SystemOrganization addCategory: #'Path-Core-Models'!
SystemOrganization addCategory: #'Path-Core-Morphic'!
SystemOrganization addCategory: #'Path-Core-Projects'!
SystemOrganization addCategory: #'Path-Core-Specs'!
SystemOrganization addCategory: #'Path-Core-Tools'!
SystemOrganization addCategory: #'Path-Core-Tracer'!

PluggableTreeMorph subclass: #SPluggableTreeMorph
	instanceVariableNames: 'highlightItemSelector indentingListItemMorphClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!SPluggableTreeMorph methodsFor: 'private' stamp: 'mp 1/20/2010 17:55'!
addSubmorphsAfter: parentMorph fromCollection: aCollection allowSorting: sortBoolean 
	"Hook for highlighting currently expanded tree nodes"
	| result |
	result := super 
		addSubmorphsAfter: parentMorph
		fromCollection: aCollection
		allowSorting: sortBoolean.
	self highlightItemSelector ifNotNil:[
		self refreshHighlightingOf: parentMorph.
		result do: [:each | self refreshHighlightingOf: each]].
	^ result! !

!SPluggableTreeMorph methodsFor: 'private' stamp: 'mp 4/14/2010 11:34'!
adjustSubmorphPositions

	super adjustSubmorphPositions.
	scroller submorphsDo: [ :each | 
		each isCodeExplorerIndentingListItemMorph 
			ifTrue: [each adjustCustomMorphs]].! !

!SPluggableTreeMorph methodsFor: 'node access' stamp: 'mp 7/7/2010 16:42:50.962'!
contentsOfNode: node
	"Overwritten for interchanging PluggableTreeItemNode"
	| children |
	self getChildrenSelector ifNil:[^#()].
	children := self model perform: self getChildrenSelector with: node item.
	^children collect:[:item | SPluggableTreeItemNode with: item model: self]! !

!SPluggableTreeMorph methodsFor: 'private' stamp: 'mp 1/29/2010 10:34'!
expandAllOfSelectedNode
	
	selectedMorph ifNil: [^ self].
	selectedMorph isExpanded ifTrue: [self toggleExpandedState: selectedMorph].
	self expandAll.! !

!SPluggableTreeMorph methodsFor: 'geometry' stamp: 'mp 3/4/2010 14:35'!
extent: aPoint

	super extent: aPoint.
	"Required for collapse systemwindow"
	aPoint y = 0
		ifTrue: [self hide]
		ifFalse: [self show].! !

!SPluggableTreeMorph methodsFor: 'node access' stamp: 'mp 1/20/2010 17:55'!
firstRootTreeEntry

	^ self scroller submorphs first! !

!SPluggableTreeMorph methodsFor: 'scrolling' stamp: 'mp 7/4/2011 15:31:16.39'!
hUnadjustedScrollRange
"Return the width of the widest item in the list"

	| max count |

	max := 0.
	count := 0.
	scroller submorphsDo: [ :each | | width right |
		width := each isCodeExplorerIndentingListItemMorph
			ifTrue: [each requiredWidth]
			ifFalse: [each font widthOfStringOrText: each contents].
		right := (each toggleRectangle right + width + 10).
		max := max max: right.
		
"NOTE: need to optimize this method by caching list item morph widths (can init that cache most efficiently in the #list: method before the item widths are reset to 9999).  For now, just punt on really long lists"
		((count := count + 1) > 200) ifTrue:[ ^max * 3].
	].

	^max! !

!SPluggableTreeMorph methodsFor: 'accessing' stamp: 'mp 1/20/2010 17:55'!
highlightItemSelector
	^ highlightItemSelector! !

!SPluggableTreeMorph methodsFor: 'accessing' stamp: 'mp 1/20/2010 17:55'!
highlightItemSelector: anObject
	highlightItemSelector := anObject! !

!SPluggableTreeMorph methodsFor: 'initialization' stamp: 'mp 4/14/2010 11:21'!
indentingItemClass
	
	^ self indentingListItemMorphClass! !

!SPluggableTreeMorph methodsFor: 'accessing' stamp: 'mp 4/14/2010 11:17'!
indentingListItemMorphClass
	"Answer the value of indentingListItemMorphClass"

	^ indentingListItemMorphClass ifNil: [indentingListItemMorphClass := IndentingListItemMorph]! !

!SPluggableTreeMorph methodsFor: 'accessing' stamp: 'mp 4/14/2010 11:17'!
indentingListItemMorphClass: anObject
	"Set the value of indentingListItemMorphClass"

	indentingListItemMorphClass := anObject! !

!SPluggableTreeMorph methodsFor: 'private' stamp: 'mp 1/20/2010 17:55'!
insertNewMorphs: morphList 
	"Hook for highlighting root nodes after init or refresh"
	self highlightItemSelector 
		ifNotNil: [morphList do: [ :each | self refreshHighlightingOf: each ]].
	super insertNewMorphs: morphList! !

!SPluggableTreeMorph methodsFor: 'refreshing' stamp: 'mp 1/20/2010 17:55'!
refresh: aBlock fromNode: aMorph
	aMorph withSiblingsDo: [:sib | 
		aBlock value: sib.
		sib firstChild ifNotNil: [self refresh: aBlock fromNode: sib firstChild]].! !

!SPluggableTreeMorph methodsFor: 'refreshing' stamp: 'mp 9/22/2010 14:01:56.496'!
refreshHighlighting
	self refresh: [:node | self refreshHighlightingOf: node] fromNode: self firstRootTreeEntry! !

!SPluggableTreeMorph methodsFor: 'refreshing' stamp: 'mp 1/20/2010 17:55'!
refreshHighlightingOf: aMorph 
	(self model perform: self highlightItemSelector	with: aMorph complexContents item) 
		ifTrue: [aMorph highlight]
		ifFalse: [aMorph unhighlight]! !

!SPluggableTreeMorph methodsFor: 'refreshing' stamp: 'mp 1/20/2010 18:36'!
refreshIconOf: aMorph
	aMorph icon: (self model 
					perform: self getIconSelector 
					with: aMorph complexContents item).
	aMorph changed.! !

!SPluggableTreeMorph methodsFor: 'refreshing' stamp: 'mp 1/20/2010 17:55'!
refreshIcons
	self refresh: [:node | self refreshIconOf: node] fromNode: self firstRootTreeEntry.! !

!SPluggableTreeMorph methodsFor: 'node access' stamp: 'mp 1/20/2010 17:55'!
rootMorphs
	"Answer the receiver's roots"
	^ self scroller submorphs
		select: [:each | each indentLevel isZero]! !

!SPluggableTreeMorph methodsFor: 'accessing' stamp: 'mp 7/7/2010 16:42:55.915'!
roots: anArray
	"Overwritten for interchanging PluggableTreeItemNode"
	roots := anArray collect:[:item| SPluggableTreeItemNode with: item model: self].
	self list: roots.! !

!SPluggableTreeMorph methodsFor: 'selection' stamp: 'mp 3/24/2011 17:26:09.673'!
setSelectedMorph: aMorph 
	| selected |
	selected := self selectedMorph.
	super setSelectedMorph: aMorph.
	(selected notNil and: [self highlightItemSelector notNil])
		ifTrue: [self refreshHighlightingOf: selected].
	(aMorph notNil and: [aMorph isCodeExplorerIndentingListItemMorph])
		ifTrue: [aMorph 
					highlightInPathMapIfPossible;
					toggleCodeView].! !

!SPluggableTreeMorph methodsFor: 'updating' stamp: 'mp 1/29/2010 10:32'!
update: what
	what ifNil:[^self].
	what == self highlightItemSelector ifTrue:[
		self refreshHighlighting.
		^self].
	what == self getIconSelector ifTrue:[
		self refreshIcons.
		^self].
	what == #expandAllOfSelectedNode ifTrue: [
		self expandAllOfSelectedNode.
		^ self].
	^super update: what! !

PluggablePanelSpec subclass: #SPathViewDiagramSpec
	instanceVariableNames: 'viewAreaMorph miniMap scrollPane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Tools'!

!SPathViewDiagramSpec commentStamp: 'omg 6/14/2011 14:31:01.408' prior: 0!
A SPathViewDiagramSpec is responsible for drawing the passed viewAreaMorph within a scroller and provide a MiniMap to go with it.!

!SPathViewDiagramSpec methodsFor: 'building' stamp: 'ag 12/4/2011 13:57:24.818'!
buildWith: aBuilder
	| widget |
	widget := super buildWith: aBuilder.
	widget
		addMorph: self scrollPane;
		addMorph: self miniMap.
	^ widget! !

!SPathViewDiagramSpec methodsFor: 'building' stamp: 'ag 12/29/2011 16:40:13.798'!
miniMap
	
	^ miniMap ifNil: [
		miniMap := SMiniMap on: viewAreaMorph in: scrollPane.
		STool setOffsetFrame: (10 asPoint corner: 0 asPoint) in: miniMap.
		viewAreaMorph minimap: miniMap.
		miniMap ]! !

!SPathViewDiagramSpec methodsFor: 'building' stamp: 'ag 12/29/2011 15:22:51.947'!
scrollPane

	^ scrollPane ifNil: [
		scrollPane := SScrollPane forMorph: viewAreaMorph.
		scrollPane borderWidth: 0.
		STool setFrame: (0.01 asPoint corner: 0.99 asPoint) in: scrollPane.
		scrollPane scrollBy: ((viewAreaMorph extent / 2) - (scrollPane scroller extent * 2)) negated.
		scrollPane ]! !

!SPathViewDiagramSpec methodsFor: 'accessing' stamp: 'omg 6/14/2011 14:30:22.321'!
viewAreaMorph: aMorph
	
	viewAreaMorph := aMorph.! !

PluggablePanelSpec subclass: #SPluggableFlapSpec
	instanceVariableNames: 'icon'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Specs'!

!SPluggableFlapSpec methodsFor: 'building' stamp: 'mp 9/13/2010 14:57:47.442'!
buildWith: builder
	^ builder buildPluggableFlap: self.! !

!SPluggableFlapSpec methodsFor: 'accessing' stamp: 'mp 9/13/2010 18:54:11.991'!
icon
	"Answer the value of icon"

	^ icon! !

!SPluggableFlapSpec methodsFor: 'accessing' stamp: 'mp 9/13/2010 18:54:11.995'!
icon: anObject
	"Set the value of icon"

	icon := anObject! !

!IndentingListItemMorph methodsFor: '*Path-Core' stamp: 'mp 4/16/2010 17:50'!
drawOn: aCanvas

	
	| tRect sRect columnScanner columnLeft |
	tRect := self toggleRectangle.

	sRect := self stringRectangle withLeft: tRect right + 4.
	self drawToggleOn: aCanvas in: tRect.
	self drawRectangleOn: aCanvas in: sRect.

	icon isNil ifFalse:[
		aCanvas
			translucentImage: icon
	
			at: sRect left @ (self top + (self height - icon height // 2)).
	

		sRect := sRect left: sRect left + icon width + 2.
	].

	(container columns isNil or: [(contents asString indexOf: Character tab) = 0]) ifTrue: [
		sRect := sRect top: sRect top + sRect bottom - self fontToUse height // 2.
		aCanvas drawString: contents asString in: sRect font: self fontToUse color: color.
	
	] ifFalse: [
		columnLeft := sRect left.
		columnScanner := ReadStream on: contents asString.
		container columns do: [ :width | | columnRect columnData |
			columnRect := columnLeft @ sRect top extent: width @ sRect height.
			columnData := columnScanner upTo: Character tab.
			columnData isEmpty ifFalse: [
				aCanvas drawString: columnData in: columnRect font: self fontToUse color: color
.
			].
			columnLeft := columnRect right + 5.
		].
	]
! !

!IndentingListItemMorph methodsFor: '*Path-Core' stamp: 'mp 4/16/2010 17:50'!
drawRectangleOn: aCanvas in: aRectangle! !

!IndentingListItemMorph methodsFor: '*Path-Core' stamp: 'mp 12/8/2009 09:33'!
icon: anIcon

	icon := anIcon.! !

!IndentingListItemMorph methodsFor: '*Path-Core' stamp: 'mp 4/14/2010 11:33'!
isCodeExplorerIndentingListItemMorph

	^ false! !

!IndentingListItemMorph methodsFor: '*Path-Core' stamp: 'mp 4/14/2010 12:11'!
stringRectangle

	^ bounds ! !

IndentingListItemMorph subclass: #SCodeExplorerIndentingListItemMorph
	instanceVariableNames: 'isCodeExpanded codePane minWidthOfMorph previousSibling'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!SCodeExplorerIndentingListItemMorph class methodsFor: 'constants' stamp: 'mp 4/24/2010 13:36'!
backgroundColorEven

	^ Color gray: 1.0! !

!SCodeExplorerIndentingListItemMorph class methodsFor: 'constants' stamp: 'mp 4/24/2010 13:35'!
backgroundColorOdd

	^ Color gray: 0.9! !

!SCodeExplorerIndentingListItemMorph class methodsFor: 'constants' stamp: 'mp 4/16/2010 18:30'!
borderColor

	^ Color gray:0.5! !

!SCodeExplorerIndentingListItemMorph class methodsFor: 'constants' stamp: 'mp 4/24/2010 14:27'!
borderOffset

	^  4! !

!SCodeExplorerIndentingListItemMorph class methodsFor: 'constants' stamp: 'mp 4/27/2010 15:48'!
borderWidth
	
	^ 1! !

!SCodeExplorerIndentingListItemMorph class methodsFor: 'constants' stamp: 'mp 4/15/2010 10:56'!
buttonSpace

	^ 3! !

!SCodeExplorerIndentingListItemMorph class methodsFor: 'constants' stamp: 'mp 4/15/2010 20:40'!
indentingPixel

	^ 12! !

!SCodeExplorerIndentingListItemMorph class methodsFor: 'constants' stamp: 'mp 4/15/2010 21:49'!
itemHeight
	
	^ 15! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'morphic' stamp: 'mp 4/27/2010 15:45'!
adjustCustomMorphs

	codePane ifNotNil: [ "direct access to prevent lazy initialization"
		self codePane position: (self class indentingPixel * (indentLevel + 1)) 
							@ (self position y)].! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'accessing' stamp: 'mp 4/15/2010 11:56'!
callNode

	^ self complexContents item! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'accessing' stamp: 'mp 4/15/2010 13:19'!
callgraphModel

	^ self callNode callgraphModel! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'accessing' stamp: 'mp 7/7/2010 16:44:34.542'!
codePane
	"Answer the value of codePane"

	^ codePane ifNil: [codePane := SCodePaneMorph on: self callNode color: self getBackgroundColor].! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'accessing' stamp: 'mp 4/14/2010 13:45'!
codePane: anObject
	"Set the value of codePane"

	codePane := anObject! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'morphic' stamp: 'mp 4/16/2010 19:39'!
computeMaxWidthOfSiblings

	| max |
	max := 0.
	self withSiblingsDo: [:each |  max := each minWidth max: max].
	self withPreviousSiblingsDo: [:each |  max := each minWidth max: max].
	^ max! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'accessing' stamp: 'mp 4/14/2010 11:55'!
container

	^ container! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'drawing' stamp: 'mp 4/27/2010 15:48'!
drawRectangleOn: aCanvas in: aRectangle
	| rect |
	rect := Rectangle 
			origin: (aRectangle origin x - self class borderOffset) @ (aRectangle origin y)
			corner: (aRectangle origin x + self visibleWidth + self class borderOffset) @ (aRectangle corner y).
	aCanvas 
		frameAndFillRectangle: rect 
		fillColor: self getBackgroundColor 
		borderWidth: 0 
		borderColor: self class borderColor.! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'drawing' stamp: 'mp 4/17/2010 16:54'!
getBackgroundColor

	| bgColor |
	bgColor := self class backgroundColorOdd.
	self indentLevel even ifTrue: [bgColor := self class backgroundColorEven].
	^ bgColor! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'actions' stamp: 'mp 3/24/2011 17:27:21.627'!
highlightInPathMapIfPossible
	SPMPathMap allInstances do: [:each |
		[(each 
			getMethodMorph: self callNode clientClass 
			and: self callNode clientSelector) highlight] on: Error do: []].! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'initialization' stamp: 'mp 4/24/2010 14:16'!
initWithContents: anObject prior: priorMorph forList: hostList indentLevel: newLevel

	super initWithContents: anObject prior: priorMorph forList: hostList indentLevel: newLevel.
	self 
		extent: self minWidth@self class itemHeight;
		isCodeExpanded: false;
		previousSibling: priorMorph.! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'accessing' stamp: 'mp 4/14/2010 11:52'!
isCodeExpanded
	"Answer the value of isCodeExpanded"

	^ isCodeExpanded! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'accessing' stamp: 'mp 4/14/2010 11:52'!
isCodeExpanded: anObject
	"Set the value of isCodeExpanded"

	isCodeExpanded := anObject! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'testing' stamp: 'mp 4/14/2010 11:33'!
isCodeExplorerIndentingListItemMorph

	^ true! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'accessing' stamp: 'mp 4/16/2010 19:17'!
minWidthOfMorph
	"Answer the value of minWidthOfMorph"

	^ minWidthOfMorph ifNil: [minWidthOfMorph := self computeMaxWidthOfSiblings]! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'accessing' stamp: 'mp 4/16/2010 19:38'!
minWidthOfMorph: anObject
	"Set the value of minWidthOfMorph"

	minWidthOfMorph := anObject! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'accessing' stamp: 'mp 4/16/2010 19:38'!
previousSibling
	"Answer the value of previousSibling"

	^ previousSibling! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'accessing' stamp: 'mp 4/16/2010 19:38'!
previousSibling: anObject
	"Set the value of previousSibling"

	previousSibling := anObject! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'scrolling' stamp: 'mp 7/4/2011 15:42:21.364'!
requiredWidth
	self isCodeExpanded ifTrue: [
		^ self codePane width + (self codePane objExpMorphsStack size *
									SObjectExplorationMorph explorationMinWidth)].
	^ self font widthOfStringOrText: self contents! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'drawing' stamp: 'mp 4/15/2010 20:50'!
stringRectangle

	self isCodeExpanded ifFalse: [^ super stringRectangle].
	^ bounds origin corner: (bounds corner x @ (bounds origin y + self class itemHeight))! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'actions' stamp: 'mp 4/27/2010 15:47'!
toggleCodeView

	self isCodeExpanded
		ifTrue: [self 
				extent: self width@self class itemHeight;
				removeMorph: self codePane]
		ifFalse: [self 
				addMorph: self codePane;
				extent: self width@(self codePane height)].
	self isCodeExpanded: self isCodeExpanded not.
	self container adjustSubmorphPositions.! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'drawing' stamp: 'mp 4/15/2010 20:51'!
toggleRectangle

	self isCodeExpanded ifFalse: [^ super toggleRectangle].
	^(bounds left + (self class indentingPixel * indentLevel)) @ bounds top 
		extent: self class indentingPixel@self class itemHeight! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'morphic' stamp: 'mp 4/24/2010 14:20'!
visibleWidth

	^ self minWidthOfMorph! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'siblings' stamp: 'mp 4/16/2010 19:39'!
withPreviousSiblingsDo: aBlock
	"Iterate also previous siblings"
	| node |
	node := self.
	[node isNil] whileFalse: [
		aBlock value: node.
		node := node previousSibling
	].! !

!MorphicToolBuilder methodsFor: '*Path-Core' stamp: 'mp 9/15/2010 14:40:10.3'!
buildPluggableCheckBox: aSpec
	| widget label state action enabled |
	label := aSpec label.
	state := aSpec state.
	action := aSpec action.
	widget := SPluggableCheckBoxMorph on: aSpec model
				getState: (state isSymbol ifTrue:[state])
				action: nil
				label: (label isSymbol ifTrue:[label]).
	self register: widget id: aSpec name.
	enabled := aSpec enabled.
	enabled isSymbol
		ifTrue:[widget getEnabledSelector: enabled]
		ifFalse:[widget enabled: enabled].
	widget action: action.
	widget getColorSelector: aSpec color.
	self buildHelpFor: widget spec: aSpec. 
	(label isSymbol or:[label == nil]) ifFalse:[widget label: label].
	self setFrame: aSpec frame in: widget.
	parent ifNotNil:[self add: widget to: parent].
	^widget! !

!MorphicToolBuilder methodsFor: '*Path-Core' stamp: 'mp 9/13/2010 19:02:48.438'!
buildPluggableFlap: aSpec
	| widget children frame |
	widget := self flapClass new.
	self register: widget id: aSpec name.
	widget model: aSpec model.
	aSpec icon ifNotNil: [widget flapIcon: aSpec icon].
	
	widget clipSubmorphs: true.
	children := aSpec children.
	children isSymbol ifTrue: [
		widget getChildrenSelector: children.
		widget update: children.
		children := #()].
	self buildAll: children in: widget.
	
	self buildHelpFor: widget spec: aSpec. 
	self setFrame: aSpec frame in: widget.
	parent ifNotNil:[self add: widget to: parent].
	self setLayout: aSpec layout in: widget.
	widget 
		layoutInset: 3;
		borderWidth: 2;
		borderColor: #raised.
	widget submorphsDo: [:sm |
		(frame := sm layoutFrame) ifNotNil:[
			(frame rightFraction = 0 or:[frame rightFraction = 1]) 
				ifFalse:[frame rightOffset: 1].
			(frame bottomFraction = 0 or: [frame bottomFraction = 1]) 
				ifFalse:[frame bottomOffset: 1]]].
	widget color: (Color r: 0.672 g: 0.672 b: 0.672).
	widget layoutFrame leftOffset: 1.
	widget switchExpandState.
	^widget! !

!MorphicToolBuilder methodsFor: '*Path-Core' stamp: 'mp 1/25/2010 11:28'!
buildPluggableTree: aSpec
	| widget |
	widget := (self pluggableTreeMorphClass: aSpec) new.
	self register: widget id: aSpec name.
	self setAdditionalTreeSpecs: aSpec on: widget.
	widget model: aSpec model.
	widget getSelectedPathSelector: aSpec getSelectedPath.
	widget setSelectedSelector: aSpec setSelected.
	widget getChildrenSelector: aSpec getChildren.
	widget hasChildrenSelector: aSpec hasChildren.
	widget getLabelSelector: aSpec label.
	widget getIconSelector: aSpec icon.
	widget getHelpSelector: aSpec help.
	widget getMenuSelector: aSpec menu.
	widget keystrokeActionSelector: aSpec keyPress.
	widget getRootsSelector: aSpec roots.
	widget autoDeselect: aSpec autoDeselect.
	widget dropItemSelector: aSpec dropItem.
	widget wantsDropSelector: aSpec dropAccept.
	
	self setFrame: aSpec frame in: widget.
	parent ifNotNil:[self add: widget to: parent].
	panes ifNotNil:[
		aSpec roots ifNotNil:[panes add: aSpec roots].
	].
	^widget! !

!MorphicToolBuilder methodsFor: '*Path-Core' stamp: 'mp 9/23/2010 17:46:34.678'!
buildSPluggableMultiSelectionList: aSpec
	| widget listClass |
	aSpec getSelected ifNotNil:[^self error:'There is no PluggableListMorphOfManyByItem'].
	listClass := SPluggableListMorphOfMany.
	widget := listClass on: aSpec model
		list: aSpec list
		primarySelection: aSpec getIndex
		changePrimarySelection: aSpec setIndex
		listSelection: aSpec getSelectionList
		changeListSelection: aSpec setSelectionList
		menu: aSpec menu.
	widget setItemColorSelector: aSpec itemColor.
	self register: widget id: aSpec name.
	widget keystrokeActionSelector: aSpec keyPress.
	widget getListElementSelector: aSpec listItem.
	widget getListSizeSelector: aSpec listSize.
	self buildHelpFor: widget spec: aSpec. 
	self setFrame: aSpec frame in: widget.
	parent ifNotNil:[self add: widget to: parent].
	panes ifNotNil:[
		aSpec list ifNotNil:[panes add: aSpec list].
	].
	parent isSystemWindow
		ifFalse: [widget 
					borderWidth: 1; 
					borderColor: #inset;
					color: Color white].
	^widget! !

!MorphicToolBuilder methodsFor: '*Path-Core' stamp: 'mp 3/24/2011 12:15:07.882'!
codePaneClass
	^ SPluggableTextMorphPlus! !

!MorphicToolBuilder methodsFor: '*Path-Core' stamp: 'mp 9/13/2010 15:05:41.639'!
flapClass

	^ SPluggableFlapMorph! !

!MorphicToolBuilder methodsFor: '*Path-Core' stamp: 'mp 7/7/2010 16:41:03.577'!
pluggableTreeMorphClass: aSpec

	(aSpec isKindOf: SPluggableTreeSpec) ifTrue: [^ SPluggableTreeMorph].
	^ PluggableTreeMorph! !

!MorphicToolBuilder methodsFor: '*Path-Core' stamp: 'mp 7/7/2010 16:41:07.354'!
setAdditionalTreeSpecs: aSpec on: aWidget

	(aSpec isKindOf: SPluggableTreeSpec) 
		ifTrue: [
			aWidget highlightItemSelector: aSpec highlightItem.
			aWidget indentingListItemMorphClass: aSpec indentingListItemMorph].! !

StringMorph subclass: #SActionStringMorph
	instanceVariableNames: 'actionModel actionSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!SActionStringMorph class methodsFor: 'instance creation' stamp: 'mp 4/15/2010 21:11'!
on: aModel selector: aSymbol

	^ self on: aModel selector: aSymbol name: aModel asString! !

!SActionStringMorph class methodsFor: 'instance creation' stamp: 'mp 1/7/2010 17:44'!
on: aModel selector: aSymbol name: aString

	^ (self contents: aString)
		actionModel: aModel;
		actionSelector: aSymbol! !

!SActionStringMorph methodsFor: 'accessing' stamp: 'mp 1/6/2010 16:25'!
actionModel
	^ actionModel! !

!SActionStringMorph methodsFor: 'accessing' stamp: 'mp 1/6/2010 16:25'!
actionModel: anObject
	actionModel := anObject! !

!SActionStringMorph methodsFor: 'accessing' stamp: 'mp 1/6/2010 16:25'!
actionSelector
	^ actionSelector! !

!SActionStringMorph methodsFor: 'accessing' stamp: 'mp 1/6/2010 16:25'!
actionSelector: anObject
	actionSelector := anObject! !

!SActionStringMorph methodsFor: 'event handling' stamp: 'mp 1/6/2010 16:22'!
handlesMouseDown: evt

	^ true! !

!SActionStringMorph methodsFor: 'event handling' stamp: 'mp 1/6/2010 14:01'!
handlesMouseOver: anEvent

	^ true! !

!SActionStringMorph methodsFor: 'event handling' stamp: 'mp 1/6/2010 14:04'!
mouseEnter: anEvent

	self emphasis: (TextEmphasis underlined) emphasisCode.! !

!SActionStringMorph methodsFor: 'event handling' stamp: 'mp 1/6/2010 14:04'!
mouseLeave: anEvent

	self emphasis: (TextEmphasis normal) emphasisCode.! !

!SActionStringMorph methodsFor: 'event handling' stamp: 'mp 3/1/2010 16:47'!
mouseUp: anEvent

	self performAction.! !

!SActionStringMorph methodsFor: 'event handling' stamp: 'mp 3/1/2010 16:47'!
performAction

	self actionModel perform: self actionSelector.! !

!PasteUpMorph methodsFor: '*Path-Core' stamp: 'mp 1/20/2010 19:01'!
modalLockTo: aSystemWindow
	"Don't lock the world!! Lock the submorphs.
	The modal window gets opened afterwards so is OK."
	
	|lockStates|
	lockStates := IdentityDictionary new.
	self submorphsDo: [:m |
		lockStates at: m put: m isLocked.
		m lock].
	self
		setProperty: #submorphLockStates
		toValue: lockStates! !

!PasteUpMorph methodsFor: '*Path-Core' stamp: 'mp 1/20/2010 19:02'!
modalUnlockFrom: aSystemWindow
	"Don't unlock the world!! Unlock the submorphs
	that were not originally locked."
	
	|lockStates|
	lockStates := self
		valueOfProperty: #submorphLockStates
		ifAbsent: [^self].
	self removeProperty: #submorphLockStates.
	lockStates keysAndValuesDo: [:m :locked |
		locked ifFalse: [m unlock]]! !

PluggableTextMorphPlus subclass: #SPluggableTextMorphPlus
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!SPluggableTextMorphPlus methodsFor: 'private' stamp: 'mp 7/7/2010 16:40:31.48'!
textMorphClass
	"Answer the class used to create the receiver's textMorph"
	
	^ STextMorphForEditView! !

!Morph methodsFor: '*Path-Core' stamp: 'mp 1/20/2010 19:00'!
modalLockTo: aSystemWindow
	"Lock the receiver as a modal owner of the given window."

	self lock! !

!Morph methodsFor: '*Path-Core' stamp: 'mp 1/20/2010 19:00'!
modalUnlockFrom: aSystemWindow
	"Unlock the receiver as a modal owner of the given window."

	self unlock! !

!Morph methodsFor: '*Path-Core' stamp: 'mp 1/20/2010 19:05'!
openModal: aSystemWindow
	"Open the given window locking the receiver until it is dismissed.
	Answer the system window.
	Restore the original keyboard focus when closed."

	|area mySysWin keyboardFocus|
	keyboardFocus := self activeHand keyboardFocus.
	mySysWin := self isSystemWindow ifTrue: [self] ifFalse: [self ownerThatIsA: SystemWindow].
	mySysWin ifNil: [mySysWin := self].
	mySysWin modalLockTo: aSystemWindow.
	area := RealEstateAgent maximumUsableArea.
	self class environment at: #Flaps ifPresent: [:cl |
		RealEstateAgent reduceByFlaps: area].
	aSystemWindow extent: aSystemWindow initialExtent.
	aSystemWindow position = (0@0)
		ifTrue: [aSystemWindow
				position: self activeHand position - (aSystemWindow extent // 2)].
	aSystemWindow
		bounds: (aSystemWindow bounds translatedToBeWithin: area).
	[ToolBuilder default runModal: aSystemWindow openAsIs]
		ensure: [mySysWin modalUnlockFrom: aSystemWindow.
				self activeHand newKeyboardFocus: keyboardFocus].
	^aSystemWindow! !

!Morph methodsFor: '*Path-Core' stamp: 'mp 1/25/2010 13:05'!
visible: aBoolean 
	"set the 'visible' attribute of the receiver to aBoolean"
	(extension isNil and:[aBoolean]) ifTrue: [^ self].
	self visible == aBoolean ifTrue: [^ self].
	self assureExtension visible: aBoolean.
	self changed.
	owner ifNotNil: [owner layoutChanged]. "Changed for 3.9 compatibility and forward events again after hiding"! !

!ToolBuilder methodsFor: '*Path-Core' stamp: 'mp 9/13/2010 14:44:42.133'!
pluggableFlapSpec
	^SPluggableFlapSpec! !

!Bitmap methodsFor: '*Path-Core' stamp: 'mp 7/9/2010 11:11:20.572'!
uncompressedBits
	| stream |
	stream := WriteStream on: OrderedCollection new.
	self writeUncompressedOn: stream.
	^ stream contents! !

!TestCase class methodsFor: '*Path-Core' stamp: 'mp 3/24/2011 10:54:24.775'!
inheritedTestSelectors
	^ self shouldInheritSelectors
		ifTrue: [self allTestSelectors]
		ifFalse: [self testSelectors ]! !

!ObjectExplorer methodsFor: '*Path-Core' stamp: 'mp 7/7/2010 16:39:58.474'!
explorerListMorphFor: anObject
	|  listMorph |
	rootObject := anObject.
	listMorph := SPluggableTreeMorph 
			on: self
			list: #getList
			selected: #getCurrentSelection
			changeSelected: #noteNewSelection:
			menu: #genericMenu:
			keystroke: #explorerKey:from:.
	listMorph setSelectedSelector: #noteNewSelection:.
	listMorph
		autoDeselect: false;
		color: Color white;
		alwaysShowScrollBars: false.
	^ listMorph! !

PluggablePanelMorph subclass: #SPluggableFlapMorph
	instanceVariableNames: 'flapIcon expandedFlap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!SPluggableFlapMorph class methodsFor: 'constants' stamp: 'mp 9/14/2010 10:01:52.044'!
iconOffset
	^ 34! !

!SPluggableFlapMorph methodsFor: 'switching' stamp: 'mp 9/15/2010 13:23:31.387'!
closeAllOtherFlaps
	self owner ifNil: [^ self].
	self flag: #mpe. "Refactor the owner relationship to a more stable version, later on"
	"Add some kind of select flap selector..."
	self owner paneMorphs 
		select: [:each | (each isKindOf: self class) and: [(each == self) not]]
		thenDo: [:each | each closeFlap].! !

!SPluggableFlapMorph methodsFor: 'switching' stamp: 'mp 9/15/2010 09:59:34.425'!
closeFlap
	self expandedFlap: false.
	self submorphs do: [:each | each hide].
	self changed.! !

!SPluggableFlapMorph methodsFor: 'drawing' stamp: 'mp 9/13/2010 18:58:07.688'!
drawExpandedFlapOn: aCanvas
	"Icon Background"
	aCanvas 
		fillRectangle: self iconRectangle	
		fillStyle: self fillStyle 
		borderStyle: self borderStyle.	
	"Draw Icon"
	aCanvas image: self flapIcon at: self iconRectangle origin + 2.
	"Main Background"
	aCanvas 
		fillRectangle: (self bounds insetOriginBy: 0@0 cornerBy: self class iconOffset@0)  		
		fillStyle: self fillStyle 
		borderStyle: self borderStyle.
	"Left Border to System Window"
	aCanvas 
		fillRectangle: (self bounds origin 
						corner: ((self bounds origin x + 2)@(self bounds corner y))) 
		color: self color.! !

!SPluggableFlapMorph methodsFor: 'drawing' stamp: 'mp 9/13/2010 18:58:10.619'!
drawNotExpandedFlapOn: aCanvas
	"Icon Background"
	aCanvas 
		fillRectangle: self fullBounds	
		fillStyle: self fillStyle 
		borderStyle: self borderStyle.
	aCanvas image: self flapIcon at: self fullBounds origin + 2.! !

!SPluggableFlapMorph methodsFor: 'drawing' stamp: 'mp 9/15/2010 09:52:56.7'!
drawOn: aCanvas
	self isExpanded
		ifTrue: [self drawExpandedFlapOn: aCanvas]
		ifFalse: [self drawNotExpandedFlapOn: aCanvas].! !

!SPluggableFlapMorph methodsFor: 'accessing' stamp: 'mp 9/13/2010 18:17:44.835'!
expandedFlap
	"Answer the value of expandedFlap"

	^ expandedFlap ifNil: [expandedFlap := false]! !

!SPluggableFlapMorph methodsFor: 'accessing' stamp: 'mp 9/13/2010 18:11:44.341'!
expandedFlap: anObject
	"Set the value of expandedFlap"

	expandedFlap := anObject! !

!SPluggableFlapMorph methodsFor: 'accessing' stamp: 'mp 9/13/2010 18:57:33.686'!
flapIcon
	"Answer the value of flapIcon"

	^ flapIcon! !

!SPluggableFlapMorph methodsFor: 'accessing' stamp: 'mp 9/13/2010 18:57:33.691'!
flapIcon: anObject
	"Set the value of flapIcon"

	flapIcon := anObject! !

!SPluggableFlapMorph methodsFor: 'layout' stamp: 'mp 9/15/2010 09:53:37.669'!
fullBounds
	| b |
	self isExpanded
		ifTrue: [^ super fullBounds]
		ifFalse: [b := super fullBounds.
				^ b origin corner: (b origin x + self class iconOffset) @ 
						     		   (b origin y + self class iconOffset)]! !

!SPluggableFlapMorph methodsFor: 'event handling' stamp: 'mp 9/15/2010 09:53:52.809'!
handlesMouseDown: evt
	self isExpanded
		ifTrue: [^ self iconRectangle containsPoint: evt cursorPoint]
		ifFalse: [^ self fullBounds containsPoint: evt cursorPoint]! !

!SPluggableFlapMorph methodsFor: 'accessing' stamp: 'mp 9/13/2010 18:05:09.219'!
iconRectangle
	^ (self bounds corner x - self class iconOffset)@(self bounds origin y)
			corner: ((self bounds corner x)@(self bounds origin y + self class iconOffset))! !

!SPluggableFlapMorph methodsFor: 'initialization' stamp: 'mp 9/13/2010 18:16:47.754'!
initialize
	super initialize.
	self switchExpandState.
! !

!SPluggableFlapMorph methodsFor: 'testing' stamp: 'mp 9/15/2010 09:52:09.29'!
isExpanded

	^ expandedFlap = true! !

!SPluggableFlapMorph methodsFor: 'testing' stamp: 'mp 9/15/2010 09:52:13.226'!
isNotExpanded

	^ expandedFlap = false! !

!SPluggableFlapMorph methodsFor: 'layout' stamp: 'mp 9/13/2010 19:03:35.28'!
layoutBounds
	^ super layoutBounds insetOriginBy: 0@0 cornerBy: self class iconOffset@0! !

!SPluggableFlapMorph methodsFor: 'event handling' stamp: 'mp 9/13/2010 18:16:14.717'!
mouseDown: evt
	self switchExpandState.
! !

!SPluggableFlapMorph methodsFor: 'switching' stamp: 'mp 9/16/2010 11:08:45.688'!
switchExpandState
	self expandedFlap: self expandedFlap not.
	self isExpanded
		ifTrue: [self submorphs do: [:each | each show].
				self closeAllOtherFlaps]
		ifFalse: [self submorphs do: [:each | each hide]].
	self changed.
! !

!ContextPart methodsFor: '*Path-Core' stamp: 'eem 7/18/2010 19:25'!
cogTryNamedPrimitiveIn: aCompiledMethod for: aReceiver withArgs: arguments
	| selector theMethod spec receiverClass |
	<primitive: 218 error: ec>
	ec ifNotNil:
		["If ec is an integer other than -1 there was a problem with primitive 218,
		  not with the external primitive itself.  -1 indicates a generic failure (where
		  ec should be nil) but ec = nil means primitive 218 is not implemented.  So
		  interpret -1 to mean the external primitive failed with a nil error code."
		 ec isInteger ifTrue:
			[ec = -1
				ifTrue: [ec := nil]
				ifFalse: [self primitiveFailed]].
		^{PrimitiveFailToken. ec}].
	"Assume a nil error code implies the primitive is not implemented and fall back on the old code."
	"Hack. Attempt to execute the named primitive from the given compiled method"
	arguments size > 8 ifTrue:
		[^{PrimitiveFailToken. nil}].
	selector := #(
		tryNamedPrimitive 
		tryNamedPrimitive: 
		tryNamedPrimitive:with: 
		tryNamedPrimitive:with:with: 
		tryNamedPrimitive:with:with:with:
		tryNamedPrimitive:with:with:with:with:
		tryNamedPrimitive:with:with:with:with:with:
		tryNamedPrimitive:with:with:with:with:with:with:
		tryNamedPrimitive:with:with:with:with:with:with:with:) at: arguments size+1.
	receiverClass := self objectClass: aReceiver.
	theMethod := receiverClass lookupSelector: selector.
	theMethod == nil ifTrue:
		[^{PrimitiveFailToken. nil}].
	spec := theMethod literalAt: 1.
	spec replaceFrom: 1 to: spec size with: (aCompiledMethod literalAt: 1) startingAt: 1.
	Smalltalk unbindExternalPrimitives.
	^self object: aReceiver perform: selector withArguments: arguments inClass: receiverClass! !

!ContextPart methodsFor: '*Path-Core' stamp: 'mp 11/5/2010 13:52:09.08'!
runSimulatedMethodOnly: aBlock contextAtEachStep: block2
	| current |
	aBlock hasMethodReturn
		ifTrue: [self error: 'simulation of blocks with ^ can run loose'].
	current := aBlock asContext.
	current pushArgs: Array new from: self.
	[current == self]
		whileFalse:
			[(current sender receiver class inheritsFrom: MwMethodWrapper)
					ifTrue: [current := current step] "Ignore byte codes of method wrappers"
					ifFalse: [block2 value: current.
						 	current := current quickStep]].
	^self pop! !

!ContextPart methodsFor: '*Path-Core' stamp: 'eem 5/23/2010 14:13'!
tryNamedPrimitiveIn: aCompiledMethod for: aReceiver withArgs: arguments
	"Hack. Attempt to execute the named primitive from the given compiled method"
	| selector theMethod spec |
	arguments size > 8 ifTrue:[^PrimitiveFailToken].
	selector := #(
		tryNamedPrimitive 
		tryNamedPrimitive: 
		tryNamedPrimitive:with: 
		tryNamedPrimitive:with:with: 
		tryNamedPrimitive:with:with:with:
		tryNamedPrimitive:with:with:with:with:
		tryNamedPrimitive:with:with:with:with:with:
		tryNamedPrimitive:with:with:with:with:with:with:
		tryNamedPrimitive:with:with:with:with:with:with:with:) at: arguments size+1.
	theMethod := aReceiver class lookupSelector: selector.
	theMethod == nil ifTrue:[^PrimitiveFailToken].
	spec := theMethod literalAt: 1.
	spec replaceFrom: 1 to: spec size with: (aCompiledMethod literalAt: 1) startingAt: 1.
	theMethod flushCache.
	selector flushCache.
	^aReceiver perform: selector withArguments: arguments! !

PluggableTreeItemNode subclass: #SPluggableTreeItemNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!SPluggableTreeItemNode methodsFor: 'accessing' stamp: 'mp 1/25/2010 16:23'!
highlightingColor

	^ Color r: 110 / 256.0 g: 127 / 256.0 b: 223 / 256.0! !

!CompiledMethod methodsFor: '*Path-Core' stamp: 'mp 9/23/2011 18:40:22.074'!
asMethodReference
	^ self methodReference! !

!CompiledMethod methodsFor: '*Path-Core' stamp: 'mp 9/12/2011 14:10:38.965'!
authorFirstChange
	<description: 'Method creator'>
	| firstChange |
	firstChange := self firstChange.
	firstChange ifNil: [^ 'Unknown'].
	^ firstChange first! !

!CompiledMethod methodsFor: '*Path-Core' stamp: 'mp 9/12/2011 14:10:27.443'!
authorLastChange
	<description: 'Last change'>
	| lastChange |
	lastChange := self lastChange.
	lastChange ifNil: [^ 'Unknown'].
	^ lastChange first! !

!CompiledMethod methodsFor: '*Path-Core' stamp: 'mp 9/12/2011 14:10:21.364'!
authorMostChanges
	<description: 'Most changes'>
	| authorBag |
	authorBag := Bag new.
	self changes do: [:each | authorBag add: each first].
	^ authorBag sortedCounts first value! !

!CompiledMethod methodsFor: '*Path-Core' stamp: 'mp 9/12/2011 14:10:46.236'!
authorRecentChanges
	<description: 'Frequency and recency of changes'>
	| uniqueChangesPerDay creatorOfMethod highscore bonusForCreator authors |
	self flag: #mpe. "ToDo: Needs refactoring"
	self changes size = 1
		ifTrue: [^ self authorFirstChange].
	uniqueChangesPerDay := (self changes 
						collect: [:each | {each first. each second asDate}]) asSet.
	uniqueChangesPerDay := uniqueChangesPerDay 
								asSortedCollection: [:a :b | a second > b second].
	creatorOfMethod := uniqueChangesPerDay last.
	highscore := uniqueChangesPerDay collect: [:each | 
							{each first. (each second - creatorOfMethod second) days}].
	bonusForCreator := (highscore at: highscore size - 1) second - 1. 
	highscore at: highscore size put: {highscore last first. bonusForCreator}.
	authors := (highscore collect: [:each | each first]) asSet.
	highscore := (authors collect: [:author | 
					{author. 
					(highscore 
						select: [:each | each first = author] 
						thenCollect: [:each | each second]) sum}]).
	highscore := highscore asSortedCollection: [:a :b | a second > b second].
	^ highscore first first! !

!CompiledMethod methodsFor: '*Path-Core' stamp: 'mp 9/29/2010 10:29:36.204'!
changes
	| versions subStrings |
	versions := self versions.
	versions ifNil: [^ nil].
	^ versions changeList collect: [:each | 
		each stamp
			ifEmpty: [{'Unknown'. TimeStamp now}]
			ifNotEmpty: [subStrings := (each stamp subStrings: String space).
		{subStrings first. ((subStrings second, ' ', subStrings third) asTimeStamp)}]]! !

!CompiledMethod methodsFor: '*Path-Core' stamp: 'mp 9/19/2010 16:46:54.024'!
complexity
	| type complexity |
	complexity := self startpcsToBlockExtents keys size.
	self initialPC to: self endPC 
		do: [:each | 
			type := (self at: each) // 16.
			(type = 10 or: [type = 9])
				ifTrue: [complexity := complexity + 1]].
	^ complexity! !

!CompiledMethod methodsFor: '*Path-Core' stamp: 'mp 9/23/2011 18:40:39.133'!
coveringTests
	^ SProject current coveredTestsFor: self asMethodReference! !

!CompiledMethod methodsFor: '*Path-Core' stamp: 'mp 1/25/2011 15:42:44.597'!
embeddedBlockMethods

	| bms extractor scanner |
	bms := OrderedCollection new.
	scanner := self scanner.
	extractor := ClosureExtractor withAction: [ :c | bms add: c ] andScanner: scanner.
	[ scanner pc <= self endPC ] whileTrue: [ scanner interpretNextInstructionFor: extractor ].
	^ bms! !

!CompiledMethod methodsFor: '*Path-Core' stamp: 'mp 9/9/2011 14:25:37.763'!
firstChange
	self changes ifNil: [^ nil].
	^ self changes last! !

!CompiledMethod methodsFor: '*Path-Core' stamp: 'mp 9/20/2010 09:49:28.184'!
lastChange
	self changes ifNil: [^ nil].
	^ self changes first! !

!CompiledMethod methodsFor: '*Path-Core' stamp: 'tfel 1/27/2012 09:19:56.752'!
methodNode
	"Return the parse tree that represents self"
	| source |
	"Fix for debugging OMeta"
	(self methodClass inheritsFrom: (Smalltalk at: #OMeta2 ifAbsent: []))
		ifTrue: [^ self decompile].
	SBreakpointManager installedNodes at: self ifPresent: [:node | ^ node].
	^ (source := self getSourceFromFile)
			ifNil: [self decompile]
			ifNotNil: [self parserClass new
								parse: source
								class: (self methodClass ifNil: [self sourceClass])]
! !

!CompiledMethod methodsFor: '*Path-Core' stamp: 'mp 9/20/2010 10:45:07.292'!
numberOfVariableAccess
	| access type offset skipNextByte |
	access := 0.
	skipNextByte := false.
	(self isQuick and: [self isReturnSpecial not]) ifTrue: [^ 1].
	self initialPC to: self endPC 
		do: [:each | 
			skipNextByte 
				ifTrue: [skipNextByte := false]
				ifFalse: [
			type := (self at: each) // 16.
			type = 0
				ifTrue: ["Read instance variable"
						access := access + 1].
			type = 1
				ifTrue: ["Read temporary variable"
						access := access + 1].	
			(type = 4 or: [type = 5])
				ifTrue: ["Read literal variable (class variable)"
						access := access + 1].	
			type = 6
				ifTrue: ["Pop receiver or temporary variable"
						access := access + 1].									
			type = 8
				ifTrue: ["Extended read/write for receiver, temporary and class variables"
						offset := (self at: each) \\ 16. 
						offset = 0
							ifTrue: ["read variables"
								access := access + 1].
						offset = 2
							ifTrue: ["write variables"
								access := access + 1].							
						].
			(type = 8 or: [type = 10])
				ifTrue: [skipNextByte := true]]].
	^ access! !

!CompiledMethod methodsFor: '*Path-Core' stamp: 'mp 9/9/2011 14:43:06.761'!
setOfAuthors
	self changes ifNil: [^ nil].
	^ (self changes collect: [:each | each first]) asSet asSortedCollection! !

!CompiledMethod methodsFor: '*Path-Core' stamp: 'mp 9/19/2010 16:11:23.367'!
versions
	^ VersionsBrowser new
			scanVersionsOf: self 
			class: self methodClass 
			meta: self methodClass isMeta
			category: nil 
			selector: self selector.! !

RectangleMorph subclass: #SActionButtonMorph
	instanceVariableNames: 'actionModel actionSelector actionArgs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

SActionButtonMorph subclass: #SActionButtonIconMorph
	instanceVariableNames: 'iconForm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!SActionButtonIconMorph class methodsFor: 'instance creation' stamp: 'mp 5/2/2010 19:39'!
on: aModel selector: aSymbol args: aCollection icon: anIconForm

	^ (self on: aModel selector: aSymbol args: aCollection)
		iconForm: anIconForm;
		extentToIcon;
		yourself! !

!SActionButtonIconMorph class methodsFor: 'instance creation' stamp: 'mp 4/15/2010 21:38'!
on: aModel selector: aSymbol icon: anIconForm

	^ (self on: aModel selector: aSymbol)
		iconForm: anIconForm;
		extentToIcon;
		yourself! !

!SActionButtonIconMorph methodsFor: 'drawing' stamp: 'mp 4/15/2010 21:36'!
drawOn: aCanvas
	super drawOn: aCanvas.
	aCanvas translucentImage: self iconForm at: bounds origin.! !

!SActionButtonIconMorph methodsFor: 'geometry' stamp: 'mp 4/15/2010 21:37'!
extentToIcon

	self extent: self iconForm extent.! !

!SActionButtonIconMorph methodsFor: 'accessing' stamp: 'mp 4/15/2010 21:17'!
iconForm
	"Answer the value of iconForm"

	^ iconForm! !

!SActionButtonIconMorph methodsFor: 'accessing' stamp: 'mp 4/15/2010 21:17'!
iconForm: anObject
	"Set the value of iconForm"

	iconForm := anObject! !

SActionButtonMorph subclass: #SActionButtonLabelMorph
	instanceVariableNames: 'labelMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!SActionButtonLabelMorph class methodsFor: 'constants' stamp: 'mp 4/15/2010 21:05'!
defaultExtensionFactor

	^ 1.5! !

!SActionButtonLabelMorph class methodsFor: 'instance creation' stamp: 'mp 4/18/2010 20:27'!
on: aModel selector: aSymbol args: aCollection name: aString

	^ (self on: aModel selector: aSymbol args: aCollection)
		createLabelMorph: aString! !

!SActionButtonLabelMorph class methodsFor: 'instance creation' stamp: 'mp 4/15/2010 21:07'!
on: aModel selector: aSymbol name: aString

	^ (self on: aModel selector: aSymbol)
		createLabelMorph: aString! !

!SActionButtonLabelMorph methodsFor: 'building' stamp: 'mp 4/20/2010 17:10'!
createLabelMorph: aString

	self labelMorph: (StringMorph contents: aString).
	self addMorph: self labelMorph.
	self extent: (self labelMorph fullBounds corner * self class defaultExtensionFactor).! !

!SActionButtonLabelMorph methodsFor: 'geometry' stamp: 'mp 4/24/2010 15:56'!
extent: aPoint

	| borderOffset |
	super extent: aPoint.
	self labelMorph position: self position.
	self labelMorph width < self width
		ifTrue: [self labelMorph position: 
				(self labelMorph position x + (self width / 2) - (self labelMorph width / 2)) @ 
					(self labelMorph position y + (self height / 2) - (self labelMorph height / 2))]
		ifFalse: [
			borderOffset := 5.
			self labelMorph position: 
				(self position x + borderOffset - 2) @ 
					(self labelMorph position y + (self height / 2) - (self labelMorph height / 2)).
			self labelMorph extent: (self width - borderOffset)@ self height.
			].! !

!SActionButtonLabelMorph methodsFor: 'accessing' stamp: 'mp 4/15/2010 21:05'!
labelMorph
	"Answer the value of labelMorph"

	^ labelMorph! !

!SActionButtonLabelMorph methodsFor: 'accessing' stamp: 'mp 4/15/2010 21:05'!
labelMorph: anObject
	"Set the value of labelMorph"

	labelMorph := anObject! !

SActionButtonLabelMorph subclass: #SDropDownActionButtonMorph
	instanceVariableNames: 'dropDownMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!SDropDownActionButtonMorph methodsFor: 'accessing' stamp: 'mp 1/15/2010 18:35'!
dropDownMorph
	^ dropDownMorph! !

!SDropDownActionButtonMorph methodsFor: 'accessing' stamp: 'mp 1/15/2010 18:35'!
dropDownMorph: anObject
	dropDownMorph := anObject! !

!SDropDownActionButtonMorph methodsFor: 'event handling' stamp: 'mp 1/15/2010 18:47'!
mouseUp: anEvent
	super mouseUp: anEvent.
	self dropDownMorph newSelectedEntry: self labelMorph contents.! !

SActionButtonLabelMorph subclass: #SDropDownMorph
	instanceVariableNames: 'menuEntries selectedEntry menuMorph entriesChangedSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!SDropDownMorph class methodsFor: 'constants' stamp: 'mp 1/15/2010 17:51'!
defaultHeight

	^ 25! !

!SDropDownMorph class methodsFor: 'instance creation' stamp: 'mp 2/3/2012 12:32:12.487'!
getLabelFrom: aCollection
	^ aCollection
		ifEmpty: ['No Menu Entry']
		ifNotEmpty: [aCollection first isCollection
						ifTrue: [aCollection first first]
						ifFalse: [aCollection first key]]! !

!SDropDownMorph class methodsFor: 'instance creation' stamp: 'mp 2/3/2012 12:32:26.616'!
on: aModel with: aCollection
	^ self new
		actionModel: aModel;
		menuEntries: aCollection;
		createLabelMorph: (self getLabelFrom: aCollection);
		createMenu;
		yourself! !

!SDropDownMorph methodsFor: 'building' stamp: 'mp 2/3/2012 12:37:00.403'!
createLabelMorph: aString

	super createLabelMorph: aString.
	self extentMorphToLargestString: aString.! !

!SDropDownMorph methodsFor: 'building' stamp: 'mp 9/22/2010 11:00:37.443'!
createMenu
	| entryMorphs |
	entryMorphs := self createMenuEntries.
	self menuMorph: (AlignmentMorph inAColumn: entryMorphs).
	self addMorph: self menuMorph.
	self menuMorph 
		borderWidth: 0;
		position: (self position x - 1) @ (self position y + self height - 1);
		hide.! !

!SDropDownMorph methodsFor: 'building' stamp: 'mp 9/9/2011 10:44:57.345'!
createMenuEntries
	self menuEntries ifEmpty: [^ #()].
	self menuEntries first isCollection
		ifTrue: [	"Collection with args for action selector"
			^ self menuEntries collect: [:each | 
								(SDropDownActionButtonMorph 
									on: self actionModel 
									selector: each second 
									args: each third 
									name: each first) 
										extent: self extent;
										dropDownMorph: self]]
		ifFalse: ["Associations"
			^ self menuEntries collect: [:each | 
				(SDropDownActionButtonMorph 
					on: self actionModel selector: each value name: each key) 
					extent: self extent;
					dropDownMorph: self]].! !

!SDropDownMorph methodsFor: 'accessing' stamp: 'mp 2/3/2012 12:13:35.843'!
entriesChangedSelector
	"Answer the value of entriesChangedSelector"

	^ entriesChangedSelector! !

!SDropDownMorph methodsFor: 'accessing' stamp: 'mp 2/3/2012 12:13:35.859'!
entriesChangedSelector: anObject
	"Set the value of entriesChangedSelector"

	entriesChangedSelector := anObject! !

!SDropDownMorph methodsFor: 'geometry' stamp: 'mp 9/16/2010 13:38:22.437'!
extent: aPoint

	| oldHeight |
	oldHeight := self height.
	super extent: aPoint.
	"Required for collapse systemwindow"
	self flag: #mpe. "Creates a bug in PathMap Flap - Morph cannot be hided."
"	aPoint y = 0
		ifTrue: [self hide]
		ifFalse: [self show]."
	self menuMorph ifNotNil: [
	self menuMorph 
		position: (self menuMorph position x) @ 
					 (self menuMorph position y + self height - oldHeight).
	self menuMorph submorphs do: [:each | each extent: self extent]]! !

!SDropDownMorph methodsFor: 'building' stamp: 'mp 2/3/2012 12:37:31.053'!
extentMorphToLargestString: aString
	| largestString |
	largestString := aString.
	self menuEntries ifNotEmpty: [
		self menuEntries first isCollection
			ifTrue: [self menuEntries do: [:each | 
					(each first size > largestString size) 
						ifTrue: [largestString := each first]]]
			ifFalse: [self menuEntries do: [:each | 
					(each key size > largestString size) 
						ifTrue: [largestString := each key]]]].
	self extent: largestString asStringMorph fullBounds corner * 
					self class defaultExtensionFactor.! !

!SDropDownMorph methodsFor: 'accessing' stamp: 'mp 1/15/2010 17:43'!
menuEntries
	^ menuEntries! !

!SDropDownMorph methodsFor: 'accessing' stamp: 'mp 1/15/2010 17:43'!
menuEntries: anObject
	menuEntries := anObject! !

!SDropDownMorph methodsFor: 'accessing' stamp: 'mp 1/15/2010 18:08'!
menuMorph
	^ menuMorph! !

!SDropDownMorph methodsFor: 'accessing' stamp: 'mp 1/15/2010 18:08'!
menuMorph: anObject
	menuMorph := anObject! !

!SDropDownMorph methodsFor: 'event handling' stamp: 'mp 1/15/2010 18:34'!
mouseUp: anEvent

	self switchVisibilityOfMenu.! !

!SDropDownMorph methodsFor: 'private' stamp: 'mp 1/15/2010 18:39'!
newSelectedEntry: aString

	self switchVisibilityOfMenu.
	self selectedEntry: aString.
	self labelMorph contents: aString.
	self extent: self extent.! !

!SDropDownMorph methodsFor: 'updating' stamp: 'mp 2/3/2012 12:38:24.463'!
refreshMenuEntries: aCollection

	self menuEntries: aCollection.
	self extentMorphToLargestString: (self class getLabelFrom: aCollection).
	self createMenu.! !

!SDropDownMorph methodsFor: 'accessing' stamp: 'mp 1/15/2010 17:45'!
selectedEntry
	^ selectedEntry! !

!SDropDownMorph methodsFor: 'accessing' stamp: 'mp 1/15/2010 17:45'!
selectedEntry: anObject
	selectedEntry := anObject! !

!SDropDownMorph methodsFor: 'private' stamp: 'mp 1/25/2010 13:04'!
switchVisibilityOfMenu

	self menuMorph visible: self menuMorph visible not.! !

!SDropDownMorph methodsFor: 'updating' stamp: 'mp 2/3/2012 12:18:09.321'!
update: what
	what == self entriesChangedSelector
		ifTrue: [	self refreshMenuEntries: (self actionModel 
											perform: self entriesChangedSelector)]! !

!SActionButtonMorph class methodsFor: 'constants' stamp: 'mp 1/15/2010 17:32'!
defaultColor

	^ Color white! !

!SActionButtonMorph class methodsFor: 'constants' stamp: 'mp 4/15/2010 20:59'!
highlightBrightness

	^ 0.16! !

!SActionButtonMorph class methodsFor: 'instance creation' stamp: 'mp 4/18/2010 20:25'!
on: aModel selector: aSymbol

	^ self on: aModel selector: aSymbol args: #()! !

!SActionButtonMorph class methodsFor: 'instance creation' stamp: 'mp 4/18/2010 20:25'!
on: aModel selector: aSymbol args: aCollection

	^ self new 
		actionModel: aModel;
		actionSelector: aSymbol;
		actionArgs: aCollection;
		yourself! !

!SActionButtonMorph methodsFor: 'accessing' stamp: 'mp 4/18/2010 20:24'!
actionArgs
	"Answer the value of actionArgs"

	^ actionArgs! !

!SActionButtonMorph methodsFor: 'accessing' stamp: 'mp 4/18/2010 20:24'!
actionArgs: anObject
	"Set the value of actionArgs"

	actionArgs := anObject! !

!SActionButtonMorph methodsFor: 'accessing' stamp: 'mp 1/15/2010 16:40'!
actionModel
	^ actionModel! !

!SActionButtonMorph methodsFor: 'accessing' stamp: 'mp 1/15/2010 16:40'!
actionModel: anObject
	actionModel := anObject! !

!SActionButtonMorph methodsFor: 'accessing' stamp: 'mp 1/15/2010 16:40'!
actionSelector
	^ actionSelector! !

!SActionButtonMorph methodsFor: 'accessing' stamp: 'mp 1/15/2010 16:40'!
actionSelector: anObject
	actionSelector := anObject! !

!SActionButtonMorph methodsFor: 'initialization' stamp: 'mp 9/15/2010 17:44:30.911'!
defaultBorderColor

	^ Color gray: 0.5! !

!SActionButtonMorph methodsFor: 'initialization' stamp: 'mp 2/25/2010 16:32'!
defaultBorderWidth

	^ 1! !

!SActionButtonMorph methodsFor: 'event handling' stamp: 'mp 1/25/2010 11:45'!
handlesMouseDown: evt

	^ true! !

!SActionButtonMorph methodsFor: 'event handling' stamp: 'mp 1/15/2010 17:29'!
handlesMouseOver: anEvent

	^ true! !

!SActionButtonMorph methodsFor: 'initialization' stamp: 'mp 1/15/2010 17:35'!
initialize
	super initialize.
	self color: self class defaultColor.! !

!SActionButtonMorph methodsFor: 'event handling' stamp: 'mp 4/15/2010 21:00'!
mouseEnter: anEvent

	self color: (self color adjustBrightness: self class highlightBrightness negated).! !

!SActionButtonMorph methodsFor: 'event handling' stamp: 'mp 4/15/2010 21:00'!
mouseLeave: anEvent

	self color: (self color adjustBrightness: self class highlightBrightness).! !

!SActionButtonMorph methodsFor: 'event handling' stamp: 'mp 4/18/2010 20:26'!
mouseUp: anEvent
	
	self actionModel perform: self actionSelector withArguments: self actionArgs.! !

RectangleMorph subclass: #SCheckBoxMorph
	instanceVariableNames: 'checked'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!SCheckBoxMorph methodsFor: 'accessing' stamp: 'mp 9/15/2010 15:02:39.767'!
checked
	"Answer the value of checked"

	^ checked ifNil: [checked := false]! !

!SCheckBoxMorph methodsFor: 'accessing' stamp: 'mp 9/15/2010 15:15:57.526'!
checked: anObject
	"Set the value of checked"
	checked := anObject.
	self changed.! !

!SCheckBoxMorph methodsFor: 'accessing' stamp: 'mp 6/1/2011 12:52:13.554'!
drawOn: aCanvas
	aCanvas 
		frameRectangle: self bounds 
		color: Color black.
	self checked
		ifTrue: [aCanvas 
					fillRectangle: (self bounds expandBy: -2)
					color: Color black].
		! !

RectangleMorph subclass: #SCodePaneMorph
	instanceVariableNames: 'callNode definition objectExplorationMorphs objExpMorphsStack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

SCodePaneMorph class
	instanceVariableNames: 'loupeIcon documentIcon bugIcon treeIcon beforeIcon afterIcon pathfinderIcon closeIcon replayIcon infoIcon spiderIcon leftRightIcon worldIconLarge qualityIconLarge traceabilityIconLarge ladybugIconLarge stopwatchIconLarge'!

SCodePaneMorph class
	instanceVariableNames: 'loupeIcon documentIcon bugIcon treeIcon beforeIcon afterIcon pathfinderIcon closeIcon replayIcon infoIcon spiderIcon leftRightIcon worldIconLarge qualityIconLarge traceabilityIconLarge ladybugIconLarge stopwatchIconLarge'!

!SCodePaneMorph class methodsFor: 'constants' stamp: 'mp 4/24/2010 14:42'!
borderOffset

	^ 2! !

!SCodePaneMorph class methodsFor: 'constants' stamp: 'mp 4/18/2010 20:37'!
buttonWidth

	^ 15! !

!SCodePaneMorph class methodsFor: 'constants' stamp: 'mp 4/27/2010 17:16'!
codePaneHeight

	^ 125! !

!SCodePaneMorph class methodsFor: 'constants' stamp: 'mp 11/8/2010 16:44:47.619'!
codePaneWidth

	^ 480 - 3! !

!SCodePaneMorph class methodsFor: 'constants' stamp: 'mp 11/8/2010 16:43:42.541'!
definitionHeight

	^ self codePaneHeight - (2 * self borderOffset)! !

!SCodePaneMorph class methodsFor: 'constants' stamp: 'mp 11/8/2010 16:44:12.408'!
definitionWidth

	^ 400 - self labelHeight! !

!SCodePaneMorph class methodsFor: 'constants' stamp: 'mp 4/27/2010 16:32'!
labelHeight

	^ 15! !

!SCodePaneMorph class methodsFor: 'instance creation' stamp: 'mp 3/29/2012 16:56:14.577'!
on: aCallNode color: aColor

	^ self new
		callNode: aCallNode;
		color: aColor;
		createDefinitionMorph;
		createLabelMorph;
		createExclamationMark;
		createNodeButtons;
		createObjectExploreButtons;
		yourself! !

!SCodePaneMorph methodsFor: 'exploration' stamp: 'mp 4/24/2010 17:12'!
addObjectExplorationMorph: aMorph

	(self objExpMorphsStack includes: aMorph) ifTrue: [self objExpMorphsStack remove: aMorph].
	self objExpMorphsStack addFirst: aMorph.
	self 
		addMorph: aMorph;
		adjustObjectExplorationMorphs.! !

!SCodePaneMorph methodsFor: 'exploration' stamp: 'mp 4/18/2010 20:15'!
adjustObjectExplorationMorphs

	| posX |
	posX := self position x + self width.
	self objExpMorphsStack do: [:each | 
		each position: posX @ self position y.
		posX := posX + each width].! !

!SCodePaneMorph methodsFor: 'buttons' stamp: 'mp 7/4/2011 20:36:48.444'!
buttonSpec
	| spec |
	spec :=  {{#openCodeBrowser. 
				SImageRepository documentIcon. 
				'Open the source code browser'}.
			    {#byteCodeCoverage. 
				SImageRepository leftRightIcon. 
				'Coverage per statements'}.
			    {#debugMethod. 
				SImageRepository bugIcon. 
				'Start symbolic debugger'}.
			    {#expandTree. 
				SImageRepository treeIcon. 
				'Expand the complete subtree'}} asOrderedCollection.
	self isPathMapDataAvailable
		ifTrue: [	spec 
					add: {#showAdditionalInformation. 
							SImageRepository infoIcon. 
							'Show additional information'} 
					afterIndex: 1].
	^ spec! !

!SCodePaneMorph methodsFor: 'button actions' stamp: 'mp 9/21/2011 11:53:51.587'!
byteCodeCoverage
	| byteCodes method map stream range |
	byteCodes := self tracer byteCodeCoverageAt: self callNode.
	method := self callNode compiledMethod.
	map := (DebuggerMethodMap forMethod: method).
	byteCodes do: [:each | 
		stream := (InstructionStream on: method).
		stream pc: each.
		(stream willReallySend or: [stream willReturn])
			ifTrue: [range := map rangeForPC: each contextIsActiveContext: true.
					self definition text 
						addAttribute: TextEmphasis underlined
						from: range first 
						to: range last]].
			self definition changed.! !

!SCodePaneMorph methodsFor: 'accessing' stamp: 'mp 4/14/2010 14:03'!
callNode
	"Answer the value of callNode"

	^ callNode! !

!SCodePaneMorph methodsFor: 'accessing' stamp: 'mp 4/14/2010 14:03'!
callNode: anObject
	"Set the value of callNode"

	callNode := anObject! !

!SCodePaneMorph methodsFor: 'accessing' stamp: 'mp 3/25/2011 15:52:53.177'!
callgraphModel

	^ self callNode callgraphModel! !

!SCodePaneMorph methodsFor: 'definition' stamp: 'mp 3/24/2011 12:15:48.158'!
codePaneClass
	^ SPluggableTextMorphPlus! !

!SCodePaneMorph methodsFor: 'buttons' stamp: 'mp 7/7/2010 16:39:05.034'!
createButtonFromSelector: aSymbol icon: aForm
	
	| button |
	button := SActionButtonIconMorph on: self selector: aSymbol icon: aForm.
	button extent: (self class buttonWidth @ self class buttonWidth).
	self addMorph: button.
	^ button! !

!SCodePaneMorph methodsFor: 'definition' stamp: 'mp 3/24/2011 11:57:08.733'!
createDefinitionMorph

	| widget model |
	widget := self codePaneClass new.
	widget useDefaultStyler.
	model := SDefinitionModel new.
	model setClass: self callNode clientClass andSelector: self callNode clientSelector.
	widget on: model
				text: #contents
				accept: nil
				readSelection: nil 
				menu: nil.
	widget textMorph addDependent: self.
	widget 
		font: Preferences standardCodeFont;
		getColorSelector: nil;
		borderColor: Color lightGray;
		borderWidth: 0;
		color: Color white.
	self definition: widget.
	self addMorph: self definition.
	self definition extent: self class definitionWidth@self class definitionHeight.
	self definition position: (self definition position x + self class labelHeight)@ 
						(self definition position y + self class borderOffset)! !

!SCodePaneMorph methodsFor: 'label' stamp: 'mp 3/29/2012 17:46:15.16'!
createExclamationMark
	| violationMorph |
	self callNode hasViolations ifFalse: [^ self].
	violationMorph := SPMViolationMorph new.
	self addMorph: violationMorph.
	"Place in center of label morph"
	violationMorph position: (violationMorph position x + 3)@
								(violationMorph position y + 2).! !

!SCodePaneMorph methodsFor: 'exploration' stamp: 'mp 7/4/2011 20:13:27.031'!
createExploreButtonsForArgumentsAt: aNumber

	| arguments yPos button |
	self callNode numArgsOfMethod isZero
		ifTrue: [^ aNumber]
		ifFalse: [arguments := self getArgumentsFromSource: self callNode methodReference sourceCode.
			yPos := aNumber.
			arguments size > 3 
				ifTrue: [self createMultipleArgumentsButton: arguments at: yPos.
					^ yPos + self class buttonWidth].
			arguments withIndexDo: [:each :index | 
				button := self createObjExpButtonWith: {#arguments. each. index} 
							name: each atYPos: yPos.
				button 
					setBalloonText: 'Explore the ', each, ' argument in full detail' 
					maxLineLength: 50.
				yPos := yPos + self class buttonWidth].
			^ yPos].! !

!SCodePaneMorph methodsFor: 'exploration' stamp: 'mp 7/4/2011 20:10:56.082'!
createExploreButtonsForSelfAt: aNumber

	| button xPos label background |
	xPos := self definition position x + self definition width + self class borderOffset - 1.
	button := self createObjExpIconButtonWith: {#selfBefore. 'before'. 1} icon: SImageRepository beforeIcon.
	button position: xPos@(self definition position y + aNumber).
	button 
		setBalloonText: 'Explore the receiver object before the method is executed' 
		maxLineLength: 50.
	background := RectangleMorph new.
	self addMorph: background.
	background
		color: Color white;
		borderWidth: 0;
		extent: 45@self class buttonWidth;
		position: (xPos + button width)@(self definition position y + aNumber).
	label := StringMorph contents: 'self'.
	self addMorph: label.
	label position: (xPos + button width + (label width / 2))@(self definition position y + aNumber).
	xPos := xPos + button width + 45.
	button := 	self createObjExpIconButtonWith: {#selfAfter. 'after'. 1} icon: SImageRepository afterIcon.	
	button position: xPos@(self definition position y + aNumber).
	button 
		setBalloonText: 'Explore the receiver object after the method was executed' 
		maxLineLength: 50.
	^ aNumber + self class buttonWidth! !

!SCodePaneMorph methodsFor: 'label' stamp: 'mp 3/25/2011 15:53:04.838'!
createLabelMorph
	| stringMorph offsetPosX offsetPosY labelMorph |
	stringMorph := StringMorph contents: (self callNode views at: #receiver) asString.

	labelMorph := RectangleMorph new.
	labelMorph 
		extent: self class codePaneHeight @ self class labelHeight;
		color: self color;
		borderWidth: 1;
		borderColor: Color gray;
		addMorph: stringMorph.
		
	labelMorph width < self height
		ifTrue: [labelMorph width: self height].
	stringMorph width > (labelMorph width - 10)
		ifTrue: [stringMorph extent: (labelMorph width - 10) @ self class labelHeight.].
	
	offsetPosX := ((labelMorph width - stringMorph width) / 2) rounded.
	offsetPosY := ((labelMorph height - stringMorph height) / 2) rounded.
	stringMorph position: (stringMorph position x + offsetPosX)@(stringMorph position y + offsetPosY).	
	self addMorph: labelMorph.
	labelMorph heading: -90.
	labelMorph owner position: (self position x - 2) @ (self position y - 2).
	"Get color information from PathMap if available"
	(self callgraphModel getColorFromMap: self callNode)
		ifNotNil: [:color | labelMorph color: color].
	^ labelMorph! !

!SCodePaneMorph methodsFor: 'exploration' stamp: 'mp 7/4/2011 20:14:11.145'!
createMultipleArgumentsButton: aCollection at: aNumber
	| button |
	button := SActionButtonLabelMorph 
				on: self 
				selector: #showChooseArgumentMenu:
				args: (Array with: aCollection)
				name: 'Args...'.
	self addMorph: button.
	button 
		extent: (self class buttonWidth * 3 + 30)@self class buttonWidth;
		position: (self definition position x + 
					self definition width + self class borderOffset - 1)@
					(self definition position y + aNumber);
		borderWidth: 0.
	button 
		setBalloonText: 'Choose an argument for exploration' 
		maxLineLength: 50.! !

!SCodePaneMorph methodsFor: 'buttons' stamp: 'mp 7/4/2011 17:31:38.998'!
createNodeButtons

	| button posX |
	posX :=  self definition position x + self definition width + self class borderOffset - 1.
	self buttonSpec do: [:each | 
		button := self createButtonFromSelector: each first icon: each second.
		button position: posX@(self position y + 1).
		button borderWidth: 0.
		each size > 2
			ifTrue: [button setBalloonText: each third maxLineLength: 50].
		posX := posX + button width].! !

!SCodePaneMorph methodsFor: 'exploration' stamp: 'mp 7/4/2011 20:11:59.557'!
createObjExpButtonWith: aCollection name: aString atYPos: aNumber
	| button |
	button := SActionButtonLabelMorph 
				on: self 
				selector: #showObjectExploration:title:objectIndex:
				args: aCollection
				name: aString.
	self addMorph: button.
	button 
		extent: (self class buttonWidth * 3 + 30)@self class buttonWidth;
		position: (self definition position x + self definition width + self class borderOffset - 1)@
					(self definition position y + aNumber);
		borderWidth: 0.
	button labelMorph position: (button position x + 2)@(button labelMorph position y).
	^ button! !

!SCodePaneMorph methodsFor: 'exploration' stamp: 'mp 7/7/2010 16:39:00.67'!
createObjExpIconButtonWith: aCollection icon: anIconForm
	| button |
	button := SActionButtonIconMorph 
				on: self 
				selector: #showObjectExploration:title:objectIndex:
				args: aCollection
				icon: anIconForm.
	self addMorph: button.
	button borderWidth: 0.
	^ button! !

!SCodePaneMorph methodsFor: 'exploration' stamp: 'mp 7/4/2011 20:18:51.865'!
createObjectExploreButtonSpec

	^ {
		{{#return. 'return'. 1}. 'return'. 'Explore the returned object'}
	}! !

!SCodePaneMorph methodsFor: 'exploration' stamp: 'mp 7/4/2011 20:18:09.564'!
createObjectExploreButtons
	| yPos button |
	yPos := self position y + self class borderOffset + self class buttonWidth - 3.
	yPos := self createExploreButtonsForArgumentsAt: yPos.
	yPos := self createExploreButtonsForSelfAt: yPos.
	
	self createObjectExploreButtonSpec do: [:each |
		button := self createObjExpButtonWith: each first 
						name: each second atYPos: yPos.
		each size > 2
			ifTrue: [	button 
						setBalloonText: each third
						maxLineLength: 50].
		yPos := yPos + self class buttonWidth].! !

!SCodePaneMorph methodsFor: 'button actions' stamp: 'mp 4/24/2010 14:22'!
debugMethod

	self tracer debugAt: self callNode.! !

!SCodePaneMorph methodsFor: 'initialization' stamp: 'mp 7/7/2010 16:43:48.984'!
defaultBorderColor

	^ SCodeExplorerIndentingListItemMorph borderColor! !

!SCodePaneMorph methodsFor: 'initialization' stamp: 'mp 7/7/2010 16:43:45.332'!
defaultBorderWidth

	^ SCodeExplorerIndentingListItemMorph borderWidth! !

!SCodePaneMorph methodsFor: 'accessing' stamp: 'mp 4/14/2010 14:14'!
definition
	"Answer the value of definition"

	^ definition! !

!SCodePaneMorph methodsFor: 'accessing' stamp: 'mp 4/14/2010 14:14'!
definition: anObject
	"Set the value of definition"

	definition := anObject! !

!SCodePaneMorph methodsFor: 'button actions' stamp: 'mp 4/24/2010 14:35'!
expandTree

	self callNode callgraphModel expandNode: self callNode.! !

!SCodePaneMorph methodsFor: 'exploration' stamp: 'mp 4/24/2010 15:26'!
getArgumentsFromSource: aText

	| signature tokens index |
	signature := aText string lineCorrespondingToIndex: 1.
	tokens := signature findBetweenSubStrs: ' :'.
	index := 0.
	^ tokens select: [:each |
		index := index + 1.
		index even. ].
	! !

!SCodePaneMorph methodsFor: 'initialization' stamp: 'mp 4/27/2010 14:51'!
initialize

	super initialize.
	self 
		color: Color white;
		extent: self class codePaneWidth@self class codePaneHeight.! !

!SCodePaneMorph methodsFor: 'testing' stamp: 'mp 3/25/2011 15:55:13.126'!
isPathMapDataAvailable
	^ self pathFinder notNil and: [self pathFinder coverageTracer notNil]! !

!SCodePaneMorph methodsFor: 'updating' stamp: 'mp 3/24/2011 12:06:32.265'!
methodTypesLabelFor: aWord
	| method temps index type |
	self flag: #mpe. "Redundant code compare to implementors"
	method := self callNode compiledMethod.
	temps := method methodNode arguments, method methodNode temporaries.
	temps ifNotEmpty: [
		temps := temps collect: [:each | each name].
		index := temps indexOf: aWord.
		index = 0
			ifFalse: [SProject current typesBucket 
						ifNil: [^ 'Run type harvester first'].
				type := (SProject current typesBucket 	tempTypeAt: index in: method).
				type 
					ifNil: [^ 'No type available']
					ifNotNil: [^ type asString]]].
	(self callNode clientSelector asString beginsWith: aWord)
		ifTrue: [SProject current typesBucket 
					ifNil: [^ 'Run type harvester first'].
			type := (SProject current typesBucket 	returnTypeFor: method).
			type 
				ifNil: [^ '^ No type available']
				ifNotNil: [^ '^ ', type asString]].
	^ ''
! !

!SCodePaneMorph methodsFor: 'accessing' stamp: 'mp 4/18/2010 20:06'!
objExpMorphsStack
	"Answer the value of objExpMorphsStack"

	^ objExpMorphsStack ifNil: [objExpMorphsStack := OrderedCollection new]! !

!SCodePaneMorph methodsFor: 'accessing' stamp: 'mp 4/18/2010 20:06'!
objExpMorphsStack: anObject
	"Set the value of objExpMorphsStack"

	objExpMorphsStack := anObject! !

!SCodePaneMorph methodsFor: 'accessing' stamp: 'mp 4/18/2010 19:44'!
objectExplorationMorphs
	"Answer the value of objectExplorationMorphs"

	^ objectExplorationMorphs ifNil: [objectExplorationMorphs := Dictionary new]! !

!SCodePaneMorph methodsFor: 'accessing' stamp: 'mp 4/18/2010 18:18'!
objectExplorationMorphs: anObject
	"Set the value of objectExplorationMorphs"

	objectExplorationMorphs := anObject! !

!SCodePaneMorph methodsFor: 'button actions' stamp: 'mp 4/24/2010 14:22'!
openCodeBrowser

	Browser fullOnClass: self callNode clientClass selector: self callNode clientSelector! !

!SCodePaneMorph methodsFor: 'accessing' stamp: 'mp 3/25/2011 15:53:17.505'!
pathFinder

	^ self callNode callgraphModel pathFinder! !

!SCodePaneMorph methodsFor: 'updating' stamp: 'mp 7/4/2011 15:51:57.444'!
refreshScrollbars

	self owner container setScrollDeltas.! !

!SCodePaneMorph methodsFor: 'exploration' stamp: 'mp 4/18/2010 20:11'!
removeObjectExplorationMorph: aMorph

	self objExpMorphsStack remove: aMorph.
	self 
		removeMorph: aMorph;
		adjustObjectExplorationMorphs.! !

!SCodePaneMorph methodsFor: 'button actions' stamp: 'mp 2/9/2012 17:17:53.22'!
showAdditionalInformation
	| info |
	info := self callgraphModel getAdditionalInformationFromMap: self callNode.
	info ifNil: [^ self].
	info isString
		ifTrue: [^ self inform: info].
	info explore.! !

!SCodePaneMorph methodsFor: 'exploration' stamp: 'mp 4/24/2010 17:09'!
showChooseArgumentMenu: aCollection

	| choice |
	choice := UIManager default 
				chooseFrom: aCollection 
					values: (1 to: aCollection size) 
					lines: #() 
					title: 'Choose argument'.
	choice ifNotNil: [self showObjectExploration: #arguments title: (aCollection at: choice) objectIndex: choice].! !

!SCodePaneMorph methodsFor: 'exploration' stamp: 'mp 7/4/2011 15:50:57.431'!
showObjectExploration: aSymbol title: aString objectIndex: aNumber

	| morph |
	morph := self objectExplorationMorphs 
				at: (aSymbol asString, aNumber asString) asSymbol
				ifAbsentPut: [SObjectExplorationMorph 
								on: self 
								title: aString 
								kindOfObjects: aSymbol 
								objectIndex: aNumber
								callNode: self callNode 
								color: self color].
	self 
		addObjectExplorationMorph: morph;
		refreshScrollbars.! !

!SCodePaneMorph methodsFor: 'accessing' stamp: 'mp 4/24/2010 14:37'!
tracer

	^ self callNode callgraphModel tracer! !

!SCodePaneMorph methodsFor: 'updating' stamp: 'mp 3/24/2011 12:01:48.954'!
update: aWord with: aTextMorph
	aTextMorph labelMorph createLabelMorph: (self methodTypesLabelFor: aWord).
! !

RectangleMorph subclass: #SColorLegendMorph
	instanceVariableNames: 'labelMorph optionsModel verticalColors horizontalColors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!SColorLegendMorph class methodsFor: 'constants' stamp: 'mp 9/16/2010 10:27:11.875'!
labelOffset
	^ 10@10! !

!SColorLegendMorph class methodsFor: 'instance creation' stamp: 'mp 9/16/2010 18:55:06.251'!
on: anOptionsModel

	^ self new
		optionsModel: anOptionsModel;
		yourself! !

!SColorLegendMorph methodsFor: 'event handling' stamp: 'mp 9/17/2010 13:43:32.438'!
convertToRelativePosition: aPoint
	| local |
	local := (self bounds topLeft - aPoint) * -1.
	^ (local x / self width) asFloat @ (local y / self height) asFloat.! !

!SColorLegendMorph methodsFor: 'initialization' stamp: 'mp 9/15/2010 22:32:04.587'!
defaultBorderColor

	^ Color gray: 0.5! !

!SColorLegendMorph methodsFor: 'initialization' stamp: 'mp 9/15/2010 22:31:58.354'!
defaultBorderWidth

	^ 1! !

!SColorLegendMorph methodsFor: 'drawing' stamp: 'mp 9/16/2010 09:42:34.501'!
drawBordersOn: aCanvas
	aCanvas 
		frameRectangle: self bounds 
		width: self defaultBorderWidth 
		color: self defaultBorderColor.! !

!SColorLegendMorph methodsFor: 'drawing' stamp: 'mp 9/20/2010 18:15:39.471'!
drawColorHorizontalOn: aCanvas
	| lasthorizontal insetRect fillStyle |
	lasthorizontal := 0.0.
	self horizontalColors do: [:each | 
		insetRect := self bounds 
						insetOriginBy: ((self bounds width * lasthorizontal) asInteger@0)
						cornerBy: ((self bounds width - (self bounds width * each key)) asInteger@0).
		lasthorizontal := each key.
		fillStyle := GradientFillStyle colors: each value.
		fillStyle origin: insetRect topLeft.
		fillStyle direction: insetRect width@0.
		aCanvas fillRectangle: insetRect fillStyle: fillStyle].
! !

!SColorLegendMorph methodsFor: 'drawing' stamp: 'mp 9/20/2010 18:29:27.279'!
drawColorVerticalOn: aCanvas
	| lastVertical insetRect fillStyle |
	lastVertical := 0.0.
	self verticalColors do: [:each | 
		insetRect := self bounds 
						insetOriginBy: (0@(self bounds height * lastVertical) asInteger)
						cornerBy: (0@(self bounds height - 	(self bounds height * each key)) asInteger).
		lastVertical := each key.
		fillStyle := GradientFillStyle colors: each value.
		fillStyle origin: insetRect topLeft.
		fillStyle direction: 0@insetRect height.
		aCanvas fillRectangle: insetRect fillStyle: fillStyle].
! !

!SColorLegendMorph methodsFor: 'drawing' stamp: 'mp 9/17/2010 17:03:16.045'!
drawOn: aCanvas
	self 
		drawColorHorizontalOn: aCanvas;
		drawColorVerticalOn: aCanvas;
		drawBordersOn: aCanvas.
! !

!SColorLegendMorph methodsFor: 'events-processing' stamp: 'mp 9/16/2010 09:56:16.082'!
handleMouseMove: anEvent
	anEvent wasHandled: true.
	self mouseMove: anEvent.! !

!SColorLegendMorph methodsFor: 'event handling' stamp: 'mp 9/16/2010 09:58:13.85'!
handlesMouseOver: evt

	^ true! !

!SColorLegendMorph methodsFor: 'accessing' stamp: 'mp 9/17/2010 17:03:45.694'!
horizontalColors
	"Answer the value of horizontalColors"

	^ horizontalColors! !

!SColorLegendMorph methodsFor: 'accessing' stamp: 'mp 9/17/2010 17:03:45.699'!
horizontalColors: anObject
	"Set the value of horizontalColors"

	horizontalColors := anObject! !

!SColorLegendMorph methodsFor: 'initialization' stamp: 'mp 9/16/2010 10:01:13.69'!
initialize
	super initialize.
	self extent: 150@150.
	self labelMorph: (SLabelMorph label: 'ToDo').! !

!SColorLegendMorph methodsFor: 'accessing' stamp: 'mp 9/16/2010 10:00:46.979'!
labelMorph
	"Answer the value of labelMorph"

	^ labelMorph! !

!SColorLegendMorph methodsFor: 'accessing' stamp: 'mp 9/16/2010 10:00:46.984'!
labelMorph: anObject
	"Set the value of labelMorph"

	labelMorph := anObject! !

!SColorLegendMorph methodsFor: 'event handling' stamp: 'mp 9/17/2010 14:54:55.868'!
mouseEnter: anEvent
	self flag: #mpe. "owner owner works but is very fragile"
	"Required to allow large labels to be shown outside the color legend"
	self owner owner addMorph: self labelMorph.
	self labelMorph position: anEvent cursorPoint + self class labelOffset.! !

!SColorLegendMorph methodsFor: 'event handling' stamp: 'mp 9/17/2010 14:53:39.978'!
mouseLeave: anEvent
	self flag: #mpe. "owner owner works but is very fragile"
	self owner owner removeMorph: self labelMorph.! !

!SColorLegendMorph methodsFor: 'event handling' stamp: 'mp 9/17/2010 14:26:12.973'!
mouseMove: anEvent
	| labelString relativePosition |
	relativePosition := self convertToRelativePosition: anEvent position.
	labelString := self optionsModel
		ifNil: [(relativePosition x printShowingDecimalPlaces: 2), '@',
								(relativePosition y printShowingDecimalPlaces: 2)]
		ifNotNil: [self optionsModel getLabelString: relativePosition].
	self labelMorph createLabelMorph: labelString.
	self labelMorph position: anEvent cursorPoint + self class labelOffset.! !

!SColorLegendMorph methodsFor: 'accessing' stamp: 'mp 9/16/2010 18:54:45.479'!
optionsModel
	"Answer the value of optionsModel"

	^ optionsModel! !

!SColorLegendMorph methodsFor: 'accessing' stamp: 'mp 9/16/2010 18:54:45.483'!
optionsModel: anObject
	"Set the value of optionsModel"

	optionsModel := anObject! !

!SColorLegendMorph methodsFor: 'accessing' stamp: 'mp 9/16/2010 19:03:38.679'!
verticalColors
	"Answer the value of verticalColors"

	^ verticalColors! !

!SColorLegendMorph methodsFor: 'accessing' stamp: 'mp 9/16/2010 19:03:38.685'!
verticalColors: anObject
	"Set the value of verticalColors"

	verticalColors := anObject! !

RectangleMorph subclass: #SLabelMorph
	instanceVariableNames: 'labelMorphs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!SLabelMorph class methodsFor: 'constants' stamp: 'mp 9/15/2010 17:45:00.918'!
defaultColor

	^ Color white! !

!SLabelMorph class methodsFor: 'constants' stamp: 'mp 9/15/2010 18:44:58.329'!
defaultExtensionFactor

	^ 1.3! !

!SLabelMorph class methodsFor: 'instance creation' stamp: 'mp 9/15/2010 17:41:34.967'!
label: aString

	^ self new
		createLabelMorph: aString;
		yourself! !

!SLabelMorph methodsFor: 'building' stamp: 'mp 9/8/2011 18:09:33.29'!
createLabelMorph: aString
	| morph corner |
	self labelMorphs ifNotNil: [
		self labelMorphs do: [:each | 
			self removeMorph: each. 
			each delete].
		self labelMorphs: OrderedCollection new.].
	aString lines do: [:each | 
		morph := StringMorph contents: each.
		self labelMorphs add: morph.
		self addMorph: morph].
	corner := self labelMorphs 
		ifEmpty: [1@1]
		ifNotEmpty: [ (self labelMorphs collect: [:each | each fullBounds corner x]) max
					@ ((self labelMorphs collect: [:each | each  fullBounds corner y]) sum)].
	self extent: (corner * self class defaultExtensionFactor).! !

!SLabelMorph methodsFor: 'initialization' stamp: 'mp 9/15/2010 17:44:35.443'!
defaultBorderColor

	^ Color gray: 0.5! !

!SLabelMorph methodsFor: 'initialization' stamp: 'mp 9/15/2010 17:44:41.885'!
defaultBorderWidth

	^ 1! !

!SLabelMorph methodsFor: 'geometry' stamp: 'mp 9/9/2011 09:37:03.35'!
extent: aPoint
	| borderOffset heightOffset |
	super extent: aPoint.
	self labelMorphs withIndexDo: [:each :index | 
		each position: self position x @ (self position y + ((index - 1) * each height))].
	heightOffset := (self height - (self height / self class defaultExtensionFactor)) / 2.
	self labelMorphs withIndexDo: [:each :index | 
		each width < self width
			ifTrue: [each position: 
					(each position x + (self width / 2) - (each width / 2)) @ 
					(each position y + heightOffset)]
			ifFalse: [
				borderOffset := 5.
				each position: 
					(self position x + borderOffset - 2) @ 
					(each position y + heightOffset).
				each extent: (self width - borderOffset) @ self height]].! !

!SLabelMorph methodsFor: 'initialization' stamp: 'mp 9/15/2010 17:44:51.141'!
initialize
	super initialize.
	self color: self class defaultColor.! !

!SLabelMorph methodsFor: 'accessing' stamp: 'mp 9/8/2011 16:57:08.097'!
labelMorphs
	"Answer the value of labelMorphs"

	^ labelMorphs ifNil: [labelMorphs := OrderedCollection new]! !

!SLabelMorph methodsFor: 'accessing' stamp: 'mp 9/8/2011 16:56:29.288'!
labelMorphs: anObject
	"Set the value of labelMorphs"

	labelMorphs := anObject! !

RectangleMorph subclass: #SObjectExplorationMorph
	instanceVariableNames: 'codePane title callNode kindOfObject objectIndex objectToExplore'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!SObjectExplorationMorph class methodsFor: 'constants' stamp: 'mp 7/7/2010 16:43:57.664'!
borderColor

	^ SCodeExplorerIndentingListItemMorph borderColor! !

!SObjectExplorationMorph class methodsFor: 'constants' stamp: 'mp 4/20/2010 15:57'!
borderOffset

	^ 2! !

!SObjectExplorationMorph class methodsFor: 'constants' stamp: 'mp 4/27/2010 16:57'!
buttonWidth

	^ 15! !

!SObjectExplorationMorph class methodsFor: 'constants' stamp: 'mp 7/7/2010 16:44:42.262'!
explorationHeight

	^ SCodePaneMorph codePaneHeight! !

!SObjectExplorationMorph class methodsFor: 'constants' stamp: 'mp 7/4/2011 13:42:49.89'!
explorationMinWidth

	^ 225! !

!SObjectExplorationMorph class methodsFor: 'instance creation' stamp: 'mp 4/24/2010 16:16'!
on: aCodePane title: aString kindOfObjects: aSymbol objectIndex: aNumber callNode: aCallNode color: aColor

	^ self new
		codePane: aCodePane;
		title: aString;
		callNode: aCallNode;
		kindOfObject: aSymbol;
		objectIndex: aNumber;
		color: aColor;
		createMorphs;
		yourself! !

!SObjectExplorationMorph class methodsFor: 'instance creation' stamp: 'mp 4/27/2010 19:52'!
on: aCodePane title: aString object: anObject color: aColor

	^ self new
		codePane: aCodePane;
		title: aString;
		objectToExplore: anObject;
		color: aColor;
		createMorphs;
		yourself! !

!SObjectExplorationMorph class methodsFor: 'constants' stamp: 'mp 4/27/2010 16:53'!
titleBorderWidth

	^ 1! !

!SObjectExplorationMorph methodsFor: 'actions' stamp: 'mp 4/20/2010 16:36'!
browseClass: aClass

	Browser fullOnClass: aClass! !

!SObjectExplorationMorph methodsFor: 'accessing' stamp: 'mp 4/19/2010 20:12'!
callNode
	"Answer the value of callNode"

	^ callNode! !

!SObjectExplorationMorph methodsFor: 'accessing' stamp: 'mp 4/19/2010 20:12'!
callNode: anObject
	"Set the value of callNode"

	callNode := anObject! !

!SObjectExplorationMorph methodsFor: 'actions' stamp: 'mp 7/4/2011 15:51:24.064'!
close

	self codePane removeObjectExplorationMorph: self.
	self codePane refreshScrollbars.! !

!SObjectExplorationMorph methodsFor: 'accessing' stamp: 'mp 4/18/2010 18:44'!
codePane
	"Answer the value of codePane"

	^ codePane! !

!SObjectExplorationMorph methodsFor: 'accessing' stamp: 'mp 4/18/2010 18:44'!
codePane: anObject
	"Set the value of codePane"

	codePane := anObject! !

!SObjectExplorationMorph methodsFor: 'morphic' stamp: 'mp 7/7/2010 16:39:45.521'!
createCloseButton

	| closeButton |
	closeButton := SActionButtonLabelMorph on: self selector: #close name: 'X'.
	self addMorph: closeButton.
	closeButton 
		extent: (self class buttonWidth -1)@self class buttonWidth;
		position: (self position x + self width - closeButton width) @ (self position y);
		color: self color.
	! !

!SObjectExplorationMorph methodsFor: 'morphic' stamp: 'mp 4/27/2010 16:55'!
createMorphs

	| exploredObject |
	exploredObject := self getObjectToExplore.
	self 
		createObjectExplorerOn: exploredObject;
		createCloseButton.
! !

!SObjectExplorationMorph methodsFor: 'morphic' stamp: 'mp 7/7/2010 17:07:53.172'!
createObjectExplorerOn: anObject
	| listMorph |
	listMorph := (SObjectExplorer on: self codePane) explorerListMorphFor: anObject.
	self addMorph: listMorph.
	listMorph 
		borderWidth: 0;
		position: self position x @ (self position y + self class buttonWidth);
		extent: (self width - 1)@(self height - self class buttonWidth - 1).
! !

!SObjectExplorationMorph methodsFor: 'initialization' stamp: 'mp 7/7/2010 16:43:54.844'!
defaultBorderColor

	^ SCodeExplorerIndentingListItemMorph borderColor! !

!SObjectExplorationMorph methodsFor: 'initialization' stamp: 'mp 7/7/2010 16:43:52.227'!
defaultBorderWidth

	^ SCodeExplorerIndentingListItemMorph borderWidth! !

!SObjectExplorationMorph methodsFor: 'drawing' stamp: 'mp 4/27/2010 16:52'!
drawOn: aCanvas

	super drawOn: aCanvas.
	self title ifNil: [^ self].
	self 
		drawTitleRectangleOn: aCanvas;
		drawTitleOn: aCanvas.! !

!SObjectExplorationMorph methodsFor: 'drawing' stamp: 'mp 4/27/2010 20:23'!
drawTitleOn: aCanvas

	| string |
	string := self title, ': ',  self getObjectToExplore class asString.
	aCanvas 
		drawString: string
		in: ((self position x + 2@self position y) 
			corner: ((self position x + self width - 2 - self class buttonWidth) @ 
				(self position y + self class buttonWidth))).! !

!SObjectExplorationMorph methodsFor: 'drawing' stamp: 'mp 4/27/2010 16:59'!
drawTitleRectangleOn: aCanvas

	| rect |
	rect := ((self position x - 1) @ self position y) 
			corner: ((self position x + self width) @ 
					(self position y + self class buttonWidth)).
	aCanvas 
		frameAndFillRectangle: rect 
		fillColor: self color 
		borderWidth: self class titleBorderWidth 
		borderColor: self class borderColor.! !

!SObjectExplorationMorph methodsFor: 'morphic' stamp: 'mp 4/27/2010 19:53'!
getObjectToExplore

	| objects |
	self objectToExplore ifNotNil: [^ self objectToExplore].
	objects := self callNode explore: self kindOfObject.
	objects size = 1 ifTrue: [
		self kindOfObject == #arguments
			ifTrue: [^ objects first at: self objectIndex].
		^ objects first].
	^ objects! !

!SObjectExplorationMorph methodsFor: 'initialization' stamp: 'mp 4/20/2010 17:01'!
initialize

	super initialize.
	self extent: self class explorationMinWidth @ self class explorationHeight.
	! !

!SObjectExplorationMorph methodsFor: 'accessing' stamp: 'mp 4/19/2010 20:12'!
kindOfObject
	"Answer the value of kindOfObject"

	^ kindOfObject! !

!SObjectExplorationMorph methodsFor: 'accessing' stamp: 'mp 4/19/2010 20:12'!
kindOfObject: anObject
	"Set the value of kindOfObject"

	kindOfObject := anObject! !

!SObjectExplorationMorph methodsFor: 'accessing' stamp: 'mp 4/24/2010 16:16'!
objectIndex
	"Answer the value of objectIndex"

	^ objectIndex! !

!SObjectExplorationMorph methodsFor: 'accessing' stamp: 'mp 4/24/2010 16:16'!
objectIndex: anObject
	"Set the value of objectIndex"

	objectIndex := anObject! !

!SObjectExplorationMorph methodsFor: 'accessing' stamp: 'mp 4/27/2010 19:52'!
objectToExplore
	"Answer the value of objectToExplore"

	^ objectToExplore! !

!SObjectExplorationMorph methodsFor: 'accessing' stamp: 'mp 4/27/2010 19:52'!
objectToExplore: anObject
	"Set the value of objectToExplore"

	objectToExplore := anObject! !

!SObjectExplorationMorph methodsFor: 'accessing' stamp: 'mp 4/18/2010 19:56'!
title
	"Answer the value of title"

	^ title! !

!SObjectExplorationMorph methodsFor: 'accessing' stamp: 'mp 4/18/2010 19:56'!
title: anObject
	"Set the value of title"

	title := anObject! !

!Behavior methodsFor: '*Path-Core' stamp: 'mp 1/25/2010 10:26'!
classAndMethodFor: aSymbol do: binaryBlock ifAbsent: absentBlock
	"Looks up the selector aSymbol in the class chain. If it is found, binaryBlock is evaluated
	with the class that defines the selector and the associated method. Otherwise
	absentBlock is evaluated."

	| method |
	self withAllSuperclassesDo: [:class |
		method := class compiledMethodAt: aSymbol ifAbsent: [nil].
		method ifNotNil: [^ binaryBlock value: class value: method].
	].
	^ absentBlock value.! !

!SystemWindow methodsFor: '*Path-Core' stamp: 'mp 9/13/2010 17:30:44.37'!
addPaneHSplitters
	"reject flap morphs, too"
	| remaining targetY sameY |
	remaining := paneMorphs copy reject: [:each | each layoutFrame bottomFraction = 1 
													or: [each isKindOf: SPluggableFlapMorph]].
	[remaining notEmpty] whileTrue:
		[targetY := remaining first layoutFrame bottomFraction.
		sameY := paneMorphs select: [:each | each layoutFrame bottomFraction = targetY].
		self addPaneHSplitterBetween: remaining first and: sameY.
		remaining := remaining copyWithoutAll: sameY]! !

!SystemWindow methodsFor: '*Path-Core' stamp: 'mp 9/13/2010 17:30:50.57'!
addPaneVSplitters
	"reject flap morphs, too"
	| remaining targetX sameX |
	remaining := paneMorphs copy reject: [:each | each layoutFrame rightFraction = 1 
													or: [each isKindOf: SPluggableFlapMorph]].
	[remaining notEmpty] whileTrue:
		[targetX := remaining first layoutFrame rightFraction.
		sameX := paneMorphs select: [:each | each layoutFrame rightFraction = targetX].
		self addPaneVSplitterBetween: remaining first and: sameX.
		remaining := remaining copyWithoutAll: sameX]! !

!SystemWindow methodsFor: '*Path-Core' stamp: 'mp 1/20/2010 19:03'!
modalLockTo: aSystemWindow
	"Lock the receiver as a modal owner of the given window."

	aSystemWindow
		setProperty: #modalOwner toValue: self.
	self setProperty: #modalChild toValue: aSystemWindow! !

!SystemWindow methodsFor: '*Path-Core' stamp: 'mp 1/20/2010 19:05'!
modalUnlockFrom: aSystemWindow
	"Unlock the receiver as a modal owner of the given window."

	aSystemWindow removeProperty: #modalOwner.
	self removeProperty: #modalChild.
	self activate! !

PluggableMultiSelectionListSpec subclass: #SPluggableMultiSelectionListSpec
	instanceVariableNames: 'itemColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Specs'!

!SPluggableMultiSelectionListSpec methodsFor: 'building' stamp: 'mp 9/23/2010 16:45:03.24'!
buildWith: builder
	^builder buildSPluggableMultiSelectionList: self! !

!SPluggableMultiSelectionListSpec methodsFor: 'accessing' stamp: 'mp 9/23/2010 17:44:47.093'!
itemColor
	"Answer the value of itemColor"

	^ itemColor! !

!SPluggableMultiSelectionListSpec methodsFor: 'accessing' stamp: 'mp 9/23/2010 17:44:47.098'!
itemColor: anObject
	"Set the value of itemColor"

	itemColor := anObject! !

!ObjectExplorerWrapper methodsFor: '*Path-Core' stamp: 'mp 4/27/2010 18:37'!
item

	^ item! !

!LazyListMorph methodsFor: '*Path-Core' stamp: 'mp 9/22/2010 14:15:44.513'!
drawBackgroundForMulti: row on: aCanvas 
	"shade the background paler, if this row is selected, but not the current selected row"
	| selectionDrawBounds thisColor |
	thisColor := selectedRow = row
		ifTrue: [ self class listSelectionColor ]
		ifFalse: [ self class listSelectionColor lighter ].
	selectionDrawBounds := self drawBoundsForRow: row.
	selectionDrawBounds := selectionDrawBounds intersect: self bounds.
	aCanvas
		fillRectangle: selectionDrawBounds
		color: thisColor! !

LazyListMorph subclass: #SLazyListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!SLazyListMorph methodsFor: 'drawing' stamp: 'mp 9/23/2010 17:56:34.888'!
colorForRow: row
	| itemColor |
	itemColor := listSource itemColorAt: row.
	itemColor == false
		ifFalse: [^ itemColor].	
	^(selectedRow notNil and: [ row = selectedRow])
		ifTrue: [ self class listSelectionTextColor ]
		ifFalse: [ self color ].
		! !

PluggableButtonMorphPlus subclass: #SPluggableCheckBoxMorph
	instanceVariableNames: 'checkBoxMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!SPluggableCheckBoxMorph methodsFor: 'accessing' stamp: 'mp 9/15/2010 15:08:08.041'!
checkBoxMorph
	"Answer the value of checkBoxMorph"

	^ checkBoxMorph! !

!SPluggableCheckBoxMorph methodsFor: 'accessing' stamp: 'mp 9/15/2010 15:08:08.046'!
checkBoxMorph: anObject
	"Set the value of checkBoxMorph"

	checkBoxMorph := anObject! !

!SPluggableCheckBoxMorph methodsFor: 'initialize-release' stamp: 'mp 9/16/2010 11:26:13.693'!
initialize
	super initialize.
	onColor := Color white.
	offColor := Color lightGray.! !

!SPluggableCheckBoxMorph methodsFor: 'accessing' stamp: 'mp 9/16/2010 11:26:49.093'!
label: aStringOrTextOrMorph font: aFont
	"Label this button with the given string or morph."
	| r |
	self removeAllMorphs.
	"nest label in a row for centering"
	r := AlignmentMorph newRow
		borderWidth: 0;
		layoutInset: 0;
		color: Color transparent;
		hResizing: #shrinkWrap;
		vResizing: #spaceFill;
		wrapCentering: #center; cellPositioning: #leftCenter.
	aStringOrTextOrMorph isMorph
		ifTrue: [
			label := aStringOrTextOrMorph.
			r addMorph: aStringOrTextOrMorph]
		ifFalse: [
			label := aStringOrTextOrMorph asString.
			r addMorph: (StringMorph contents: label font: aFont)].
	"space placeholder"
	r addMorph: ((Morph new extent: (aFont pointSize - 3)@(aFont pointSize - 3)) 
					color: Color transparent).
	self checkBoxMorph: (SCheckBoxMorph new 
							extent: (aFont pointSize)@(aFont pointSize)).
	self checkBoxMorph checked: self getModelState.
	r addMorph: self checkBoxMorph.
	self addMorph: r.! !

!SPluggableCheckBoxMorph methodsFor: 'updating' stamp: 'mp 9/15/2010 15:11:01.907'!
update: what
	| state |
	what ifNil:[^self].
	what == getLabelSelector ifTrue: [
		self label: (model perform: getLabelSelector)].
	what == getEnabledSelector ifTrue:[^self enabled: (model perform: getEnabledSelector)].

	getColorSelector ifNotNil: [ | cc |
		color = (cc := model perform: getColorSelector) ifFalse:[
			color := cc.
			self onColor: color offColor: color.
			self changed.
		].
	].
	state := self getModelState.
	self checkBoxMorph checked: state.
	state
		ifTrue: [self color: onColor]
		ifFalse: [self color: offColor].	
	getEnabledSelector ifNotNil:[
		self enabled: (model perform: getEnabledSelector).
	].
! !

!PluggableListMorphOfMany methodsFor: '*Path-Core' stamp: 'mp 9/22/2010 13:52:22.471'!
update: aSymbol 
	aSymbol == #allSelections ifTrue:
		[self selectionIndex: self getCurrentSelectionIndex.
		^ self changed].
	aSymbol == getSelectionListSelector
		ifTrue: [self changed].
	^ super update: aSymbol! !

PluggableListMorphOfMany subclass: #SPluggableListMorphOfMany
	instanceVariableNames: 'itemColorSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!SPluggableListMorphOfMany methodsFor: 'drawing' stamp: 'mp 9/23/2010 17:47:45.121'!
itemColorAt: index
	itemColorSelector ifNil: [^ false].
	^ model perform: itemColorSelector with: index! !

!SPluggableListMorphOfMany methodsFor: 'as yet unclassified' stamp: 'mp 9/23/2010 17:49:25.498'!
listMorphClass
	^SLazyListMorph! !

!SPluggableListMorphOfMany methodsFor: 'accessing' stamp: 'mp 9/23/2010 17:46:22.699'!
setItemColorSelector: aSymbol
	"Set the value of iconSelector"

	itemColorSelector := aSymbol! !

PluggableTreeSpec subclass: #SPluggableTreeSpec
	instanceVariableNames: 'highlightItem indentingListItemMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!SPluggableTreeSpec methodsFor: 'accessing' stamp: 'mp 1/20/2010 17:51'!
highlightItem
	^ highlightItem! !

!SPluggableTreeSpec methodsFor: 'accessing' stamp: 'mp 1/20/2010 17:51'!
highlightItem: anObject
	highlightItem := anObject! !

!SPluggableTreeSpec methodsFor: 'accessing' stamp: 'mp 4/14/2010 11:18'!
indentingListItemMorph
	"Answer the value of indentingListItemMorph"

	^ indentingListItemMorph! !

!SPluggableTreeSpec methodsFor: 'accessing' stamp: 'mp 4/14/2010 11:18'!
indentingListItemMorph: anObject
	"Set the value of indentingListItemMorph"

	indentingListItemMorph := anObject! !

Browser subclass: #SBrowser
	instanceVariableNames: 'currentSelectedMethod cacheCoverage cacheConcerns refreshRequired previousMethod filterProjectCategories codeSource'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Tools'!

!SBrowser class methodsFor: 'constants' stamp: 'mp 5/3/2010 23:17'!
defaultExtent

	^ 750@390! !

!SBrowser class methodsFor: 'class initialization' stamp: 'mp 3/7/2011 22:27:40.148'!
initialize

	self registerInAppRegistry.
	TheWorldMenu registerOpenCommand: {'PathBrowser'. {self. #open}}.! !

!SBrowser class methodsFor: 'instance creation' stamp: 'mp 3/23/2011 14:48:43.345'!
openBrowserView: aBrowserView label: aString 
	"Schedule aBrowserView, labelling the view aString."
	| morph |
	(aBrowserView isKindOf: ToolBuilderSpec) ifTrue:[
		morph := ToolBuilder open: aBrowserView label: aString.
		morph extent: self defaultExtent.
	] ifFalse:[
		aBrowserView isMorph
			ifTrue:  [(aBrowserView setLabel: aString) openInWorld]
			ifFalse: [aBrowserView label: aString.
					aBrowserView minimumSize: 300 @ 200.
					aBrowserView subViews do: [:each | each controller].
					aBrowserView controller open].
	].
	"Dependency required for label control within source code"
	(aBrowserView model dependents 
		detect: [:each | each isKindOf: SPluggableTextMorphPlus] ifNone: [nil])
		ifNotNil: [:each | 	each textMorph addDependent: aBrowserView model].
	aBrowserView model refreshAdditionalLists.
	^ aBrowserView model
! !

!SBrowser methodsFor: 'controls-inavariants' stamp: 'mp 3/14/2012 16:14:15.581'!
aboutToStyle: aStyler
	"Added invariants to syntax highlighting"
	self invariantsShown ifTrue: 
		[aStyler classOrMetaClass: (self selectedClassOrMetaClass). 
		^ true].
	^ super aboutToStyle: aStyler! !

!SBrowser methodsFor: 'start tools' stamp: 'mp 3/21/2011 16:59:19.54'!
browsePath
	| tests |
	tests := self coveredTestsSortedFor: self selectedMethodReference.
	tests 
		ifEmpty: [self inform: 'The method is not covered by an entry point.', 
							  String cr, 
							  'Run PathMap first.']
		ifNotEmpty:[
			(self choseTest: tests asOrderedCollection)
				ifNotNil: [:choice | self openPathFinderOn: choice asMethodReference]].	! !

!SBrowser methodsFor: 'start tools' stamp: 'tfel 7/7/2011 12:10:10.533'!
browseWithPathView
	| views labels lines open |
	self selectedClass ifNil: [^ self].  
	views := OrderedCollection newFrom: {#new}.
	labels := OrderedCollection newFrom: {'New ...' translated}.
	lines := OrderedCollection newFrom: #(1).
	SProject allProjects do: [:p || projectsPathViews |
		projectsPathViews := p views select: [:view |
			view classes includes: self selectedClass].
		projectsPathViews ifNotEmpty: [
			lines add: labels size. "Add a line for this project at the end"
			views addAll: (projectsPathViews keys collect: [:name | p -> name]).
			labels addAll: (projectsPathViews keys collect: [:name | p projectName, ' - ', name])]].
	views ifEmpty: [^ self createPathView].
	open := SMultipleChoiceRequest
				prompt: 'Open view...'
				labels: labels
				values: views
				lines: lines.
	open ifNotNil: [
		open = #new ifTrue: [^ self createPathView].
		SProject setCurrentProject: open key.
		SPathView openSaved: open value].! !

!SBrowser methodsFor: 'toolbuilder' stamp: 'mp 5/11/2011 12:14:42.479'!
buildCodePaneWith: builder
	| textSpec top buttonSpec annoSpec |
	textSpec := builder pluggableCodePaneSpec new.
	textSpec 
		model: self;
		name: #codePane;
		getText: #contents; 
		setText: #contents:notifying:; 
		selection: #contentsSelection; 
		menu: #codePaneMenu:shifted:.
	self wantsAnnotationPane ifTrue:[
		top ifNil:[
			top := builder pluggablePanelSpec new.
			top children: OrderedCollection new.
		].
		annoSpec := builder pluggableInputFieldSpec new.
		annoSpec model: self; getText: #annotation. 
		annoSpec frame: (0@0.88 corner: 1@1).
		top children add: annoSpec.
	].
	top ifNotNil:[
		textSpec frame: (0 @ (buttonSpec ifNil:[0] ifNotNil:[0.12])
			corner: 1 @ (annoSpec ifNil:[1] ifNotNil:[0.88])).
		top children add: textSpec.
	].
	^top ifNil:[textSpec]! !

!SBrowser methodsFor: 'toolbuilder' stamp: 'mp 3/23/2011 12:17:17.797'!
buildConcernTreeWith: aBuilder
	| treeSpec |
	treeSpec := aBuilder pluggableTreeSpec new.
	treeSpec
		model: self;
		name: #concernTree;
		roots: #rootsConcerns;
		hasChildren: #hasChildrenConcerns:;
		getChildren: #getChildrenConcerns:;
		label: #labelConcern:;
		setSelected: #selectedConcernItem:;
		icon: #iconForConcernItem:.
	^ treeSpec! !

!SBrowser methodsFor: 'controls-prepost' stamp: 'mp 3/14/2012 16:23:41.954'!
buildContractSwitchesWith: builder
	"Build the switches to view parts of contracts"
	| panelSpec buttonSpec |
	panelSpec := builder pluggablePanelSpec new.
	panelSpec children: OrderedCollection new.

	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec 
			model: self;
			label: 'pre'; 
			state: #preconditionsShown; 
			action: #togglePreconditions;
			color: #conditionButtonColor;
			enabled: #hasConditions;
			frame: (0@0 corner: 0.39@1).
	panelSpec children addLast: buttonSpec.

	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec 
			model: self;
			label: 'post'; 
			state: #classMessagesIndicated; 
			action: #togglePostconditions;
			color: #conditionButtonColor;
			enabled: #hasConditions;
			frame: (0.61@0 corner: 1@1).
	panelSpec children addLast: buttonSpec.

	^ panelSpec! !

!SBrowser methodsFor: 'controls-inavariants' stamp: 'mp 3/14/2012 15:54:49.524'!
buildSwitchesWith: builder
	"Build the instance/comment/invariant/class switches"
	| panelSpec buttonSpec |
	panelSpec := builder pluggablePanelSpec new.
	panelSpec children: OrderedCollection new.

	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec 
			model: self;
			label: 'inst'; 
			state: #instanceMessagesIndicated; 
			action: #indicateInstanceMessages;
			frame: (0@0 corner: 0.31@1).
	panelSpec children addLast: buttonSpec.

	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec 
			model: self;
			label: '?'; 
			state: #classCommentIndicated; 
			action: #plusButtonHit;
			frame: (0.33@0 corner: 0.47@1).
	panelSpec children addLast: buttonSpec.
	
	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec 
			model: self;
			label: 'inv'; 
			state: #invariantsShown; 
			action: #toggleInvariants;
			color: #invariantsButtonColor;
			enabled: #hasInvariants;
			frame: (0.49@0 corner: 0.65@1).
	panelSpec children addLast: buttonSpec.

	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec 
			model: self;
			label: 'class'; 
			state: #classMessagesIndicated; 
			action: #indicateClassMessages;
			frame: (0.67@0 corner: 1@1).
	panelSpec children addLast: buttonSpec.

	^ panelSpec! !

!SBrowser methodsFor: 'toolbuilder' stamp: 'mp 3/21/2011 16:12:16.756'!
buildTestCoverageListWith: builder
	| listSpec |
	listSpec := builder pluggableListSpec new.
	listSpec 
		model: self;
		list: #coverageList;
		setIndex: #coverageListIndex:.
	^listSpec! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 3/23/2011 11:40:43.571'!
cacheConcerns
	"Answer the value of cacheConcerns"

	^ cacheConcerns ifNil: [IdentityDictionary new]! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 3/23/2011 11:26:58.331'!
cacheConcerns: anObject
	"Set the value of cacheConcerns"

	cacheConcerns := anObject! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 3/21/2011 15:06:25.408'!
cacheCoverage
	"Answer the value of cacheCoverage"

	^ cacheCoverage ifNil: [{}]! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 3/21/2011 15:05:36.58'!
cacheCoverage: anObject
	"Set the value of cacheCoverage"

	cacheCoverage := anObject! !

!SBrowser methodsFor: 'start tools' stamp: 'mp 3/7/2011 22:10:54.281'!
choseTest: aCollectionOfTests

	^ UIManager default 
				chooseFrom: (aCollectionOfTests collect: [:each | each asStringOrText]) 
				values: aCollectionOfTests 
				lines: #() 
				title: 'Choose entry point'.! !

!SBrowser methodsFor: 'list reset' stamp: 'mp 3/14/2012 16:33:12.007'!
classListIndex: anInteger 
	self codeSource: nil.
	super classListIndex: anInteger.
	self selectedMethodReference ifNil: [self resetCaches].
	anInteger = 0
		ifFalse: [SPMPathMap allInstances do: [:each |
					[(each getClassMorph: self selectedClass) highlight] on: Error do: []]].! !

!SBrowser methodsFor: 'start tools' stamp: 'tfel 7/14/2011 16:57:47.819'!
classListMenu: aMenu shifted: shifted
	"Set up the menu to apply to the receiver's class list, honoring the #shifted boolean"
	shifted ifTrue:[^ self shiftedClassListMenu: aMenu].
	aMenu addList: #(
		-
		('browse full (b)'			browseMethodFull)
		('browse hierarchy (h)'		spawnHierarchy)
		('browse protocol (p)'		browseFullProtocol)
		('browse with PathView'	browseWithPathView)
		-
		('printOut'					printOutClass)
		('fileOut'					fileOutClass)
		-
		('show hierarchy'			hierarchy)
		('show definition'			editClass)
		('show comment'			editComment)
		-
		('inst var refs...'			browseInstVarRefs)
		('inst var defs...'			browseInstVarDefs)
		-
		('class var refs...'			browseClassVarRefs)
		('class vars'					browseClassVariables)
		('class refs (N)'				browseClassRefs)
		-
		('rename class ...'			renameClass)
		('copy class'				copyClass)
		('remove class (x)'			removeClass)
		-
		('find method...'				findMethod)
		('find method wildcard...'	findMethodWithWildcard)
		-
		('more...'					offerShiftedClassListMenu)).
	^ aMenu
! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 6/1/2011 13:21:02.012'!
codePane
	^ self dependents detect: [:each | each knownName = 'codePane']! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 3/14/2012 15:59:25.337'!
codeSource
	"Answer the value of codeSource"

	^ codeSource! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 3/14/2012 15:59:25.348'!
codeSource: anObject
	"Set the value of codeSource"

	codeSource := anObject! !

!SBrowser methodsFor: 'coverage list' stamp: 'mp 9/21/2011 13:57:47.019'!
computeOchiaiFor: aDictionary with: aTracer

	^ ((self mergeByteCodes: aDictionary) 
		collect: [:each | self ochiaiForByteCode: each from: aDictionary with: aTracer]) 
		sorted: [:a :b | a value first < b value first]! !

!SBrowser methodsFor: 'concerns' stamp: 'mp 3/23/2011 11:55:49.883'!
concernColors
	^ SProject current concerns colors! !

!SBrowser methodsFor: 'concerns' stamp: 'mp 3/23/2011 14:22:33.975'!
concernGroups
	^ SProject current concerns groups! !

!SBrowser methodsFor: 'concerns' stamp: 'mp 3/23/2011 12:25:05.84'!
concernMapping
	^ SProject current concerns mapping! !

!SBrowser methodsFor: 'controls-prepost' stamp: 'mp 3/14/2012 16:22:08.598'!
conditionButtonColor
	"If conditions are shown currently, highlight the buttons"
	| method |
	method := currentCompiledMethod.
	((method isKindOf: DCContractWrapper) and: [Preferences decorateBrowserButtons])
		ifFalse: [^ Color gray].
	(self preconditionsShown or: [self postconditionsShown]) ifTrue: 
		[^ Color yellow muchLighter lighter].
	^ Color transparent
! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 3/14/2012 17:01:03.416'!
contents
	"Depending on browser state display different source code"
	| source |
	self invariantsShown ifTrue: [
			source := (self selectedClassOrMetaClass organization invariantMethod
				getSourceFor: #invariants 
				in: (self selectedClassOrMetaClass))].
	
	[self postconditionsShown ifTrue: [
		source := (currentCompiledMethod afterMethod 
				getSourceFor: (currentCompiledMethod selector) 
				in: (self selectedClassOrMetaClass))].
	
	self preconditionsShown ifTrue: [
		source := (currentCompiledMethod beforeMethod 
				getSourceFor: (currentCompiledMethod selector) 
				in: (self selectedClassOrMetaClass))]] 
		on: Error do: ["After removing contracts browser inconsistency are possible"].
	
	source ifNotNil: [^ self editContentsWithDefault: 
		[source copy asText makeSelectorBoldIn: self selectedClassOrMetaClass]].
	^ super contents! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 3/14/2012 16:34:42.747'!
contents: input notifying: aController 
	"Provide a hook to save code of invariants"
	| aString methodNode |
	self invariantsShown ifFalse: [^ super contents: input notifying: aController].
	self selectedClassOrMetaClass organization invariantMethod ifNil: 
		[self error: 'Cannot create new method in invariant mode!!'].
	
	self changed: #annotation.
	aString := input asString.
	methodNode := self methodNodeFrom: aString notifying: nil.
	self selectedClassOrMetaClass organization invariantMethod: (methodNode method).
	^ true! !

!SBrowser methodsFor: 'coverage list' stamp: 'mp 5/12/2011 14:14:45.654'!
coverageList
	| coveredTests method |
	self refreshRequired ifFalse: [^ self cacheCoverage].
	method := self selectedMethodReference.
	method 
		ifNotNil: [coveredTests := self coveredTestsSortedFor: method.
				 self cacheCoverage: coveredTests].
	^ self cacheCoverage! !

!SBrowser methodsFor: 'coverage list' stamp: 'mp 7/4/2011 12:58:37.758'!
coverageListIndex: anInteger
	| testReference |
	anInteger <= 0 ifTrue: [^ self].
	testReference := self cacheCoverage at: anInteger.
	(UIManager default 
		chooseFrom: {'PathFinder'. 'Debugger'. 'Browser'} 
		values: {#openPathFinderOn:. #openDebuggerOn:. #openBrowserOn:} 
		lines: #() 
		title: 'Choose tool')
			ifNotNil: [:choice | 
				self perform: choice with: testReference asMethodReference].
	! !

!SBrowser methodsFor: 'coverage list' stamp: 'mp 3/21/2011 16:52:32.908'!
coveredTestsSortedFor: aMethodReference
	^ (SProject current coveredTestsFor: aMethodReference)
		asSortedCollection: [:a :b | a asMethodReference <= b asMethodReference]! !

!SBrowser methodsFor: 'start tools' stamp: 'tfel 7/7/2011 12:09:59.695'!
createPathView
	| project |
	project := SMultipleChoiceRequest
		prompt: 'Create a view in which project?'
		labels: SProject allProjectNames
		values: SProject allProjects.
	project ifNil: [^ self].
	SProject setCurrentProject: project.
	SPathView openOn: self selectedClass.
! !

!SBrowser methodsFor: 'accessing' stamp: 'abc 5/10/2010 17:46'!
currentSelectedMethod
	"Answer the value of currentSelectedMethod"

	^ currentSelectedMethod! !

!SBrowser methodsFor: 'accessing' stamp: 'abc 5/10/2010 17:46'!
currentSelectedMethod: anObject
	"Set the value of currentSelectedMethod"

	currentSelectedMethod := anObject! !

!SBrowser methodsFor: 'initialize-release' stamp: 'mp 3/7/2011 21:41:49.34'!
defaultBrowserTitle

	^ 'PathBrowser'! !

!SBrowser methodsFor: 'message functions' stamp: 'mp 3/14/2012 16:37:55.399'!
defineMessageFrom: aString notifying: aController
	"If contracts exist for the compiled method, store the code at the right place"
	| methodNode |
	currentCompiledMethod class = DCContractWrapper ifFalse: 
		[^ super defineMessageFrom: aString notifying: aController].
	
	methodNode := self methodNodeFrom: aString notifying: aController.
	self preconditionsShown 
		ifTrue: [currentCompiledMethod beforeMethod: methodNode method]
		ifFalse: 
			[self postconditionsShown 
				ifTrue:  [currentCompiledMethod afterMethod: methodNode method.]
				ifFalse: [currentCompiledMethod clientMethod: methodNode method]].
	contents := aString copy.
	^ methodNode selector.! !

!SBrowser methodsFor: 'coverage list' stamp: 'mp 9/21/2011 13:59:34.78'!
faultLocalizationAtStatements: aTracer
	| byteCodes |
	self flag: #mpe. "ToDo: Redundancy to SDebuggerCodePane (and following methods)"
	self selectedMethodReference ifNil: [^ self inform: 'Select a method first.'].
	byteCodes := self getCoveredByteCodes.
	byteCodes := self computeOchiaiFor: byteCodes with: aTracer.
	self highlightAnomaliesAtStatements: byteCodes.! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 5/12/2010 18:26'!
filterProjectCategories
	"Answer the value of filterProjectCategories"

	^ filterProjectCategories ifNil: [filterProjectCategories := false]! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 5/12/2010 18:26'!
filterProjectCategories: anObject
	"Set the value of filterProjectCategories"

	filterProjectCategories := anObject! !

!SBrowser methodsFor: 'concerns' stamp: 'mp 3/23/2011 11:48:58.792'!
getChildrenConcerns: anObject
	^ (self cacheConcerns at: anObject) asSortedCollection! !

!SBrowser methodsFor: 'coverage list' stamp: 'mp 5/11/2011 11:55:47.364'!
getCoveredByteCodes
	| wrapper |
	self flag: #mpe. "ToDo: Needs Refactoring - quite similar to SDebuggerCodePane"
	[wrapper := SMethodByteCodeCoverageForAllTestsWrapper 
					on: self selectedMethodReference.
	wrapper install.
	self coverageList
		do: [:each | wrapper currentTest: each.
				     each execute] 
		displayingProgress: [:each | 
			'Processing ', each asString, ' out of ', 
			self coverageList size asString, ' Entry Points.']]
	ensure: [wrapper uninstall].
	^ wrapper coveredByteCodes
! !

!SBrowser methodsFor: 'concerns' stamp: 'mp 3/23/2011 11:48:11.743'!
hasChildrenConcerns: anObject
	^ self cacheConcerns includesKey: anObject! !

!SBrowser methodsFor: 'controls-prepost' stamp: 'mp 3/14/2012 16:21:33.251'!
hasConditions
	^ (currentCompiledMethod isContractWrapper)! !

!SBrowser methodsFor: 'controls-inavariants' stamp: 'mp 3/14/2012 15:55:44.128'!
hasInvariants
	^ (self selectedClassOrMetaClass notNil and: 
		   [self selectedClassOrMetaClass organization invariantMethod notNil])! !

!SBrowser methodsFor: 'coverage list' stamp: 'mp 9/21/2011 14:01:30.335'!
highlightAnomaliesAtStatements: supicousByteCodes
	| method map stream range |
	method := self selectedMethodReference compiledMethod.
	map := (DebuggerMethodMap forMethod: method).
	supicousByteCodes do: [:each | 
		stream := (InstructionStream on: method).
		stream pc: each key.
		(stream willReallySend or: [stream willReturn])
			ifTrue: [range := map rangeForPC: each key contextIsActiveContext: true.
					self codePane text 
						addAttribute: (TextColor 
										color: (Color 
												h: 120 * (1.0 - each value first) 
												s: each value second
												v: 1.0)) 
						from: range first 
						to: range last;
						addAttribute: TextEmphasis underlined
						from: range first 
						to: range last]].
			self codePane selectAll; changed.! !

!SBrowser methodsFor: 'concerns' stamp: 'mp 3/23/2011 11:56:03.104'!
iconForConcernItem: anObject
	| icon |
	(self concernColors includesKey: anObject)
		ifTrue: [
			icon := Form extent: 15@15 depth: 32.
			icon fillColor: (self concernColors at: anObject).
			^ icon].
	^ nil! !

!SBrowser methodsFor: 'controls' stamp: 'mp 3/14/2012 16:39:03.886'!
indicateClassMessages
	"If browser is toggled to class code, clear pane from any contract-sourcecode"
	self codeSource: nil.
	^ super indicateClassMessages! !

!SBrowser methodsFor: 'controls' stamp: 'mp 3/14/2012 16:40:14.08'!
indicateInstanceMessages
	"If browser is toggled to instance code, clear pane from any contract-sourcecode"
	self codeSource: nil.
	^ super indicateInstanceMessages! !

!SBrowser methodsFor: 'types harvester' stamp: 'mp 3/19/2011 18:39:55.191'!
instVarTypeLabelFor: aWord
	| index type |
	index := self selectedClassOrMetaClass allInstVarNames indexOf: aWord.
	index = 0
		ifFalse: [
			SProject current typesBucket ifNil: [^ 'Run type harvester first'].
			type := (SProject current typesBucket 
					memberTypeFor: index 
					in: self selectedClassOrMetaClass).
			type 
				ifNil: [^ 'No type available']
				ifNotNil: [^ type asString]].
	^ ''! !

!SBrowser methodsFor: 'controls-inavariants' stamp: 'mp 3/14/2012 15:57:23.984'!
invariantsButtonColor
	"Highlight inv button, if invariants are currently shown"
	(self selectedClassOrMetaClass isNil or: 
	[self selectedClassOrMetaClass organization invariantMethod isNil]) 
		ifTrue: [^ Color gray].
	self invariantsShown ifTrue: [^ Color yellow muchLighter lighter].
	^ Color transparent! !

!SBrowser methodsFor: 'controls-inavariants' stamp: 'mp 3/14/2012 15:58:26.193'!
invariantsShown
	^ self codeSource = #invariants or: [self editSelection = #editInvariants]! !

!SBrowser methodsFor: 'concerns' stamp: 'mp 3/23/2011 12:00:01.39'!
involvedConcerns
	| tests concerns projectConcerns |
	tests := self coveredTestsSortedFor: self selectedMethodReference.
	concerns := IdentityDictionary new. 
	tests 
		ifNotEmpty: [
			projectConcerns := SProject current concerns.
			projectConcerns groups keysDo: [:group |
				concerns at: group put: IdentitySet new.
				tests do: [:test | 
					concerns 
						at: group 
						put: ((concerns at: group),
							(projectConcerns 
								concernsOfGroup: group 
								andTest: test asMethodReference))]]].
		^ concerns! !

!SBrowser methodsFor: 'concerns' stamp: 'mp 3/23/2011 11:51:20.355'!
labelConcern: anObject

	^ anObject asString! !

!SBrowser methodsFor: 'coverage list' stamp: 'mp 9/21/2011 13:26:20.1'!
mergeByteCodes: aDictionary
	^ aDictionary values inject: Set new into: [:set :each | set := set, each]! !

!SBrowser methodsFor: 'list reset' stamp: 'mp 3/24/2011 17:16:12.377'!
messageCategoryListIndex: anInteger
	super messageCategoryListIndex: anInteger.
	self selectedMethodReference ifNil: [self resetCaches].
	anInteger = 0
		ifFalse: [SPMPathMap allInstances do: [:each |
					[(each 
						getMethodCategoryMorph: self selectedClassOrMetaClass 
						and: self selectedMessageCategoryName)
							highlight] on: Error do: []]].! !

!SBrowser methodsFor: 'list reset' stamp: 'mp 3/14/2012 16:41:44.054'!
messageListIndex: anInteger
	| ref |
	super messageListIndex: anInteger.
	anInteger = 0 "Deselect"
		ifTrue: [self 
					currentSelectedMethod: nil;
					resetCaches].
	self selectedMessageName 
		ifNil: [
			(self cacheCoverage size = 0 and: [self cacheConcerns isEmpty]) 
				ifTrue: [^ self].
			self resetCaches]
		ifNotNil: [
			ref := MethodReference 
					class: self selectedClassOrMetaClass 
					selector: self selectedMessageName.
			(self currentSelectedMethod isNil or: 
				[(self currentSelectedMethod = ref) not])
					ifTrue: [self refreshAdditionalLists].
			self currentSelectedMethod: ref].
	anInteger = 0
		ifFalse: [SPMPathMap allInstances do: [:each |
					[(each 
						getMethodMorph: self selectedClassOrMetaClass 
						and: self selectedMessageName) highlight] on: Error do: []]].
	"Force refresh for pre- and postconditions to show up"
	((self preconditionsShown) or: [self postconditionsShown]) 
		ifTrue: [	self selectedMessage.
				self changed: #contents]! !

!SBrowser methodsFor: 'start tools' stamp: 'tfel 7/14/2011 12:28:28.171'!
messageListMenu: aMenu shifted: shifted 
	"Answer the message-list menu"
	"(self menuHook: aMenu named: #messageListMenu shifted: shifted) ifTrue:[^aMenu]."
	shifted ifTrue: [^ self shiftedMessageListMenu: aMenu].
	aMenu addList: #(
			('what to show...'			offerWhatToShowMenu)
			('toggle break on entry'		toggleBreakOnEntry)
			-
			('browse full (b)' 			browseMethodFull)
			('browse hierarchy (h)'			classHierarchy)
			('browse method (O)'			openSingleMessageBrowser)
			('browse protocol (p)'			browseFullProtocol)
			('browse path' 			browsePath)
			-
			('fileOut'				fileOutMessage)
			('printOut'				printOutMessage)
			-
			('senders of... (n)'			browseSendersOfMessages)
			('implementors of... (m)'		browseMessages)
			('inheritance (i)'			methodHierarchy)
			('versions (v)'				browseVersions)
			-
			('inst var refs...'			browseInstVarRefs)
			('inst var defs...'			browseInstVarDefs)
			('class var refs...'			browseClassVarRefs)
			('class variables'			browseClassVariables)
			('class refs (N)'			browseClassRefs)
			-
			('remove method (x)'			removeMessage)
			-
			('more...'				shiftedYellowButtonActivity)).
	^ aMenu! !

!SBrowser methodsFor: 'message functions' stamp: 'mp 3/14/2012 16:43:58.946'!
methodNodeFrom: aString notifying: aController
	"Compile the string storing the source code"
	| methodNode |
	methodNode := (self selectedClassOrMetaClass 
		compile:  aString
		classified: self selectedMessageCategoryName
		notifying: aController
		trailer: Object defaultMethodTrailer
		ifFail: [^ nil]).
	methodNode == nil ifTrue: [^ nil].
	methodNode method putSource: aString fromParseNode: methodNode node inFile: 2
			withPreamble: [:f | f cr; nextPut: $!!; nextChunkPut: 'Contract method'; cr].
	^ methodNode! !

!SBrowser methodsFor: 'types harvester' stamp: 'mp 1/4/2012 20:35:13.401'!
methodTypesLabelFor: aWord
	| method temps index type |
	(SProject current allClasses includes: self selectedClassOrMetaClass instanceSide)
		ifTrue: [
			method := self selectedClassOrMetaClass >> self selectedMessageName.
			temps := method methodNode arguments, method methodNode temporaries.
			temps ifNotEmpty: [
				temps := temps collect: [:each | each name].
				index := temps indexOf: aWord.
				index = 0
					ifFalse: [SProject current typesBucket 
								ifNil: [^ 'Run type harvester first'].
						type := (SProject current typesBucket 
									tempTypeAt: index in: method).
						type 
							ifNil: [^ 'No type available']
							ifNotNil: [^ type asString]]].
			(self selectedMessageName asString beginsWith: aWord)
				ifTrue: [SProject current typesBucket 
							ifNil: [^ 'Run type harvester first'].
					type := (SProject current typesBucket 
								returnTypeFor: method).
					type 
						ifNil: [^ '^ No type available']
						ifNotNil: [^ '^ ', type asString]]].
	^ ''! !

!SBrowser methodsFor: 'concerns' stamp: 'mp 3/23/2011 14:03:13.299'!
methodsCoveredBy: aCollection
	| key |
	^ aCollection inject: Set new into: [:set :each | 
		key := SProject current coverage keys 
							detect: [:test | test asMethodReference = each] ifNone: [nil].
		key ifNotNil: [set addAll: (SProject current coverage at: key) keys].
		set yourself]! !

!SBrowser methodsFor: 'coverage list' stamp: 'mp 9/21/2011 13:58:24.593'!
ochiaiForByteCode: aByteCode from: aDictionary with: aTracer
	| coveredTests failuresAtByteCode passedAtByteCode allFailures suspiciousness confidence |
	allFailures := aTracer allFailures.
	coveredTests := aDictionary keys 
							select: [:test | (aDictionary at: test) includes: aByteCode].
	failuresAtByteCode := aTracer failuresFrom: coveredTests.		
	passedAtByteCode := coveredTests size - failuresAtByteCode.
	(allFailures = 0 or: [failuresAtByteCode = 0]) 
		ifTrue: [suspiciousness := 0.0. 
			     confidence := 1.0]
		ifFalse: [suspiciousness := (failuresAtByteCode / 
				((allFailures * (failuresAtByteCode + passedAtByteCode)) sqrt)). 
				confidence := (failuresAtByteCode / allFailures).].
	^ aByteCode -> {suspiciousness. confidence}! !

!SBrowser methodsFor: 'start tools' stamp: 'mp 7/4/2011 13:00:43.125'!
openBrowserOn: chosenTest
	^ Browser fullOnClass: chosenTest actualClass selector: chosenTest methodSymbol
	! !

!SBrowser methodsFor: 'start tools' stamp: 'mp 3/21/2011 16:29:04.11'!
openDebuggerOn: aMethodReference
	| method |
	method := self selectedMethodReference.
	[SBreakpointManager 
		installInClass: method actualClass selector: method methodSymbol.
	aMethodReference actualClass run: aMethodReference methodSymbol] 
		ensure: [SBreakpointManager unInstall: method compiledMethod].! !

!SBrowser methodsFor: 'initialize-release' stamp: 'mp 3/14/2012 16:25:51.253'!
openEditString: aString
        "Create a pluggable version of all the views for a Browser, including views and controllers."
	"Example: 
		Browser fullOnClass: Browser.
	"
	| builder max |
	builder := ToolBuilder default.
	max := self wantsOptionalButtons ifTrue:[0.42] ifFalse:[0.5].
	^self buildWindowWith: builder specs: {
		(0@0 corner: 0.2@max) -> [self buildSystemCategoryListWith: builder].
		(0.2@0 corner: 0.4@(max-0.08)) -> [self buildClassListWith: builder].
		(0.2@(max-0.08) corner: 0.4@max) -> [self buildSwitchesWith: builder].
		(0.4@0 corner: 0.6@max) -> [self buildMessageCategoryListWith: builder].
		(0.6@0 corner: 0.8@(max-0.08)) -> [self buildMessageListWith: builder].
		(0.6@(max-0.08) corner: 0.8@max) -> [self buildContractSwitchesWith: builder].
		(0.8@0 corner: 1.0@max) -> [self buildTestCoverageListWith: builder].
		(0.8@0.5 corner: 1.0@1.0) -> [self buildConcernTreeWith: builder].
		(0@max corner: 1@0.5) -> [self buildOptionalButtonsWith: builder].
		(0@0.5 corner: 0.8@1) -> [self buildCodePaneWith: builder].
	}! !

!SBrowser methodsFor: 'start tools' stamp: 'mp 3/21/2011 16:25:17.585'!
openPathFinderOn: chosenTest

	^ SPathFinder openOn: chosenTest and: self selectedMethodReference! !

!SBrowser methodsFor: 'controls' stamp: 'tfel 7/8/2011 09:14:38.98'!
optionalButtonPairs
	^ super optionalButtonPairs asOrderedCollection
			addLast: #('coverage' statementCoverage
				'Compute statement coverage provided by tests covering this method');
			addLast: #('path views' browseWithPathView
				'open PathViews with this class');
			yourself! !

!SBrowser methodsFor: 'controls-prepost' stamp: 'mp 3/14/2012 16:07:53.461'!
postconditionsShown
	^ self codeSource = #postconditions! !

!SBrowser methodsFor: 'controls-prepost' stamp: 'mp 3/14/2012 16:08:08.661'!
preconditionsShown
	^ self codeSource = #preconditions! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 5/12/2010 11:39'!
previousMethod
	"Answer the value of previousMethod"

	^ previousMethod! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 5/12/2010 11:39'!
previousMethod: anObject
	"Set the value of previousMethod"

	previousMethod := anObject! !

!SBrowser methodsFor: 'updating' stamp: 'mp 3/23/2011 12:02:25.824'!
refreshAdditionalLists
	self 
		refreshRequired: true;
		changed: #coverageList;
		changed: #rootsConcerns;
		refreshRequired: false.! !

!SBrowser methodsFor: 'accessing' stamp: 'abc 5/10/2010 19:09'!
refreshRequired
	"Answer the value of refreshRequired"

	^ refreshRequired ifNil: [refreshRequired := false]! !

!SBrowser methodsFor: 'accessing' stamp: 'abc 5/10/2010 19:07'!
refreshRequired: anObject
	"Set the value of refreshRequired"

	refreshRequired := anObject! !

!SBrowser methodsFor: 'list reset' stamp: 'mp 3/23/2011 11:28:21.757'!
resetCaches
	self 
		cacheCoverage: nil;
		cacheConcerns: nil;
		refreshAdditionalLists.! !

!SBrowser methodsFor: 'concerns' stamp: 'mp 3/23/2011 12:03:43.35'!
rootsConcerns
	(self refreshRequired and: [self selectedMethodReference notNil]) 
		ifTrue: [self cacheConcerns: self involvedConcerns].
	^ (self cacheConcerns keys 
		reject: [:each | (self cacheConcerns at: each) isEmpty]) asSortedCollection! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 7/7/2010 16:51:21.96'!
selectedCategories
	
	^ SProject current categories! !

!SBrowser methodsFor: 'types harvester' stamp: 'mp 1/4/2012 20:34:28.423'!
selectedClassInPartialTrace
	^ SProject current allClasses includes: self selectedClassOrMetaClass instanceSide! !

!SBrowser methodsFor: 'concerns' stamp: 'mp 3/23/2011 14:27:44.78'!
selectedConcernItem: anObject
	| tests group label |
	anObject ifNil: [^ self].
	group := self cacheConcerns includesKey: anObject.
	tests := group
				ifTrue: [self testsForConcerns: (self concernGroups at: anObject)]
				ifFalse: [self testsForConcerns: {anObject}].
	label := 'Methods of ', anObject asString, ' concern'.
	group ifTrue: [label := label, ' group'].
	SystemNavigation default
		browseMessageList: (self methodsCoveredBy: tests) asSortedCollection
		name: label
! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 5/12/2011 14:13:34.318'!
selectedMethodReference
	(self selectedClassOrMetaClass isNil or: [self selectedMessageName isNil])
		ifTrue: [^ nil].
	^ MethodReference 
		class: self selectedClassOrMetaClass selector: self selectedMessageName.! !

!SBrowser methodsFor: 'updating' stamp: 'mp 3/21/2011 16:25:26.401'!
setMethodRefAndRefreshSendersSelection: aMethodRef

	| prevRef |
	prevRef := self selectedMethodReference.
	self setClass: aMethodRef actualClass selector: aMethodRef methodSymbol.
	self setSelectionInSendersFrom: prevRef! !

!SBrowser methodsFor: 'updating' stamp: 'mp 5/12/2010 11:48'!
setSelectionInImplementorsFrom: aMethodReference

		self previousMethod: aMethodReference.
		self changed: #implementorsListIndex.
		self previousMethod: nil.
		self changed: #senderListIndex! !

!SBrowser methodsFor: 'updating' stamp: 'mp 5/12/2010 11:47'!
setSelectionInSendersFrom: aMethodReference

		self previousMethod: aMethodReference.
		self changed: #senderListIndex.
		self previousMethod: nil.
		self changed: #implementorsListIndex! !

!SBrowser methodsFor: 'coverage list' stamp: 'mp 9/21/2011 14:07:54.241'!
statementCoverage
	| byteCodes method map stream range |
	self flag: #mpe. "ToDo: Needs Refactoring - quite similar to 
						SCodePane>>#byteCodeCoverage"
	self selectedMethodReference ifNil: [^ self inform: 'Select a method first.'].
	byteCodes := self mergeByteCodes: self getCoveredByteCodes.
	method := self selectedMethodReference compiledMethod.
	map := (DebuggerMethodMap forMethod: method).
	byteCodes do: [:each | 
		stream := (InstructionStream on: method).
		stream pc: each.
		(stream willReallySend or: [stream willReturn])
			ifTrue: [range := map rangeForPC: each contextIsActiveContext: true.
					self codePane text
						addAttribute: TextEmphasis underlined
						from: range first 
						to: range last]].
	self codePane changed.! !

!SBrowser methodsFor: 'list reset' stamp: 'mp 3/14/2012 16:42:10.605'!
systemCategoryListIndex: anInteger 
	self codeSource: nil.
	super systemCategoryListIndex: anInteger.
	self selectedMethodReference ifNil: [self resetCaches].
	anInteger = 0
		ifFalse: [SPMPathMap allInstances do: [:each |
					[(each getCategoryMorph: self selectedSystemCategoryName)
						 highlight] on: Error do: []]].! !

!SBrowser methodsFor: 'concerns' stamp: 'mp 3/23/2011 12:53:32.926'!
testsForConcerns: aCollection
	| set |
	set := Set new.
	aCollection do: [:concern | 
		set addAll: (self concernMapping at: concern)].
	^ set! !

!SBrowser methodsFor: 'controls-inavariants' stamp: 'mp 3/14/2012 16:04:58.508'!
toggleInvariants
	"Toggle code pane between displaying invariants and regular class / instance code"
	self selectedClassOrMetaClass ifNil: [^ self].
	self codeSource: nil.
	((self editSelection = #editInvariants) or: 
	 [self selectedClassOrMetaClass organization invariantMethod isNil])
		ifTrue: [currentCompiledMethod := nil.
			"automatically sets editSelection to message"
			self messageCategoryListIndex: 0]
		ifFalse: [self metaClassIndicated 
			ifTrue:  
				[currentCompiledMethod := self selectedClassOrMetaClass class organization invariantMethod]
			ifFalse: 
				[currentCompiledMethod := self selectedClassOrMetaClass organization invariantMethod].
			self messageCategoryListIndex: 0;
				contentsSymbol: #source;
				editSelection: #editInvariants].
	self 
		changed: #classSelectionChanged;
		changed: #messageCategoryList;
		changed: #messageList;
		decorateButtons;
		contentsChanged! !

!SBrowser methodsFor: 'controls-prepost' stamp: 'mp 3/14/2012 16:27:26.196'!
togglePostconditions
	"Toggle code pane between displaying postconditions and method source"
	((self codeSource = #postconditions) or: 
	[currentCompiledMethod isContractWrapper not]) 
		ifTrue: [self codeSource: nil]
		ifFalse: [self codeSource: #postconditions].

	contents := nil.
	self contentsChanged! !

!SBrowser methodsFor: 'controls-prepost' stamp: 'mp 3/14/2012 16:26:35.729'!
togglePreconditions
	"Toggle code pane between displaying preconditions and method source"
	((self codeSource = #preconditions) or: 
	[currentCompiledMethod isContractWrapper not])
		ifTrue: [self codeSource: nil]
		ifFalse: [self codeSource: #preconditions.].
	
	contents := nil.
	self contentsChanged! !

!SBrowser methodsFor: 'types harvester' stamp: 'mp 5/3/2011 16:07:31.034'!
update: aWord with: aTextMorph
	| label |	
	label := ''.
	self selectedClassOrMetaClass
		ifNotNil: [self selectedClassInPartialTrace
					ifTrue: [label := self selectedMessageName
										ifNil: [self instVarTypeLabelFor: aWord]
										ifNotNil: [self methodTypesLabelFor: aWord]]].
	aTextMorph labelMorph createLabelMorph: label.! !

AlignmentMorph subclass: #SNavigationBarMorph
	instanceVariableNames: 'itemList hiddenMorphs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!SNavigationBarMorph methodsFor: 'accessing' stamp: 'mp 1/6/2010 16:29'!
addItem: anObject withSelector: aSymbol

	self itemList ifNotEmpty: [self addSeparator].	
	self itemList add: anObject.
	self createActionStringMorphOn: anObject withSelector: aSymbol.
	! !

!SNavigationBarMorph methodsFor: 'accessing' stamp: 'mp 3/1/2010 16:15'!
addItems: aCollection withSelector: aSymbol

	aCollection do: [:each | self addItem: each withSelector: aSymbol].
	self reduceMorphsInTheMiddle.! !

!SNavigationBarMorph methodsFor: 'accessing' stamp: 'mp 3/1/2010 16:27'!
addSeparator

	self addMorphBack: self separatorMorph.
	
! !

!SNavigationBarMorph methodsFor: 'building' stamp: 'mp 7/7/2010 16:43:21.452'!
createActionStringMorphOn: anObject withSelector: aSymbol

	| stringMorph |
	stringMorph := SActionStringMorph on: anObject selector: aSymbol.
	stringMorph font: (StrikeFont familyName: 'BitstreamVeraSans' size: 9).
	self addMorphBack: stringMorph.
	
! !

!SNavigationBarMorph methodsFor: 'initialization' stamp: 'mp 1/6/2010 16:09'!
defaultBorderColor
	"answer the default color/fill style for the receiver"
	^ Color r: 0.835 g: 0.835 b: 0.835! !

!SNavigationBarMorph methodsFor: 'initialization' stamp: 'mp 1/6/2010 15:48'!
defaultBorderWidth

	^ 1! !

!SNavigationBarMorph methodsFor: 'initialization' stamp: 'mp 1/6/2010 16:06'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color white! !

!SNavigationBarMorph methodsFor: 'as yet unclassified' stamp: 'mp 3/4/2010 14:26'!
extent: aPoint

	super extent: aPoint.
	"Required for collapse systemwindow"
	aPoint y = 0
		ifTrue: [self hide]
		ifFalse: [self show].! !

!SNavigationBarMorph methodsFor: 'accessing' stamp: 'mp 3/1/2010 16:17'!
getCurrentStringWidth

	^ self submorphs inject: 0 into: [:sum :each | each width + sum]! !

!SNavigationBarMorph methodsFor: 'accessing' stamp: 'mp 3/1/2010 16:30'!
hiddenMorphs
	"Answer the value of hiddenMorphs"

	^ hiddenMorphs ifNil: [hiddenMorphs := OrderedCollection new]! !

!SNavigationBarMorph methodsFor: 'accessing' stamp: 'mp 3/1/2010 16:29'!
hiddenMorphs: anObject
	"Set the value of hiddenMorphs"

	hiddenMorphs := anObject! !

!SNavigationBarMorph methodsFor: 'initialization' stamp: 'mp 3/4/2010 10:34'!
initialize
	super initialize.
	self 
		itemList: OrderedCollection new;
		addSeparator;
		listDirection: #leftToRight;
		hResizing: #spaceFill;
		vResizing: #spaceFill.! !

!SNavigationBarMorph methodsFor: 'accessing' stamp: 'mp 1/6/2010 15:43'!
itemList
	^ itemList! !

!SNavigationBarMorph methodsFor: 'accessing' stamp: 'mp 1/6/2010 15:43'!
itemList: anObject
	itemList := anObject! !

!SNavigationBarMorph methodsFor: 'actions' stamp: 'mp 3/1/2010 16:47'!
listHiddenItems

	| choice |
	choice := UIManager default 
					chooseFrom: (self hiddenMorphs collect: [:each | each contents]) 
					values: self hiddenMorphs 
					lines: #() 
					title: 'Select Item'.
	choice ifNotNil: [choice performAction].
! !

!SNavigationBarMorph methodsFor: 'building' stamp: 'mp 7/7/2010 16:43:25.75'!
reduceMorphsInTheMiddle

	"summarize morphs [...] except the first and the last three strings"
	self getCurrentStringWidth > self width
		ifTrue: [
			self hiddenMorphs: (self submorphs copyFrom: 3 to: self submorphs size - 6).
			self removeAllMorphsIn: self hiddenMorphs.
			self hiddenMorphs: (self hiddenMorphs reject: [:each | each contents = self separator]).
			
			self addMorph: (SActionStringMorph on: self selector: #listHiddenItems name: '[...]') 
				asElementNumber: 4.
			self addMorph: self separatorMorph 
				asElementNumber: 5].
	! !

!SNavigationBarMorph methodsFor: 'accessing' stamp: 'mp 1/6/2010 16:39'!
removeAllItems

	self itemList: OrderedCollection new.
	self removeAllMorphs.
	self addSeparator.! !

!SNavigationBarMorph methodsFor: 'accessing' stamp: 'mp 1/6/2010 16:45'!
removeLastItem

	self itemList ifEmpty: [^ self].
	self itemList size = 1
		ifTrue: [
			self itemList removeLast.
			self removeAllMorphsIn: {self submorphs last.}.
			^ self].
	self itemList removeLast.
	self removeAllMorphsIn: {self submorphs last. self submorphs at: self submorphs size - 1.}! !

!SNavigationBarMorph methodsFor: 'accessing' stamp: 'mp 1/7/2010 17:42'!
separator

	^ ' >> '! !

!SNavigationBarMorph methodsFor: 'accessing' stamp: 'mp 3/1/2010 16:28'!
separatorMorph

	| stringMorph |
	stringMorph := StringMorph contents: self separator.
	stringMorph font: (StrikeFont familyName: 'BitstreamVeraSans' size: 9).
	^ stringMorph
	
! !

SNavigationBarMorph subclass: #SPathFindNaviBarMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!SPathFindNaviBarMorph methodsFor: 'building' stamp: 'mp 7/7/2010 16:43:32.392'!
createActionStringMorphOn: anObject withSelector: aSymbol

	| stringMorph |
	stringMorph := SActionStringMorph on: anObject selector: aSymbol name: anObject clientSelector asString.
	stringMorph font: (StrikeFont familyName: 'BitstreamVeraSans' size: 9).
	self addMorphBack: stringMorph.! !

!SPathFindNaviBarMorph methodsFor: 'accessing' stamp: 'mp 1/7/2010 17:47'!
separator

	^ ' -> '! !

!SPathFindNaviBarMorph methodsFor: 'updating' stamp: 'mp 1/31/2010 18:40'!
update: aCallNode

	aCallNode isNil 
		ifTrue: [self removeAllItems.
			      ^ self]. 
	aCallNode isLiteral
		ifTrue: [^ self].
	self 
		removeAllItems;
		addItems: aCallNode getCallStack withSelector: #setAsCurrentSelection.! !

TextMorphForEditView subclass: #STextMorphForEditView
	instanceVariableNames: 'labelMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!STextMorphForEditView class methodsFor: 'preferences' stamp: 'mp 3/10/2010 11:52'!
requiredSpaceForTwoCodeDigits

	^ Preferences standardCodeFont widthOfString: '00'! !

!STextMorphForEditView class methodsFor: 'constants' stamp: 'mp 3/10/2010 11:48'!
scaleFactorLeftMargin

	^ 1.5! !

!STextMorphForEditView methodsFor: 'drawing' stamp: 'mp 3/10/2010 12:48'!
drawLineNumber: aNumber on: aCanvas

	| str line |
	str := self getStringFor: aNumber.
	line := self paragraph lines at: aNumber.
	aCanvas
		drawString: str
		from: 1
		to: str size
		at: (self position x @ (line top + 2))
		font: Preferences standardCodeFont
		color: Color gray.! !

!STextMorphForEditView methodsFor: 'drawing' stamp: 'mp 3/10/2010 11:58'!
drawLineNumbersBorderOn: aCanvas

	| xOffset |
	xOffset := 4.
	aCanvas
		line: (self margins left - xOffset) @ aCanvas clipRect top
		to: (self margins left - xOffset) @ aCanvas clipRect bottom
		width: 1
		color: Color gray.! !

!STextMorphForEditView methodsFor: 'drawing' stamp: 'mp 3/10/2010 12:19'!
drawLineNumbersOn: aCanvas

	1 to: self paragraph numberOfLines do: [:lineNumber | 
		self drawLineNumber: lineNumber on: aCanvas].! !

!STextMorphForEditView methodsFor: 'drawing' stamp: 'mp 3/10/2010 14:37'!
drawOn: aCanvas

	super drawOn: aCanvas.
	self
		drawLineNumbersBorderOn: aCanvas;
		drawLineNumbersOn: aCanvas.! !

!STextMorphForEditView methodsFor: 'private' stamp: 'mp 3/10/2010 12:08'!
getStringFor: aNumber

	| twoDigits |
	twoDigits := aNumber \\ 100.
	^ (twoDigits < 10 ifTrue: ['  '] ifFalse: ['']), twoDigits asString.! !

!STextMorphForEditView methodsFor: 'type labels' stamp: 'mp 3/18/2011 21:52:07.713'!
handlesMouseOver: anEvent
	^ true! !

!STextMorphForEditView methodsFor: 'initialization' stamp: 'mp 3/10/2010 11:50'!
initialize

	| leftOffset |
	super initialize.
	leftOffset := (self class requiredSpaceForTwoCodeDigits * self class scaleFactorLeftMargin) rounded.
	self margins: ((leftOffset@0) corner: 0@0).! !

!STextMorphForEditView methodsFor: 'accessing' stamp: 'mp 3/18/2011 21:38:23.288'!
labelMorph
	"Answer the value of labelMorph"

	^ labelMorph ifNil: [labelMorph := SLabelMorph label: '']! !

!STextMorphForEditView methodsFor: 'accessing' stamp: 'mp 3/18/2011 21:34:16.236'!
labelMorph: anObject
	"Set the value of labelMorph"

	labelMorph := anObject! !

!STextMorphForEditView methodsFor: 'type labels' stamp: 'mp 3/18/2011 21:50:27.061'!
mouseLeave: evt
	super mouseLeave: evt.
	self removeMorph: self labelMorph.! !

!STextMorphForEditView methodsFor: 'type labels' stamp: 'mp 9/8/2011 17:46:22.085'!
mouseMove: evt
	| index word |
	super mouseMove: evt.
	index := (self paragraph characterBlockAtPoint: evt position) stringIndex.
	(self text notNil and: [index between: 1 and: self text size])
		ifTrue: [
			word := self wordAt: index.
			word isAllSeparators
				ifTrue: [self removeMorph: self labelMorph]
				ifFalse: [
					self changed: word with: self.
					(self labelMorph labelMorphs isEmpty or:
						[self labelMorph labelMorphs first contents = ''])
							ifTrue: [self removeMorph: self labelMorph]
							ifFalse: [self addMorph: self labelMorph.
									self labelMorph position: evt position + self position]]].! !

!STextMorphForEditView methodsFor: 'type labels' stamp: 'mp 3/18/2011 21:33:08.326'!
trimWord: aString
	^ aString select: [:each | each isLetter or: [each isDigit]]! !

!STextMorphForEditView methodsFor: 'type labels' stamp: 'mp 3/18/2011 21:22:47.069'!
wordAt: anIndex
	| start stop |
	start := anIndex.
	stop := anIndex.
	[stop <= self text size and: [(self text at: stop) isSeparator not]]
		whileTrue: [stop := stop + 1].
	[start >= 1 and: [(self text at: start) isSeparator not]]
		whileTrue: [start := start - 1].
	^self trimWord: (self text copyFrom: start to: stop) asString ! !

Object subclass: #SConcernsRepository
	instanceVariableNames: 'groups colors mapping'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Projects'!

!SConcernsRepository methodsFor: 'accessing' stamp: 'mp 9/1/2010 11:22:30.463'!
colors
	"Answer the value of colors"

	^ colors! !

!SConcernsRepository methodsFor: 'accessing' stamp: 'mp 9/1/2010 11:22:30.466'!
colors: anObject
	"Set the value of colors"

	colors := anObject! !

!SConcernsRepository methodsFor: 'public api' stamp: 'mp 9/2/2010 15:06:58.411'!
concernsOfGroup: aGroupString andTest: aMethodRef
	^ ((self groups at: aGroupString) 
		select: [:each | (self mapping at: each ifAbsent: [#()]) includes: aMethodRef]) 		
			asSortedCollection! !

!SConcernsRepository methodsFor: 'public api' stamp: 'mp 9/2/2010 14:01:05.578'!
concernsOfTest: aMethodRef
	| concerns |
	concerns := IdentitySet new.
	self mapping keysAndValuesDo: [:key :value | 
		(value includes: aMethodRef) ifTrue: [concerns add: key]].
	^ concerns! !

!SConcernsRepository methodsFor: 'public api' stamp: 'mp 9/2/2010 14:12:42.325'!
groupOfConcern: concern
	self groups keysAndValuesDo: [:key :value | 
		(value detect: [:each | each == concern] ifNone: [nil])
			ifNotNil: [^ key]].! !

!SConcernsRepository methodsFor: 'accessing' stamp: 'mp 9/1/2010 11:22:30.454'!
groups
	"Answer the value of groups"

	^ groups! !

!SConcernsRepository methodsFor: 'accessing' stamp: 'mp 9/1/2010 11:22:30.459'!
groups: anObject
	"Set the value of groups"

	groups := anObject! !

!SConcernsRepository methodsFor: 'public api' stamp: 'mp 9/2/2010 15:05:04.788'!
groupsOfConcerns: aCollection
	| groups |
	groups := IdentitySet new.
	aCollection do: [:concern | groups add: (self groupOfConcern: concern)].
	^ groups asSortedCollection! !

!SConcernsRepository methodsFor: 'initialize-release' stamp: 'mp 9/2/2010 10:01:46.174'!
initialize
	self groups: IdentityDictionary new.
	self mapping: IdentityDictionary new.
	self colors: IdentityDictionary new.! !

!SConcernsRepository methodsFor: 'accessing' stamp: 'mp 9/2/2010 10:05:01.002'!
mapping
	"Answer the value of mappings"

	^ mapping ifNil: [mapping := IdentityDictionary new]! !

!SConcernsRepository methodsFor: 'accessing' stamp: 'mp 9/2/2010 10:01:36.495'!
mapping: anObject
	"Set the value of mappings"

	mapping := anObject! !

!SConcernsRepository methodsFor: 'public api' stamp: 'mp 9/2/2010 16:56:34.549'!
mappingExisting: aConcern and: aMethodRef
	(self mapping includesKey: aConcern) ifFalse: [^ false].
	^ (self mapping at: aConcern) includes: aMethodRef! !

!SConcernsRepository methodsFor: 'public api' stamp: 'mp 9/2/2010 13:34:52.482'!
testClassesOfConcern: aConcern
	| testClasses map |
	testClasses := IdentitySet new.
	map := self mapping at: aConcern.
	map do: [:each | testClasses add: each actualClass].
	^ testClasses asSortedCollection: [:a :b | a asString <= b asString]! !

!SConcernsRepository methodsFor: 'public api' stamp: 'mp 9/2/2010 14:56:18.818'!
testSelectorsOfClass: aClass andConcern: aConcern
	^ ((self mapping at: aConcern) 
		select: [:each | each actualClass == aClass] 
		thenCollect: [:each | each methodSymbol]) asSortedCollection! !

Object subclass: #SDefinitionModel
	instanceVariableNames: 'defClass defSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Models'!

!SDefinitionModel methodsFor: '-- all --' stamp: 'mp 1/25/2010 17:10'!
aboutToStyle: aStyler

	aStyler classOrMetaClass: self classOrMetaClass.
	^ true! !

!SDefinitionModel methodsFor: 'accessing' stamp: 'mp 1/4/2010 14:21'!
classOrMetaClass

	(self defClass notNil and: [self defSelector notNil]) 
		ifTrue: [^ self defClass].
	^ nil! !

!SDefinitionModel methodsFor: 'accessing' stamp: 'mp 1/4/2010 14:21'!
contents

	| sourceString |
	self defClass ifNil: [^ ''].
	self defSelector ifNil: [^ self defClass definition].
	sourceString := self defClass sourceCodeAt: self defSelector ifAbsent: [^'error'].
	^ sourceString copy asText! !

!SDefinitionModel methodsFor: 'accessing' stamp: 'mp 1/4/2010 14:21'!
defClass
	^ defClass! !

!SDefinitionModel methodsFor: 'accessing' stamp: 'mp 1/4/2010 14:21'!
defClass: anObject
	defClass := anObject! !

!SDefinitionModel methodsFor: 'accessing' stamp: 'mp 1/4/2010 14:21'!
defSelector
	^ defSelector! !

!SDefinitionModel methodsFor: 'accessing' stamp: 'mp 1/4/2010 14:21'!
defSelector: anObject
	defSelector := anObject! !

!SDefinitionModel methodsFor: 'accessing' stamp: 'mp 1/4/2010 14:21'!
setClass: aClass andSelector: aSelector

	^ self 
		defClass: aClass;
		defSelector: aSelector;
		changed: #contents;
		yourself! !

Object subclass: #SEntryPoint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Tracer'!

!SEntryPoint methodsFor: 'execution' stamp: 'mp 7/12/2010 13:24:46.524'!
execute

	self subclassResponsibility.! !

!SEntryPoint methodsFor: 'testing' stamp: 'mp 4/1/2011 13:26:36.151'!
isCode

	^ false! !

!SEntryPoint methodsFor: 'testing' stamp: 'mp 4/1/2011 13:26:42.525'!
isTestCase

	^ false! !

!SEntryPoint methodsFor: 'testing' stamp: 'mp 4/1/2011 13:26:45.826'!
isUserStory

	^ false! !

SEntryPoint subclass: #SSourceCodeEntryPoint
	instanceVariableNames: 'code'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Tracer'!

!SSourceCodeEntryPoint class methodsFor: 'instance creation' stamp: 'mp 7/12/2010 13:25:55.81'!
onCode: aString

	^ self new
		code: aString;
		yourself.! !

!SSourceCodeEntryPoint methodsFor: 'accessing' stamp: 'mp 7/12/2010 13:26:15.125'!
code
	"Answer the value of code"

	^ code! !

!SSourceCodeEntryPoint methodsFor: 'accessing' stamp: 'mp 7/12/2010 13:26:15.13'!
code: anObject
	"Set the value of code"

	code := anObject! !

!SSourceCodeEntryPoint methodsFor: 'execution' stamp: 'mp 7/12/2010 13:26:56.369'!
execute
	^ Compiler evaluate: self code! !

!SSourceCodeEntryPoint methodsFor: 'testing' stamp: 'mp 4/1/2011 13:27:30.903'!
isCode

	^ true! !

!SSourceCodeEntryPoint methodsFor: 'printing' stamp: 'mp 7/12/2010 14:16:05.892'!
printString

	^ 'Source code entry point'! !

SEntryPoint subclass: #STestCaseEntryPoint
	instanceVariableNames: 'testClass selector lastResult withoutTimeout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Tracer'!

!STestCaseEntryPoint class methodsFor: 'instance creation' stamp: 'bs 7/17/2010 12:43:32.121'!
class: aClass selector: aSelector
	^ self new
		testClass: aClass;
		selector: aSelector;
		yourself! !

!STestCaseEntryPoint class methodsFor: 'converting' stamp: 'mp 4/4/2011 17:12:55.425'!
convertTestSuite: aTestSuite

	^ aTestSuite tests collect: [ :each | 
		STestCaseEntryPoint class: each class selector: each selector ]! !

!STestCaseEntryPoint class methodsFor: 'instance creation' stamp: 'bs 7/17/2010 12:42:12.429'!
onTestCase: aTestCase

	^ self class: aTestCase class selector: aTestCase selector! !

!STestCaseEntryPoint class methodsFor: 'instance creation' stamp: 'bs 7/20/2010 14:52:04.177'!
onTestMethodReference: aMethodReference

	^ self class: aMethodReference actualClass selector: aMethodReference methodSymbol! !

!STestCaseEntryPoint class methodsFor: 'instance creation' stamp: 'bs 7/20/2010 14:52:07.313'!
testMethod: aCompiledMethod

	^ self class: aCompiledMethod methodClass selector: aCompiledMethod selector! !

!STestCaseEntryPoint methodsFor: 'comparing' stamp: 'mp 7/14/2010 09:29:14.346'!
= other
	self class == other class
		ifFalse: [^ false].
	^ self asMethodReference = other asMethodReference! !

!STestCaseEntryPoint methodsFor: 'converting' stamp: 'tfel 7/8/2011 09:42:46.062'!
asCompiledMethod

	^ self asMethodReference compiledMethod! !

!STestCaseEntryPoint methodsFor: 'converting' stamp: 'bs 7/20/2010 14:54:47.724'!
asMethodReference

	^ MethodReference class: self testClass selector: self selector! !

!STestCaseEntryPoint methodsFor: 'accessing' stamp: 'mp 12/8/2011 13:33:08.421'!
compiledMethod
	^ (self testClass whichClassIncludesSelector: self selector) >> self selector! !

!STestCaseEntryPoint methodsFor: 'execution' stamp: 'mp 6/26/2011 18:51:15.326'!
debug
	(self testClass selector: self selector) debug! !

!STestCaseEntryPoint methodsFor: 'accessing' stamp: 'mp 5/9/2011 09:53:02.273'!
disableTimeout
	self withoutTimeout: true.! !

!STestCaseEntryPoint methodsFor: 'execution' stamp: 'mp 5/9/2011 09:55:23.71'!
execute
	 self testClass resources do: [ :each |
		each isAvailable ifFalse: [ each signalInitializationError ]].
	[self withoutTimeout
		ifTrue: [	self lastResult: (self testClass selector: self selector)
					runWithoutTimeout]
		ifFalse: [self lastResult: (self testClass selector: self selector) run]] 
		ensure: [self testClass resources do: [ :each | each reset ]].
	^ self lastResult! !

!STestCaseEntryPoint methodsFor: 'comparing' stamp: 'mp 7/14/2010 09:28:50.007'!
hash

	^ self asMethodReference hash! !

!STestCaseEntryPoint methodsFor: 'testing' stamp: 'mp 9/29/2010 13:49:43.777'!
isInheritedTest
	^ (self testClass testSelectors includes: self selector) not! !

!STestCaseEntryPoint methodsFor: 'testing' stamp: 'mp 4/1/2011 13:27:47.667'!
isTestCase

	^ true! !

!STestCaseEntryPoint methodsFor: 'testing' stamp: 'mp 4/1/2011 13:28:31.425'!
isUserStory

	^ self testClass inheritsFrom: ACUserStory! !

!STestCaseEntryPoint methodsFor: 'accessing' stamp: 'mp 7/13/2010 14:52:00.283'!
lastResult
	"Answer the value of lastResult"

	^ lastResult! !

!STestCaseEntryPoint methodsFor: 'accessing' stamp: 'mp 7/13/2010 14:52:00.287'!
lastResult: anObject
	"Set the value of lastResult"

	lastResult := anObject! !

!STestCaseEntryPoint methodsFor: 'printing' stamp: 'mp 9/29/2010 13:48:34.75'!
printString
	self isInheritedTest 
		ifTrue: [^ self testClass asString, ' >> ', self selector asString, ' (inherited)'].
	^ (self testClass >> self selector) qualifiedName! !

!STestCaseEntryPoint methodsFor: 'accessing' stamp: 'bs 7/17/2010 12:38:02.943'!
selector
	^ selector! !

!STestCaseEntryPoint methodsFor: 'accessing' stamp: 'bs 7/17/2010 12:38:02.95'!
selector: anObject
	selector := anObject! !

!STestCaseEntryPoint methodsFor: 'accessing' stamp: 'bs 7/17/2010 12:38:18.191'!
testClass
	^ testClass! !

!STestCaseEntryPoint methodsFor: 'accessing' stamp: 'bs 7/17/2010 12:38:18.197'!
testClass: anObject
	testClass := anObject! !

!STestCaseEntryPoint methodsFor: 'accessing' stamp: 'mp 5/9/2011 09:53:19.674'!
withoutTimeout
	"Answer the value of withoutTimeout"

	^ withoutTimeout ifNil: [withoutTimeout := false]! !

!STestCaseEntryPoint methodsFor: 'accessing' stamp: 'mp 5/9/2011 09:52:39.289'!
withoutTimeout: anObject
	"Set the value of withoutTimeout"

	withoutTimeout := anObject! !

Object subclass: #SImageRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

SImageRepository class
	instanceVariableNames: 'loupeIcon documentIcon bugIcon treeIcon beforeIcon afterIcon pathfinderIcon closeIcon replayIcon infoIcon spiderIcon leftRightIcon worldIconLarge qualityIconLarge traceabilityIconLarge ladybugIconLarge stopwatchIconLarge scenarioSteps inductiveIconLarge violatedContracts'!

SImageRepository class
	instanceVariableNames: 'loupeIcon documentIcon bugIcon treeIcon beforeIcon afterIcon pathfinderIcon closeIcon replayIcon infoIcon spiderIcon leftRightIcon worldIconLarge qualityIconLarge traceabilityIconLarge ladybugIconLarge stopwatchIconLarge scenarioSteps inductiveIconLarge violatedContracts'!

!SImageRepository class methodsFor: 'icons' stamp: 'mp 3/24/2011 16:24:21.275'!
afterIcon
	"afterIcon := nil"
	^ afterIcon ifNil: [afterIcon := 
		(Form
			extent: 15@15
			depth: 32
			fromArray:      #(4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4279571733 4294967295 4294967295 4294967295 4294967295 4294967295 4287861651 4289901234 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4279111182 4294967295 4294967295 4294967295 4294967295 4294967295 4289440683 4279111182 4289506476 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4280361249 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288848546 4279637526 4290032820 4294967295 4294967295 4294967295 4294901502 4294967295 4279111182 4289769648 4289638062 4290032820 4289440683 4289572269 4289901234 4289506476 4278519045 4278190080 4285756275 4294967295 4294967295 4294835709 4294967295 4279111182 4279111182 4279900698 4279111182 4280295456 4279111182 4280361249 4279111182 4278519045 4278519045 4279769112 4294967295 4294967295 4294967295 4294967295 4279111182 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293980400 4279308561 4281479730 4294901502 4294967295 4294967295 4294967295 4294967295 4279637526 4294901502 4294967295 4294967295 4294967295 4294967295 4293454056 4282269246 4282466625 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4281348144 4294967295 4294967295 4294967295 4294967295 4294967295 4282729797 4281282351 4294769916 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294506744 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
			offset: 0@0)
				asFormOfDepth: Display depth;
				replaceColor: Color white withColor: Color transparent;
				yourself].! !

!SImageRepository class methodsFor: 'icons' stamp: 'mp 3/24/2011 16:24:28.675'!
beforeIcon
	"beforeIcon := nil"
	^ beforeIcon ifNil: [beforeIcon := 
		(Form
			extent: 15@15
			depth: 32
			fromArray:     #(4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4287861651 4289901234 4294967295 4294967295 4294967295 4279571733 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4289440683 4279111182 4289506476 4294967295 4294967295 4279111182 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288848546 4279637526 4290032820 4294967295 4280361249 4294967295 4294967295 4294967295 4294901502 4289769648 4289638062 4290032820 4289440683 4289572269 4289901234 4289506476 4278519045 4278190080 4285756275 4279111182 4294967295 4294967295 4294967295 4294835709 4279111182 4279900698 4279111182 4280295456 4279111182 4280361249 4279111182 4278519045 4278519045 4279769112 4279111182 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293980400 4279308561 4281479730 4294901502 4279111182 4294967295 4294967295 4294967295 4294967295 4294901502 4294967295 4294967295 4294967295 4294967295 4293454056 4282269246 4282466625 4294967295 4294967295 4279637526 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4282729797 4281282351 4294769916 4294967295 4294967295 4281348144 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294506744 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
			offset: 0@0)
				asFormOfDepth: Display depth;
				replaceColor: Color white withColor: Color transparent;
				yourself].! !

!SImageRepository class methodsFor: 'icons' stamp: 'mp 3/24/2011 16:24:37.11'!
bugIcon
	"bugIcon := nil"
	^ bugIcon ifNil: [bugIcon := 
		(Form
			extent: 15@15
			depth: 32
			fromArray:   #(4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294704123 4293190884 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293849328 4292796383 4291677646 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4293783021 4294572537 4293651949 4291481294 4289371545 4285098079 4288254582 4291216834 4294769916 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294375158 4288850090 4287528567 4291317554 4292816651 4288555781 4279898114 4278255872 4290756022 4294835709 4294967295 4294967295 4294967295 4294967295 4294967295 4293980914 4290353808 4289736722 4289069312 4291431424 4290654215 4279900689 4281151532 4289241217 4294638071 4293848814 4294967295 4294967295 4294967295 4294967295 4291480780 4292627748 4291300864 4285136896 4293077760 4291636480 4284422146 4290789913 4286799694 4290757314 4291611852 4294967295 4294967295 4294967295 4294112501 4289363311 4293863936 4290252800 4285470209 4293276928 4294587136 4294926389 4294938742 4292243025 4294506743 4294967295 4294967295 4294967295 4294309365 4291218124 4287584327 4290387712 4293667840 4294916352 4293080322 4284881927 4292323235 4293102199 4293830804 4294967295 4294967295 4294967295 4294967295 4293717227 4291547087 4291334786 4293340160 4294522880 4294128896 4293608210 4289102461 4292978849 4288163857 4293120460 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293450454 4294063361 4294062592 4294193920 4294331163 4294929480 4294920726 4291396203 4292862434 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294835709 4292786090 4292883467 4291958528 4290059266 4290523149 4293442735 4294045678 4292993762 4294835709 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293780447 4293249730 4291144097 4290294706 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292204504 4293848814 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
			offset: 0@0)
				asFormOfDepth: Display depth;
				replaceColor: Color white withColor: Color transparent;
				yourself].! !

!SImageRepository class methodsFor: 'icons' stamp: 'mp 3/24/2011 16:24:42.579'!
closeIcon
	"closeIcon := nil"
	^ closeIcon ifNil: [closeIcon := 
		(Form
			extent: 15@15
			depth: 32
			fromArray:   #(16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 7105644 7105644 6974058 795371624 2525135490 3550716835 3971331509 3836784816 3079967892 1618113138 57108327 7105644 7105644 16777215 16777215 7105644 6842472 1785753712 4105351858 4292861919 4293322470 4293322470 4293388263 4293190884 4291875024 3079638927 375809638 7105644 16777215 16777215 6908265 1937077621 4290690750 4292730333 4292401368 4292532954 4292598747 4292598747 4292335575 4292598747 4292335575 3415643798 375941224 16777215 16777215 627665257 4188777387 4292072403 4291809231 4292993505 4292203989 4292203989 4292072403 4292993505 4292072403 4291809231 4291546059 2709619073 16777215 16777215 2373482616 4290690750 4291085508 4293256677 4294967295 4293783021 4291414473 4292861919 4294967295 4294111986 4291282887 4291217094 3953501605 16777215 16777215 3515517578 4290493371 4290559164 4292467161 4294967295 4294967295 4293914607 4294901502 4294967295 4293256677 4290822336 4290493371 4004491183 16777215 16777215 3951922573 4289967027 4290295992 4290295992 4292006610 4294835709 4294967295 4294967295 4292796126 4290295992 4290427578 4290032820 3987385002 16777215 16777215 3900143479 4288190616 4289440683 4289572269 4291677645 4294835709 4294967295 4294967295 4292598747 4289638062 4289703855 4288914339 3985213833 16777215 16777215 3379457646 4286479998 4287269514 4290822336 4294967295 4294967295 4293190884 4294901502 4294967295 4292335575 4287861651 4287006342 4017386612 16777215 16777215 2053925996 4286216826 4286743170 4290888129 4294967295 4292532954 4287730065 4290756543 4294967295 4292664540 4287269514 4286611584 3849417073 16777215 16777215 392915819 4000412017 4286545791 4287137928 4289835441 4288190616 4288124823 4287861651 4289901234 4287730065 4286874756 4286019447 2272029804 16777215 16777215 7105644 1600941164 4218581618 4286545791 4286743170 4287401100 4287664272 4287598479 4286940549 4286808963 4286085240 3094179181 174877804 16777215 16777215 7105644 7105644 1147956332 3564138608 3984095352 3984424317 3984555903 3984555903 3984226938 3950211955 2423090541 107768940 7105644 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215)
			offset: 0@0)
				asFormOfDepth: Display depth;
				replaceColor: Color white withColor: Color transparent;
				yourself].! !

!SImageRepository class methodsFor: 'icons' stamp: 'mp 3/24/2011 16:24:48.241'!
documentIcon
	"documentIcon := nil"
	^ documentIcon ifNil: [documentIcon := 
		(Form
			extent: 15@15
			depth: 32
			fromArray: #(4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293717485 4288982445 4290823878 4293981171 4294770173 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294638587 4291153100 4289704883 4289704112 4288981931 4291087564 4294178550 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293257448 4289047724 4290558650 4288651167 4289769134 4289441197 4289179053 4291021771 4294572794 4294967295 4294967295 4294967295 4294967295 4294967295 4294441465 4289640375 4290624957 4288914082 4288256409 4288651167 4290164406 4290822079 4289048238 4294112243 4294967295 4294967295 4294967295 4294967295 4294967295 4291811287 4289047210 4290229685 4288914339 4288848546 4288059030 4290887872 4288982447 4292666858 4294967295 4294967295 4294967295 4294967295 4294967295 4294441466 4289179824 4291216580 4288585117 4288585375 4288585374 4290690237 4290033849 4287142296 4290099373 4290626496 4293323756 4294967295 4294967295 4293455084 4288983736 4287665564 4288388516 4287138706 4287664793 4287467415 4289638584 4286545262 4285358122 4287590433 4286343470 4288719520 4294967295 4294967295 4288587425 4287400040 4288516205 4289042294 4288384622 4288779120 4289173877 4289635464 4287002708 4287655453 4290877235 4290878271 4289506977 4294967295 4294967295 4289573806 4290486620 4294300020 4294036592 4294036333 4294036851 4294038406 4294566817 4293121452 4287659338 4291141441 4289894221 4291416270 4294967295 4294967295 4293258478 4288450921 4294627951 4294300019 4294498440 4294697373 4294830000 4294897085 4294964678 4289107823 4290944325 4288646227 4292929512 4294967295 4294967295 4294573052 4288389269 4292656497 4294631067 4294435243 4294436793 4294568123 4294369708 4294960798 4291409022 4289630020 4288254057 4294178550 4294967295 4294967295 4294835967 4291350995 4290095747 4294965440 4294963393 4294962357 4294960544 4294827147 4294957435 4294563971 4288776268 4288191111 4294507001 4294967295 4294967295 4294967295 4294244600 4288059789 4291806111 4291673231 4291606143 4291473776 4291473002 4291407210 4292459636 4286608463 4289047979 4294704381 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
			offset: 0@0)
				asFormOfDepth: Display depth;
				replaceColor: Color white withColor: Color transparent;
				yourself].! !

!SImageRepository class methodsFor: 'large icons' stamp: 'mp 1/19/2012 15:32:42.765'!
inductiveIconLarge
	"inductiveIconLarge := nil"
	^ inductiveIconLarge ifNil: [inductiveIconLarge := 
		(Form
			extent: 30@30
			depth: 32
			fromArray: #(4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294965230 4294959031 4294953349 4294949731 4294948179 4294948955 4294951799 4294956963 4294963163 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294962647 4294950764 4294941723 4294938112 4294937344 4294937088 4294936832 4294936832 4294937088 4294937600 4294940170 4294946891 4294958773 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967037 4294953091 4294940173 4294937344 4294937344 4294938368 4294941202 4294944043 4294945339 4294944562 4294942236 4294939136 4294937344 4294937344 4294938368 4294947408 4294963679 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294965487 4294947150 4294937600 4294937600 4294939397 4294948440 4294958513 4294964197 4294967038 4294967295 4294967295 4294965488 4294961096 4294952057 4294941979 4294937600 4294937600 4294941725 4294960322 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294966004 4294945856 4294937344 4294937856 4294945082 4294961097 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294964713 4294950765 4294938368 4294937856 4294940431 4294960838 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294949471 4294937344 4294937856 4294949216 4294966263 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294956448 4294939141 4294937856 4294941982 4294964197 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294957738 4294938112 4294937856 4294947922 4294967037 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294956190 4294938368 4294937600 4294948695 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294966262 4294943528 4294937600 4294942495 4294964972 4294967295 4294967295 4291480266 4288585374 4293717228 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294949987 4294937600 4294938624 4294960322 4294967295 4294967295 4294967295 4294967295 4294967295 4294957739 4294937856 4294938112 4294956703 4294967295 4294967295 4294967295 4289045925 4278190080 4279966491 4285098345 4290756543 4294704123 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294964454 4294940947 4294937344 4294948438 4294967295 4294967295 4294967295 4294967295 4294967295 4294948437 4294937088 4294943523 4294967291 4294967295 4294967295 4294967295 4289638062 4278190080 4278190080 4278190080 4278190080 4281282351 4286940549 4292401368 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294950506 4294937344 4294940944 4294964713 4294967295 4294967295 4294967295 4294966005 4294942752 4294939904 4289423633 4281875262 4282071867 4282071867 4282137660 4280756007 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4283124555 4292006610 4294967295 4294967295 4294967295 4294967295 4294967295 4294959547 4294938368 4294938112 4294959031 4294967295 4294967295 4294967295 4294963162 4294939908 4294938880 4292390262 4289967287 4290032820 4290032820 4290230199 4286085240 4278190080 4278190080 4278190080 4278190080 4278190080 4280098077 4285032552 4290361785 4294638330 4294967295 4294967295 4294967295 4294967295 4294967295 4294964197 4294940686 4294937088 4294954379 4294967295 4294967295 4294967295 4294960838 4294938880 4294938368 4294960574 4294967295 4294967295 4294967295 4294967295 4289769648 4278190080 4278190080 4278979596 4283519313 4289506476 4294375158 4294967295 4294967295 4291677645 4289835441 4294967295 4294967295 4294967295 4294967295 4294966005 4294943010 4294937088 4294951797 4294967295 4294967295 4294967295 4294960323 4294938880 4294938624 4294959548 4294967295 4294967295 4294967295 4294967295 4289440683 4281348144 4287269514 4292861919 4294967295 4294967295 4293519849 4288256409 4282400832 4278387459 4283124555 4294967295 4294967295 4294967295 4294967295 4294966263 4294943269 4294937088 4294951537 4294967295 4294967295 4294967295 4294961871 4294939392 4294938112 4294957740 4294967295 4294967295 4294967295 4294967295 4294243572 4294835709 4294967295 4294967295 4290361785 4284374622 4279505940 4278190080 4278190080 4278190080 4284111450 4294967295 4294967295 4294967295 4294967295 4294967287 4294941721 4294937088 4294953087 4294967295 4294967295 4294967295 4294964713 4294940944 4294937088 4294953089 4294967295 4294967295 4294967295 4294967295 4294967295 4294177779 4286545791 4279966491 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4279769112 4282927176 4282861383 4282861383 4282664520 4285685316 4294939907 4294937856 4294956706 4294967295 4294967295 4294967295 4294967038 4294945337 4294937088 4294945854 4294967295 4294967295 4294967295 4294967295 4294967295 4294638330 4290953922 4285690482 4280624421 4278190080 4278190080 4278190080 4278190080 4278190080 4281742902 4288914339 4288716960 4288716960 4288651941 4290744145 4294938368 4294939395 4294962388 4294967295 4294967295 4294967295 4294967295 4294953347 4294937344 4294939397 4294961871 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294309365 4289967027 4284111450 4279440147 4278190080 4278190080 4283979864 4294967295 4294967295 4294967295 4294967295 4294947133 4294937088 4294944561 4294966779 4294967295 4294967295 4294967295 4294967295 4294963164 4294939913 4294937600 4294948178 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293322470 4288256409 4281940281 4284045657 4294967295 4294967295 4294967295 4294957222 4294938112 4294937600 4294954897 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294950763 4294937344 4294938368 4294956705 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4294967295 4294967295 4294963938 4294941722 4294937600 4294942752 4294965489 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294964970 4294942239 4294937856 4294939659 4294959288 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294964714 4294944567 4294937856 4294938112 4294958254 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294960065 4294939400 4294937856 4294939914 4294955674 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294961356 4294943792 4294937856 4294937600 4294952055 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294958254 4294939659 4294937856 4294938112 4294946892 4294959807 4294966780 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294962906 4294951797 4294939915 4294937856 4294937856 4294950763 4294967038 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294960322 4294943014 4294937600 4294937600 4294938880 4294944047 4294950763 4294955412 4294956964 4294956445 4294952572 4294946628 4294940427 4294937600 4294937600 4294939400 4294954122 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294965230 4294951800 4294940947 4294937600 4294937088 4294937088 4294937344 4294937600 4294937344 4294937088 4294937088 4294937344 4294939139 4294947150 4294961355 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294964197 4294955158 4294947149 4294942754 4294940429 4294939395 4294939913 4294941722 4294945338 4294952057 4294961099 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294966005 4294963682 4294962905 4294963422 4294964973 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967038 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
			offset: 0@0)
				asFormOfDepth: Display depth;
				yourself]! !

!SImageRepository class methodsFor: 'icons' stamp: 'mp 3/24/2011 16:24:53.828'!
infoIcon
	"infoIcon := nil"
	^ infoIcon ifNil: [infoIcon := 
		(Form
			extent: 15@15
			depth: 32
			fromArray:   #(4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294770173 4291944172 4289249501 4288395225 4289052636 4291418344 4294507259 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292930034 4286620877 4283466172 4282940601 4282480567 4282480567 4283203258 4285700293 4292141035 4294967295 4294967295 4294967295 4294967295 4294967295 4293061363 4284912068 4282743481 4283269307 4283203515 4285569223 4286160842 4283334843 4282809273 4283991484 4291878121 4294967295 4294967295 4294967295 4294769917 4286817999 4282743480 4283400636 4283334844 4283137722 4292535278 4294507002 4284057790 4283203515 4282940602 4285108671 4294046709 4294967295 4294967295 4292338671 4283597757 4283269051 4283400636 4283400636 4283006394 4283991998 4284846018 4283400636 4283400636 4283335100 4283006136 4290168023 4294967295 4294967295 4290038242 4282940601 4283400636 4283334844 4283466171 4287014603 4290169569 4287672018 4283006137 4283400636 4283400636 4283006394 4287408070 4294967037 4294967295 4289381342 4282874809 4283400636 4283400636 4282677688 4288723671 4294967295 4287935188 4282743481 4283400636 4283400636 4283071931 4286750657 4294900729 4294967295 4290760933 4283006393 4283335100 4283400636 4283006393 4292338157 4294638588 4284189119 4283071930 4283400636 4283400636 4283006651 4287801796 4294966779 4294967295 4293324276 4284057533 4283137723 4283071930 4285240516 4294967295 4291483880 4285437636 4284517824 4283269051 4283269308 4283466169 4290495952 4294967295 4294967295 4294967295 4288854999 4282743223 4283006394 4285109188 4292535279 4290695138 4286423497 4283466428 4283334844 4282940859 4286355899 4293848555 4294967295 4294967295 4294967295 4294507259 4287408846 4282940344 4282875066 4283137722 4283466172 4283006395 4283072188 4283072187 4285567674 4292204762 4294967295 4294967295 4294967295 4294967295 4294967295 4294704380 4289577431 4285042621 4283597241 4283334585 4283597241 4284647866 4287867073 4292730591 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294046451 4291877088 4290824919 4291219159 4292927971 4294769143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
			offset: 0@0)
				asFormOfDepth: Display depth;
				replaceColor: Color white withColor: Color transparent;
				yourself]! !

!SImageRepository class methodsFor: 'large icons' stamp: 'mp 3/24/2011 16:18:58.89'!
ladybugIconLarge
	"ladybugIconLarge := nil"
	^ ladybugIconLarge ifNil: [ladybugIconLarge := 
		(Form
			extent: 30@30
			depth: 32
			fromArray: #(4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4286743170 4293914607 4294967295 4294638330 4294572537 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294111986 4281150765 4290559164 4294967295 4291282887 4293783021 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4291414473 4286479998 4294835709 4292401368 4294572537 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4284243036 4294243572 4293717228 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4284637794 4289703855 4294967295 4294967295 4293519849 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4290822336 4284637794 4292861919 4290822336 4288256408 4287598479 4293848814 4294967295 4294967295 4294967295 4294967295 4294967295 4294704123 4294769916 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292664540 4283124555 4284045137 4289703066 4291873716 4289176986 4283387465 4283782222 4287861651 4294967295 4294967295 4294967295 4294177779 4291151301 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4289309097 4278848010 4281216295 4291281576 4294439635 4291281834 4283782224 4282532418 4281676845 4287993236 4293585642 4291414473 4293388263 4294901502 4292467161 4290032820 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292006610 4291018943 4294568935 4289758587 4286479998 4281545523 4279900698 4279834646 4278585352 4281481277 4280624679 4284637534 4281084714 4290822336 4294835709 4290756543 4286216826 4282269246 4286085240 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294638073 4286597694 4292310101 4294224269 4294880658 4293908948 4293188826 4283256141 4282203453 4279243284 4282402379 4278585354 4289373841 4291018671 4290164405 4294769916 4284111450 4292467161 4294440951 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293173138 4294017628 4294289545 4294365892 4294298811 4287977542 4286141774 4284436558 4288976018 4288387224 4281611318 4278190080 4288386690 4294967276 4288256148 4291875024 4284440415 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294365128 4293624157 4293893241 4293897618 4294823867 4289960331 4280163870 4282005560 4282000927 4293495667 4292845714 4289361257 4283188806 4281019431 4292663485 4288124301 4287401100 4288256409 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294572022 4293887596 4294350704 4294091136 4293897874 4294492839 4291594614 4285354317 4278453252 4282789412 4294221951 4294350966 4294735433 4289812538 4282992712 4280230432 4283913812 4286282619 4294111986 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292664540 4286216826 4285482558 4293883213 4291130195 4292906092 4294222722 4293631102 4293497730 4292248165 4289229917 4292977031 4294429369 4294233277 4293826166 4294339901 4289743660 4286476912 4289967027 4294111986 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4291282887 4292136396 4292307534 4289351470 4278190080 4280160782 4292115803 4293428588 4293163613 4294154355 4294617994 4294228640 4294234562 4294234305 4293894275 4293556560 4294601787 4290406483 4293980400 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4290621614 4293417007 4292827434 4283375631 4279502851 4290861882 4293293403 4293620551 4294150497 4294220922 4294423189 4294033577 4293965984 4293893501 4294282341 4294277451 4290989874 4290690236 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4291480266 4285087029 4293744424 4293679655 4293614120 4292630055 4293026627 4293090357 4293091892 4283574812 4282328605 4290148447 4294356109 4293962380 4293565564 4289948752 4292768589 4291719259 4288321688 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293783021 4283321934 4291531655 4294007592 4293351463 4293482791 4293482538 4292762686 4293613863 4292826662 4279896323 4278190080 4281080596 4294088564 4294681729 4288439888 4278190080 4285741350 4291398012 4284506208 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4290493371 4284176473 4292978329 4293876520 4293351463 4293417511 4292760110 4292892466 4293417511 4293745192 4291382306 4283047182 4285937956 4294017626 4293888613 4292509790 4289422151 4292504908 4290748570 4287269514 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4289901234 4289307555 4293439137 4293942313 4293482791 4293285671 4292364842 4293285928 4293351463 4293285927 4293745192 4293942313 4293878578 4293487423 4293555531 4293753939 4294477145 4293822063 4292991448 4289045925 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4286743170 4292465875 4292391853 4284162831 4293548584 4292956198 4292561702 4293417511 4293351463 4293351463 4293351463 4293416999 4293351462 4293351977 4293419058 4293552443 4293682749 4294561993 4294967295 4289506476 4283190348 4290164406 4294704123 4294967295 4294967295 4294967295 4294967295 4294967295 4290953922 4282927176 4285887861 4294901502 4292530125 4278190080 4291645219 4292889125 4293088294 4293417255 4293745192 4293548327 4293351463 4293351463 4293351463 4293351206 4293351462 4294007338 4289816922 4294967295 4294967295 4294967295 4289703855 4290098613 4294572537 4294967295 4294967295 4294967295 4294967295 4294967295 4285229931 4285756275 4294967295 4294967295 4294506744 4285481267 4293416743 4292560932 4293417255 4293482791 4291316770 4292695077 4293482791 4293351463 4293351463 4293417511 4294203945 4290667858 4287860623 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294375158 4294967295 4294967295 4294967295 4294967295 4293901748 4293021477 4292956197 4294073641 4289085212 4278190080 4284359696 4294138921 4293351719 4293548584 4293945151 4291600278 4284043858 4292203989 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293434251 4293351463 4293679912 4291842083 4286984983 4290398239 4293745704 4293416743 4293689703 4292724676 4282006074 4288190616 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294834680 4293299836 4293025850 4293417260 4294008109 4293485114 4293297003 4294233027 4294110700 4287335307 4290624957 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294767602 4294501087 4294500829 4294701551 4294967295 4294967295 4292993505 4282137660 4293848814 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294572537 4286545791 4286940549 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4289967027 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
			offset: 0@0)
				asFormOfDepth: Display depth;
				yourself]! !

!SImageRepository class methodsFor: 'icons' stamp: 'mp 3/24/2011 16:24:59.432'!
leftRightIcon
	"leftRightIcon := nil"
	^ leftRightIcon ifNil: [leftRightIcon := 
		(Form
			extent: 15@15
			depth: 32
			fromArray: #(4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4291880432 4288464607 4286494421 4285706451 4286100436 4287676380 4290566633 4294704638 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4289384165 4284984015 4281436862 4279991990 4279663541 4279795126 4280648889 4283735752 4287940059 4293323516 4294967295 4294967295 4294967295 4294967295 4289054183 4283999176 4279466676 4279794870 4280123319 4280123319 4280123319 4279991990 4279466420 4281765567 4287281372 4294178811 4294967295 4294967295 4292142578 4285114576 4279466420 4279400884 4279729333 4280057783 4280123319 4280057783 4279991990 4279400884 4279269555 4282816707 4289318882 4294967295 4294967295 4288530655 4281371325 4279532212 4284326859 4289909734 4280977339 4279006641 4279203763 4288005085 4287019736 4280517305 4279466419 4286428631 4294967295 4294967295 4286297046 4280385976 4289647077 4294967295 4294967295 4292405747 4286297301 4290238184 4294770174 4294967295 4292734196 4281765311 4284918222 4294967295 4294967295 4285837779 4279729077 4283013317 4289975527 4293587960 4290238184 4294967295 4292077297 4291880176 4292340210 4285049295 4279926454 4284063946 4294967295 4294967295 4286165716 4279991990 4279597748 4279663541 4282290882 4281305789 4294638845 4285443536 4281502653 4280714426 4279335091 4279269555 4284983758 4294967295 4294967295 4287808219 4280911547 4279991990 4280057783 4279400884 4281108667 4294638845 4285771986 4278875313 4279926198 4280188855 4279532212 4285969362 4294967295 4294967295 4290960109 4284064458 4279466420 4280123319 4279860662 4281305788 4294967295 4286100436 4279269555 4280123319 4279729333 4281568702 4288398559 4294967295 4294967295 4294835967 4288003297 4282225600 4279466420 4279991990 4280648889 4286625750 4282684867 4279794869 4279729333 4280254903 4286231254 4292864502 4294967295 4294967295 4294967295 4293850361 4288004829 4283275975 4280057783 4279335091 4278612656 4279072434 4279663541 4281765567 4286561234 4291285496 4294967295 4294967295 4294967295 4294967295 4294967295 4294638845 4289712868 4287019737 4285574865 4284392652 4285049295 4286428630 4288595937 4293062645 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
			offset: 0@0)
				asFormOfDepth: Display depth;
				replaceColor: Color white withColor: Color transparent;
				yourself].! !

!SImageRepository class methodsFor: 'icons' stamp: 'mp 3/24/2011 16:25:04.585'!
loupeIcon
	"loupeIcon := nil"
	^ loupeIcon ifNil: [loupeIcon := 
		(Form
			extent: 15@15
			depth: 32
			fromArray:   #(4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4292795870 4288848292 4286019452 4283848028 4284900717 4287597713 4291216581 4294111986 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4290953411 4282927187 4283649890 4285162618 4286679454 4286749099 4285433751 4283390566 4286874503 4293124835 4294967295 4294967295 4294967295 4294967295 4293256420 4283584855 4286547099 4289445073 4289250774 4289517540 4289716718 4289912556 4288918987 4283190363 4286611329 4294967295 4294967295 4294967295 4294967295 4292138196 4282137149 4286026909 4289194990 4289722360 4289393909 4289196015 4288933100 4287478722 4282072645 4284506208 4294967295 4294967295 4294967295 4294967295 4293322470 4285887610 4284441196 4282602585 4283593075 4284647049 4284975500 4284644223 4283389794 4281545534 4286216827 4294967295 4294967295 4294967295 4294967295 4294704123 4289176743 4283781986 4284833644 4281412400 4285820798 4289242037 4288781745 4285097592 4286084990 4292795870 4294967295 4294967295 4294967295 4294835709 4293059042 4287071887 4285953927 4284243038 4284703331 4287861402 4288519332 4288585123 4290558652 4294177779 4294967295 4294967295 4294967295 4294704123 4290098613 4284440425 4287467169 4284506468 4286282361 4293059042 4293585385 4293388006 4294704123 4294967295 4294967295 4294967295 4294967295 4294967295 4290164151 4283716700 4284111719 4283519574 4285229930 4293980400 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4286217095 4293322473 4286611852 4281281836 4293651179 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288190625 4290493377 4286940558 4291874768 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4290295996 4285953663 4289045928 4294309365 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
			offset: 0@0)
				asFormOfDepth: Display depth;
				replaceColor: Color white withColor: Color transparent;
				yourself]! !

!SImageRepository class methodsFor: 'icons' stamp: 'mp 3/24/2011 16:25:09.623'!
pathfinderIcon
	"pathfinderIcon := nil"
	^ pathfinderIcon ifNil: [pathfinderIcon := 
		(Form
			extent: 15@15
			depth: 32
			fromArray: #(4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4286412400 4289427508 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4286345574 4291526161 4292972315 4290870307 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4286476383 4291854347 4293234192 4292380439 4292773904 4291461150 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4287461729 4292379657 4290410522 4287455783 4293299992 4293037077 4293299987 4292248341 4287529076 4294967295 4294967295 4294967295 4294967295 4294967295 4289172602 4291526415 4287389475 4281218368 4283319867 4288900388 4289097509 4289491750 4290935837 4292379154 4288645232 4294967295 4294967295 4294967295 4287853903 4292314126 4290803732 4282005559 4280430916 4281481797 4281219142 4281022279 4280957518 4283583814 4292511513 4292510739 4289103199 4294967295 4286802251 4291984384 4292642831 4292511247 4291657491 4285092144 4282269762 4289754663 4290412076 4286340148 4281942604 4291264287 4292708890 4292642581 4289757512 4294967295 4288506664 4292379145 4292314385 4292642320 4292773646 4289229094 4291789595 4293431064 4289294374 4281285965 4290214436 4292643610 4292709145 4290672670 4294967295 4294967295 4288244013 4292379147 4292511250 4292314385 4292773905 4292577302 4292774167 4290213667 4281153866 4288770346 4293103385 4291329046 4287070847 4294967295 4294967295 4294967295 4288047925 4292313614 4292511252 4292314388 4292314646 4292511768 4291395357 4281153350 4286669363 4292708370 4287723354 4294967295 4294967295 4294967295 4294967295 4294967295 4287851066 4292182287 4292577303 4292183318 4292380441 4292249885 4286209073 4288244004 4288836665 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4287851839 4292183061 4292446487 4292249367 4292381469 4293169175 4289425699 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4287984972 4292117010 4292119591 4292513056 4290015254 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288116303 4291855128 4291000338 4287135347 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4287919440 4287657298 4294967295 4294967295 4294967295 4294967295 4294967295)
			offset: 0@0)
				asFormOfDepth: Display depth;
				replaceColor: Color white withColor: Color transparent;
				yourself].! !

!SImageRepository class methodsFor: 'large icons' stamp: 'mp 3/24/2011 16:19:09.671'!
qualityIconLarge
	"qualityIconLarge := nil"
	^ qualityIconLarge ifNil: [qualityIconLarge := 
		(Form
			extent: 30@30
			depth: 32
			fromArray: #(4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294900216 4294766830 4294701038 4294966781 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967038 4294834166 4294566881 4293305760 4292311928 4293372325 4294102474 4294302681 4294567910 4294700524 4294900731 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294833909 4294301652 4293637296 4293107355 4292577152 4292843153 4293906125 4293174946 4292577668 4292908947 4292709513 4292974482 4294169296 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294434781 4292842381 4292577924 4293242027 4293839044 4294967295 4294967295 4294967295 4294701809 4294635502 4294635502 4292312695 4293107353 4294767602 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294036166 4292179567 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294436581 4292378232 4294036167 4294701038 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294900988 4294169552 4292643460 4293109152 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293639609 4292709253 4293770424 4294502116 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294103245 4292576381 4293041817 4294966781 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294037709 4292179567 4294169038 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294900217 4293306531 4292444795 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294768374 4292047723 4294367446 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294966781 4293704374 4292378488 4294834424 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294302938 4292908688 4294700780 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294236374 4292112746 4294037452 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294435552 4292576895 4294434781 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294037195 4292245360 4294436066 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292445824 4293439659 4294966781 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293770938 4292444025 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294966524 4292246388 4293572274 4294834424 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294102988 4292245103 4293705916 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294768373 4292643975 4293305760 4294301909 4294967038 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294701294 4293637810 4292311411 4293042331 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293308073 4292974995 4294434010 4294900730 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294834680 4294036681 4292510846 4294303452 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292511616 4293770938 4294966781 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294502631 4293174174 4292444795 4293640382 4293838018 4294502117 4294967295 4294967295 4294834937 4293573046 4293307820 4292577924 4292842124 4294434781 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967038 4293903810 4292643717 4292377722 4292708743 4292644230 4293174689 4293640127 4292643203 4292975252 4292310900 4291980651 4293903809 4294900474 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293705917 4289594624 4290124818 4290257436 4291848291 4292975253 4292445826 4292776331 4290588714 4289528576 4289200128 4292312695 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292246131 4289396736 4289661440 4289660928 4289462272 4290059024 4290523173 4289726976 4289594624 4289727488 4289661184 4289925643 4294236630 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294768117 4290456094 4289529088 4289727488 4289727488 4289727488 4289660928 4289462272 4289727232 4289727488 4289727488 4289727488 4289396736 4291649880 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293506481 4289528320 4289727488 4289727488 4289727488 4289727232 4289859846 4290853681 4289660672 4289727488 4289727488 4289727488 4289661440 4289594881 4293573045 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4291517010 4289462272 4289727488 4289727488 4289727488 4289528832 4290787888 4294170324 4289926154 4289661184 4289727488 4289727488 4289727488 4289528832 4290323741 4294568424 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294236631 4289859592 4289528832 4289462272 4289661440 4289727488 4289396736 4292445310 4294967295 4291914853 4289396736 4289727488 4289727488 4289727232 4289462272 4289265664 4291450703 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4291915365 4289134592 4290124306 4292645002 4290588967 4289528832 4289859077 4294236373 4294967295 4294435809 4289992463 4289594880 4289661440 4289860103 4291649368 4290456354 4289331200 4292444796 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294369760 4289660928 4290655792 4294170067 4294967295 4291583574 4289200128 4291118909 4294967295 4294967295 4294967295 4292843409 4289462272 4289528576 4290721581 4294967295 4294833653 4293706176 4293042847 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292843667 4291981162 4294767602 4294967295 4294967295 4292644746 4289069056 4292711052 4294967295 4294967295 4294967295 4294967295 4291185474 4289134592 4291914596 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294768374 4294967295 4294967295 4294967295 4294967295 4293573559 4289594624 4294170581 4294967295 4294967295 4294967295 4294967295 4294236117 4289661444 4292911001 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294236888 4292179823 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293307302 4294104531 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967038 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
			offset: 0@0)
				asFormOfDepth: Display depth;
				yourself]! !

!SImageRepository class methodsFor: 'icons' stamp: 'mp 3/24/2011 16:25:15.03'!
replayIcon
	"replayIcon := nil"
	^ replayIcon ifNil: [replayIcon := 
		(Form
			extent: 15@15
			depth: 32
			fromArray: #(4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4294967295 4294967295 4293652728 4289575645 4288260822 4288195031 4287997654 4288655835 4292009200 4294967295 4294967295 4294901502 4294967295 4294967295 4294967295 4294967295 4291482346 4286813642 4288720599 4291088102 4291548394 4290956775 4288590042 4285828554 4288787677 4294770431 4294967295 4294967295 4294967295 4294967295 4291417065 4286484935 4290956517 4292338161 4294770174 4294967295 4294967295 4294441212 4291745515 4285236935 4288195288 4294967295 4294967295 4294967295 4293389559 4286879950 4290890724 4294967295 4289117153 4287933148 4291417326 4294901759 4294967295 4294967295 4291219689 4284118718 4290693604 4294967295 4294967295 4289839072 4288129493 4294375675 4294901758 4287736282 4285237452 4284842697 4286946515 4292206064 4294967295 4294901503 4286747849 4286353093 4294967295 4294967295 4288392921 4290299108 4294967295 4294704125 4286880980 4284250564 4283658687 4282671542 4282540212 4287011021 4293981177 4289443031 4285036984 4294967295 4294967295 4287932633 4290891239 4294967295 4294638589 4285894348 4283066555 4282802869 4282078637 4280697503 4279447441 4286747334 4289706457 4284970930 4294967295 4294967295 4287538134 4290036194 4294967295 4294638845 4285104324 4281882285 4281158051 4280434074 4282143650 4288128207 4294967295 4288390346 4284115882 4294967295 4294967295 4288261082 4287209171 4294835710 4294835711 4283591350 4280039833 4281289117 4286089408 4292929011 4294967295 4294638332 4283983266 4285693877 4294967295 4294967295 4292205807 4284118205 4290035937 4294967295 4284379830 4284248241 4290890468 4294967295 4294967295 4294967295 4287994815 4280892039 4291284707 4294967295 4294967295 4294967295 4288983513 4282999472 4289114580 4291416552 4294967295 4294967295 4294967295 4293783027 4287665592 4280430974 4287864520 4294967295 4294967295 4294967295 4294967295 4294967295 4288720340 4282669477 4285036209 4287468735 4287732158 4286416305 4282930065 4281220229 4287996105 4294967295 4294967295 4294967295 4294967295 4294901502 4294967295 4294967295 4291744743 4287009475 4284904622 4284444071 4284575399 4286614456 4291547621 4294967295 4294967295 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
			offset: 0@0)
				asFormOfDepth: Display depth;
				replaceColor: Color white withColor: Color transparent;
				yourself].! !

!SImageRepository class methodsFor: 'icons' stamp: 'mp 4/4/2011 15:55:35.15'!
scenarioSteps
	"scenarioSteps := nil"
	^ scenarioSteps ifNil: [scenarioSteps := 
		(Form
			extent: 15@15
			depth: 32
			fromArray: #(4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4290632114 4287873407 4288070531 4288136068 4288201604 4288201604 4288201604 4288201604 4288201604 4288201604 4288201605 4288136068 4294967295 4294967295 4294835965 4288201862 4284982858 4285508436 4285508436 4285508436 4285508436 4285508436 4285508436 4285508436 4285508436 4285508437 4285508437 4294967295 4294967295 4294967295 4293522149 4291945673 4292011466 4292077003 4292077003 4292077003 4292077003 4292077003 4292077003 4292077003 4292077003 4292077003 4294967295 4294967295 4294573305 4285706076 4281633297 4282355742 4282355743 4282355743 4282355742 4282355742 4282355743 4282355743 4282355742 4282355743 4282355743 4294967295 4294967295 4294967295 4293521888 4292798665 4292864459 4292864460 4292864460 4292864460 4292864460 4292864460 4292864460 4292864460 4292864460 4292864460 4294967295 4294967295 4294967035 4294958202 4294953530 4294954307 4294954308 4294954308 4294954308 4294954308 4294954308 4294954308 4294954308 4294954308 4294954308 4294967295 4294967295 4294967294 4294963902 4294961564 4294961825 4294961825 4294961825 4294961825 4294961825 4294961825 4294961825 4294961825 4294961825 4294961825 4294967295 4294967295 4294967039 4292711056 4291515985 4291714647 4291714904 4291714904 4291714904 4291649368 4291649368 4291714904 4291714904 4291714904 4291714904 4294967295 4294967295 4294900731 4292774527 4291843910 4292042832 4292042832 4292042832 4292042832 4292042832 4292042832 4292042832 4292042832 4292042832 4292042832 4294967295 4294967295 4294967295 4293850359 4292929261 4292995053 4292995053 4292995053 4292995053 4292995053 4292995053 4292995053 4292995053 4292995053 4292995053 4294967295 4294967295 4294901502 4289770432 4287204511 4287533476 4287533733 4287533733 4287533733 4287533477 4287533733 4287533477 4287533477 4287533733 4287533476 4294967295 4294967295 4294967295 4294638587 4294375160 4294375416 4294375416 4294375416 4294375416 4294375416 4294375416 4294375416 4294375416 4294375416 4294375416 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
			offset: 0@0)
				asFormOfDepth: Display depth;
				replaceColor: Color white withColor: Color transparent;
				yourself].! !

!SImageRepository class methodsFor: 'icons' stamp: 'mp 3/24/2011 16:25:20.063'!
spiderIcon
	"spiderIcon := nil"
	^ spiderIcon ifNil: [spiderIcon := 
		(Form
			extent: 15@15
			depth: 32
			fromArray:     #(4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294046193 4289374890 4294243572 4291611852 4293519849 4294967295 4293651435 4290888129 4293848814 4289045925 4294177779 4294967295 4294967295 4294967295 4294572537 4294967295 4291875024 4289572269 4291151301 4288453788 4286019447 4287861651 4288980132 4289111718 4292401368 4294967295 4294243572 4294901502 4294967295 4291546059 4289045925 4292269782 4288585374 4287861651 4284769380 4283321934 4283979864 4286216826 4288190616 4292269782 4288585374 4291019715 4294901502 4294967295 4294901502 4292006610 4288387995 4287335307 4284835173 4284769380 4286019447 4287137928 4284506208 4286414205 4287072135 4291809231 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4289703855 4286743170 4284506208 4284966759 4287006342 4284703587 4288585374 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292796126 4288716960 4286874756 4285361517 4284177243 4284900966 4285493103 4286677377 4289045925 4293783021 4294967295 4294967295 4294967295 4294967295 4290361785 4287795858 4290822336 4287598479 4284374622 4283782485 4283979864 4285164138 4289111718 4289374890 4286479998 4292467161 4294967295 4294967295 4291085508 4289703855 4294375158 4289243304 4287203721 4284243036 4287006342 4286216826 4288914339 4287664272 4292401368 4293059298 4289243304 4293388263 4294967295 4293519849 4294967295 4291085508 4289374890 4291940817 4283848278 4291611852 4290230199 4288651167 4293125091 4286414205 4294901502 4294967295 4294704123 4294967295 4294967295 4293914607 4288387995 4294243572 4291217094 4283519313 4289967027 4288651167 4287335307 4294967295 4290032820 4289440683 4294835709 4294967295 4294967295 4294967295 4291743438 4292861919 4294967295 4293388263 4285229931 4283387727 4283585106 4291348680 4294967295 4294967295 4291282887 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4291940817 4293125091 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
			offset: 0@0)
				asFormOfDepth: Display depth;
				replaceColor: Color white withColor: Color transparent;
				yourself].! !

!SImageRepository class methodsFor: 'large icons' stamp: 'mp 3/24/2011 16:19:16.256'!
stopwatchIconLarge
	"stopwatchIconLarge := nil"
	^ stopwatchIconLarge ifNil: [stopwatchIconLarge := 
		(Form
			extent: 30@30
			depth: 32
			fromArray: #(4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293321444 4291083198 4291544261 4294045680 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967039 4292004814 4289833130 4291610311 4291017919 4289766822 4293321442 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293584615 4291017403 4293848558 4293058270 4293782251 4293387494 4290622129 4294572279 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292267724 4293189342 4293123548 4291345338 4291806143 4294901501 4291674817 4293782248 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292465361 4292728790 4292860120 4291147958 4291542714 4294769659 4291543746 4294111215 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914094 4290227372 4290952382 4290950836 4290951607 4291347395 4290688181 4294572280 4294638330 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293058270 4288648598 4291017656 4288254092 4289504419 4294177522 4292136139 4291148471 4293781992 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294835709 4293519081 4292202452 4289306534 4286673782 4287134847 4291544777 4292992992 4288845973 4290490025 4293847785 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292860895 4290819519 4289700524 4289701034 4290227889 4289371809 4289240222 4288713366 4288647831 4286476400 4290293936 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294572281 4291610063 4290030002 4290687926 4291610308 4291545287 4291413701 4290953663 4291282372 4291676873 4291610053 4289898406 4288779158 4292268501 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294703867 4291478221 4290490553 4291610050 4291151042 4290559420 4290690750 4289769647 4289111461 4289506219 4290559164 4290756543 4291611081 4290951607 4288779157 4292334037 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292268247 4290885568 4291873478 4291282628 4288519580 4287795857 4289835184 4292072402 4289703598 4291743438 4291217094 4288914082 4289572269 4291611851 4291017658 4289239712 4293584873 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293913840 4291083206 4292268496 4291151043 4291743438 4292861919 4289243047 4290032563 4292203989 4290361785 4292927968 4290295735 4288782752 4293059298 4290822335 4291743180 4290753973 4290556343 4294835452 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292201942 4291741902 4292203730 4289243304 4289374633 4290690493 4292335318 4291808974 4292335575 4286940548 4292796126 4291545802 4292203989 4292796126 4291216837 4289703855 4291610310 4290095791 4293255653 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294506487 4291609549 4292663512 4290953921 4291940817 4289440426 4289374633 4292664540 4289769392 4292137940 4290164149 4292203989 4289637805 4293256677 4290624700 4288058773 4291019715 4291413957 4291148990 4291741645 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293716461 4291478476 4292466646 4290953921 4293585385 4293783021 4293519849 4293454056 4292203989 4290624956 4287466636 4291414473 4292335575 4293651435 4293256677 4293519849 4292927712 4290822078 4292070860 4291148996 4294901246 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293518827 4291741391 4292335316 4290888128 4288650910 4288387738 4293388263 4293388263 4293717228 4291545802 4287006086 4293322470 4293322470 4292335318 4293454056 4290822336 4290098356 4290953920 4292334289 4291082945 4294638074 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293518826 4291675597 4292466646 4291480008 4290427578 4290559164 4293322470 4293322470 4293519849 4291809231 4287730065 4293717228 4293190884 4292006353 4293454056 4289703854 4288848546 4290887870 4292333776 4290951360 4294572538 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293782509 4291280583 4292400596 4291085507 4293717228 4293519849 4293125091 4293322470 4293454056 4292269782 4289308840 4293783021 4293322470 4293519849 4293519849 4293848814 4292730333 4291019457 4292333776 4291016896 4294769916 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294572280 4291477705 4292466133 4290756542 4291282630 4286611327 4289045668 4293519849 4293388263 4292006610 4290032820 4293585642 4293454056 4292730333 4288716703 4289703598 4291546059 4291414214 4291609542 4291609546 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4291806925 4291215042 4291808715 4289506476 4291282887 4291809231 4293651435 4293190884 4291019714 4290295735 4292203988 4293848814 4293190884 4289506476 4289572268 4289638061 4292597460 4290490294 4293255396 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293848046 4289700780 4291676102 4291019714 4291480267 4292269525 4287203721 4291414216 4293519849 4293190884 4293388263 4289703598 4288782753 4293454056 4290624957 4291545544 4291411390 4290687931 4294835709 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4291873232 4290293431 4292400082 4291019714 4288651167 4289177511 4292664283 4290756543 4287072135 4292335575 4290164406 4287795857 4289374890 4291480008 4291412158 4289239970 4293518824 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294703867 4291280326 4290096052 4291939274 4291216579 4290427577 4290888386 4289835184 4288716703 4290756543 4290559164 4289967026 4291610821 4290819252 4288581014 4292202194 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294704123 4291478474 4289305767 4290293169 4291478466 4291413443 4291282371 4291413957 4291347907 4291413186 4291016887 4289041304 4288581526 4292400087 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292860895 4289832625 4288647324 4288713370 4289173405 4289305245 4288778647 4288186511 4288252306 4290425015 4293848301 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4293584874 4291939538 4291083203 4290754238 4291215301 4292531673 4294111474 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
			offset: 0@0)
				asFormOfDepth: Display depth;
				yourself]! !

!SImageRepository class methodsFor: 'large icons' stamp: 'mp 3/24/2011 16:19:22.494'!
traceabilityIconLarge
	"traceabilityIconLarge := nil"
	^ traceabilityIconLarge ifNil: [traceabilityIconLarge := 
		(Form
			extent: 30@30
			depth: 32
			fromArray: #(4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4291151300 4285756276 4285098346 4287993237 4294704123 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4294967295 4294967295 4294901502 4294967295 4294967295 4294901502 4294967295 4294901502 4294901502 4294967295 4291348680 4286218637 4281547589 4284181632 4282074961 4288848546 4293519849 4290230199 4286479998 4292203989 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4294901502 4294967295 4294901502 4294901502 4294967295 4294967295 4294901502 4294967295 4294901502 4294967295 4294967295 4288256152 4289050577 4283852668 4284313222 4278651405 4282598211 4285822068 4285625460 4278584838 4287006342 4294967295 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4294901502 4294967295 4294967295 4294967295 4294967295 4287532687 4285825944 4282798428 4284639596 4288784552 4293127918 4294180349 4286547590 4279967005 4289440683 4294967295 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4294967295 4294967295 4294638330 4294967295 4292796126 4287401100 4284112221 4288060828 4292338143 4294246399 4294443007 4294311935 4289904061 4286613383 4288651167 4294967295 4294967295 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294704123 4287335311 4292532954 4294967295 4294967295 4291217094 4284770151 4293914607 4294967295 4287993237 4286348669 4288059801 4292074973 4294115070 4294377471 4293918205 4293654776 4293786362 4292667881 4290627527 4287994008 4294967295 4294967295 4294901502 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4290559163 4279638066 4283125093 4294967295 4292006610 4287468692 4284508264 4288980132 4287401100 4290560192 4292667624 4291417557 4292470245 4293852412 4293654776 4293654776 4293654776 4294180606 4285428852 4287336335 4294309365 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292664540 4282796645 4280033883 4287598483 4289047722 4289903804 4285493874 4290363327 4284375393 4289309868 4292864232 4290233283 4293655033 4293720569 4293654776 4293654776 4293654776 4294246142 4289245874 4282400575 4294769916 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4284375151 4278585641 4283652188 4293391603 4293325811 4294574079 4290890956 4285560695 4284507750 4287271313 4288191901 4290693320 4294311935 4294049791 4294115327 4294246399 4294180863 4294705151 4283717977 4287993237 4294967295 4293914607 4290756286 4287006342 4293190884 4294967295 4294967295 4294967295 4294967295 4294967295 4290164406 4282270272 4287732892 4289443510 4293917948 4293786362 4293128175 4285823867 4289048238 4283323476 4288193186 4285954682 4287797657 4291416786 4290956749 4290495941 4290825420 4291943387 4289706425 4280163870 4285493103 4288322973 4290824135 4281875259 4287861651 4294967295 4294967295 4294967295 4294967295 4293980400 4286019447 4292732389 4288193700 4289180338 4293983998 4294443007 4294967295 4286152832 4289377460 4285758074 4285232244 4288522665 4287468178 4283914585 4283981663 4283981663 4284113249 4283652698 4283849820 4278256130 4285362802 4294967295 4289772475 4283585106 4293980400 4294967295 4294967295 4294967295 4294967295 4286151033 4292140252 4294115327 4289838525 4292009951 4293456883 4288982188 4283915099 4280756264 4285034094 4291088335 4285429109 4287732892 4287996321 4289113774 4286151290 4279045132 4278782474 4286481797 4287666585 4285560438 4284836715 4292864489 4282862411 4293256677 4294967295 4294967295 4294967295 4294967295 4294967295 4291940817 4286217854 4292930282 4294705151 4293128175 4282928204 4280361249 4288387995 4289374890 4283190605 4291483350 4289245874 4287337877 4287798685 4287667099 4289443253 4287335821 4279834905 4290167234 4291219921 4292470245 4294508543 4285363573 4287598479 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294177779 4286875013 4292140252 4291219921 4282599496 4291348680 4293059555 4284638565 4281479987 4284770922 4290101183 4288259236 4287667356 4287798685 4287601306 4288654251 4287468178 4285625973 4286613640 4286613383 4292075744 4285626488 4291085508 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4289046182 4284309857 4282204738 4292532954 4287994008 4292338659 4283191633 4282335810 4288390565 4287206291 4287864478 4287798685 4287798685 4287864479 4285758329 4285033319 4285955197 4282204481 4286152832 4292602088 4284967273 4294506744 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4290559164 4287927444 4290756543 4288982445 4289772218 4281546294 4292141023 4286482054 4287272084 4287864221 4287798685 4287798685 4287864478 4287206548 4286745740 4286942862 4284639593 4284442214 4289574839 4287403413 4286611841 4294835709 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4294901502 4294967295 4294967295 4294967295 4293322470 4286612612 4283915613 4288061343 4293260018 4284178785 4287996064 4287798685 4287798685 4287798685 4287798685 4287864478 4287930528 4287930271 4288391079 4285890174 4285558896 4288848803 4288124823 4294375158 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4294901502 4294967295 4294901502 4294901502 4294967295 4291480266 4282269760 4294639615 4288587687 4284047456 4288786094 4288259236 4288193443 4288061857 4287996064 4288062114 4288061857 4287798685 4287798685 4288193700 4285954425 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4288387995 4290560706 4294967295 4284704872 4281151793 4283718491 4284508264 4285363830 4286153346 4286745483 4285824381 4285955967 4288127650 4287864478 4288522665 4284639593 4292335575 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4294901502 4294901502 4294901502 4294967295 4293651435 4284637794 4291283658 4290363327 4289442996 4287534742 4286613640 4286481797 4286350211 4286482054 4287074191 4283915099 4284178785 4286021503 4287272341 4286087296 4287335564 4294769916 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4294901502 4294967295 4294967295 4294901502 4294967295 4289703855 4279769112 4282664775 4286415490 4286875270 4281282864 4279440403 4279571989 4279637783 4279506197 4279440403 4283716949 4287598736 4286810762 4283718491 4285361517 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4293651435 4291480266 4293519849 4294967295 4292861919 4278519045 4279770658 4278519560 4278190080 4278190080 4278321924 4284703587 4293585642 4287534742 4282400832 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4294901502 4294901502 4294967295 4294901502 4294967295 4294967295 4294967295 4294967295 4289045925 4281284418 4287012535 4284181373 4278255873 4278321666 4281482309 4283782485 4294967295 4292269782 4293256677 4294967295 4294901502 4294967295 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4294901502 4294901502 4294901502 4294967295 4294901502 4294967295 4294967295 4294967295 4285559154 4286353581 4290363852 4288723679 4281482308 4280033830 4283523438 4283190348 4294967295 4294967295 4294967295 4294901502 4294967295 4294967295 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4289573302 4290889937 4294309366 4289905370 4287407042 4284511109 4283589489 4283585107 4294967295 4294967295 4294901502 4294967295 4294967295 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4291678937 4288261058 4284247935 4283190863 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4294901502 4294967295 4294967295 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4294901502 4294967295 4294967295 4294440951 4290494146 4286611843 4294835709 4294967295 4294901502 4294967295 4294901502 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
			offset: 0@0)
				asFormOfDepth: Display depth;
				yourself]! !

!SImageRepository class methodsFor: 'icons' stamp: 'mp 3/24/2011 16:25:25.321'!
treeIcon
	"treeIcon := nil"
	^ treeIcon ifNil: [treeIcon := 
		(Form
			extent: 15@15
			depth: 32
			fromArray:   #(4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293652451 4291614910 4288327307 4290168488 4292403659 4294901500 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292995288 4289773728 4285237327 4283659571 4284381516 4283724860 4283988534 4287603835 4291285946 4294441460 4294967295 4294967295 4294967295 4294967295 4294375668 4284513093 4282935085 4284776274 4283460414 4284052550 4283526461 4284314956 4284316229 4282080287 4289905062 4294967295 4294967295 4294967295 4294967295 4291285941 4283330092 4283461680 4283198260 4283987014 4284052802 4284184389 4283592000 4283330095 4283264300 4286092123 4294835964 4294967295 4294967295 4294244338 4286684004 4283066924 4283724346 4282474794 4282540846 4282737963 4282869549 4282276905 4283264305 4283460920 4283856689 4291220152 4294967295 4294967295 4293323488 4284776777 4283722822 4283657029 4282211364 4282801723 4280696092 4281880114 4282474032 4282868786 4283853904 4283461175 4288787598 4294967295 4294967295 4292074443 4284973134 4284447306 4283592000 4282210860 4281486119 4281617954 4281683749 4281552167 4283066164 4284052295 4284513349 4287800190 4294835708 4294967295 4294638330 4288852883 4282475045 4282146075 4281882399 4280499990 4281157658 4280565782 4281026586 4282343709 4281948702 4284645448 4293060318 4294967295 4294967295 4294967295 4292928988 4288852375 4288787092 4288852382 4287537038 4281615401 4284576347 4288918178 4288260749 4289510050 4289772967 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294770175 4287795852 4292664797 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294375158 4292401368 4290756543 4289374890 4287072135 4284900710 4282400830 4284506207 4286611585 4287071879 4287664272 4289769648 4293125091 4294967295 4294967295 4294704123 4293783021 4293256677 4293256677 4293454056 4293125091 4292993505 4292927712 4293519849 4293717228 4293454056 4293651435 4294506744 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
			offset: 0@0)
				asFormOfDepth: Display depth;
				replaceColor: Color white withColor: Color transparent;
				yourself]! !

!SImageRepository class methodsFor: 'icons' stamp: 'mp 3/15/2012 17:48:38.115'!
violatedContracts
	"violatedContracts := nil"
	^ violatedContracts ifNil: [violatedContracts := 
		(Form
			extent: 15@15
			depth: 32
			fromArray:      #(4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294637816 4292641151 4293508282 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293041307 4293560711 4292242280 4294043109 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294172639 4292636524 4294954703 4294084228 4291985790 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901759 4292510079 4294287775 4293645011 4294616741 4292430408 4293250766 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293377725 4293160812 4294757067 4281415993 4288248699 4294794588 4291189593 4294573308 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294570996 4292308332 4294878629 4294832112 4280427813 4287667355 4294942109 4292941076 4291995044 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292581268 4293217087 4294493122 4294967295 4281216302 4288718245 4294963697 4293667624 4290062887 4293847787 4294967295 4294967295 4294967295 4294967295 4293976546 4292162341 4293277724 4293320155 4294835966 4286085241 4291151044 4294639615 4291791750 4289724416 4290605939 4294967295 4294967295 4294967295 4294836223 4292112235 4293140228 4292454559 4292801270 4294311935 4286153604 4289640632 4294115070 4292536295 4290527805 4288875017 4292791244 4294967295 4294967295 4293246911 4292617745 4293406738 4292447875 4292448648 4292974994 4287448896 4289554274 4292318095 4291531150 4290466641 4289069056 4289414468 4294967295 4294967295 4291918456 4291900197 4291769125 4291373340 4290979353 4290650390 4290979871 4290257177 4289533970 4289336850 4289074965 4288944409 4288751142 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
			offset: 0@0)
				asFormOfDepth: Display depth;
				replaceColor: Color white withColor: Color transparent;
				yourself].! !

!SImageRepository class methodsFor: 'large icons' stamp: 'mp 3/24/2011 16:19:28.448'!
worldIconLarge
	"worldIconLarge := nil"
	^ worldIconLarge ifNil: [worldIconLarge := 
		(Form
			extent: 30@30
			depth: 32
			fromArray:   #(4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294638331 4294243573 4292600809 4291943910 4289318888 4288071400 4289646306 4291024869 4292733424 4294310137 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294244345 4290695903 4288658897 4288987347 4291220186 4289318373 4285382385 4285118185 4284920549 4284524242 4284981961 4289379271 4291482070 4293521653 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4293455087 4288330962 4289972953 4292271843 4293257193 4292404973 4288402164 4286105076 4286104048 4285709291 4286167782 4285770963 4289708236 4291150270 4288457655 4289316057 4294573052 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294638331 4291157484 4286231252 4287347157 4290305523 4290567408 4288336369 4286236662 4287155445 4286826997 4286892789 4285643242 4288464611 4292336091 4292138196 4291545802 4291019198 4286225335 4285045188 4293850104 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294375931 4288072684 4286367217 4285378776 4285972459 4288205815 4286959354 4285909498 4287089909 4287614193 4285776112 4286891245 4287349994 4291353062 4293190110 4292335574 4292006610 4291414472 4290756027 4288981679 4285634485 4293784311 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294835710 4287876592 4285248479 4286037221 4286696438 4286631418 4286827767 4287024374 4289189875 4292207854 4293586157 4289976817 4290567151 4292863724 4293060070 4293059299 4292598747 4292203989 4291546316 4290428092 4290624440 4289046957 4285174714 4294507259 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4290568180 4285644010 4286168809 4286959869 4286959611 4289124598 4287745779 4288795375 4292601324 4290895343 4293783021 4293651950 4294373613 4293848300 4293519592 4293125091 4292861919 4292335575 4291743438 4290560194 4290427835 4290361010 4285368741 4287672014 4294967295 4294967295 4294967295 4294967295 4294967295 4293916410 4286038768 4286366959 4286893818 4286630904 4286696955 4290370802 4290173682 4291223792 4290239216 4292536046 4294176749 4294176749 4293914349 4293717485 4293454056 4293190884 4292927712 4292269782 4291414473 4291085508 4290624957 4290361012 4286813864 4282939043 4292601328 4294967295 4294967295 4294967295 4294967295 4289319143 4285512166 4286894074 4286762747 4286827509 4287877364 4293061358 4294307563 4294176748 4294111213 4294439149 4294176749 4294045421 4294045421 4293848556 4293453799 4293190884 4292861920 4292203989 4291414473 4291019715 4290690750 4290295477 4288521129 4282282147 4284781249 4294967294 4294967295 4294967295 4294441723 4284915651 4285773792 4287025919 4286171127 4291486963 4293060844 4291354348 4292009444 4293454057 4294045419 4293651692 4293651693 4294176749 4293454829 4292929517 4292797157 4293125091 4292467934 4291809747 4291282887 4291151301 4290756543 4290032820 4289703080 4287403681 4280508579 4293521398 4294967295 4294967295 4292470510 4283995065 4285245904 4286171384 4286958582 4291354607 4288598256 4286235892 4288466413 4291353834 4293848041 4287612141 4286693362 4292863724 4289253101 4290041069 4291614690 4292862434 4292401111 4291480266 4291611852 4291414473 4290559164 4289835441 4288980132 4288848030 4281623963 4289710048 4294967295 4294967295 4290039004 4283995064 4284983762 4287745265 4292470253 4293651692 4293192429 4289319662 4285709036 4287743980 4290172397 4292601068 4291025645 4292140774 4290499559 4287151081 4293650147 4292993505 4291743438 4290888129 4291414473 4291151301 4290493371 4289243304 4288716960 4288585116 4281623188 4286357704 4294967295 4294967295 4287475913 4283402672 4287215572 4293914607 4294176749 4293979885 4294505197 4292207598 4285840364 4285577713 4284658163 4287480300 4292863723 4294176490 4292665572 4290498272 4292861918 4292532954 4291611852 4291085508 4290624957 4290361785 4289703855 4289045924 4288913822 4286483611 4280506258 4284911032 4294967295 4294967295 4285898685 4283467692 4289971666 4294045163 4293783021 4293848557 4293914349 4294242541 4292667118 4292601326 4288990961 4288071664 4293323501 4293914092 4292731107 4293124317 4292926938 4292466646 4292137422 4291809230 4291282887 4290361785 4290032563 4289309870 4289373857 4286220696 4279652244 4283136428 4294967295 4294967295 4285701820 4284321713 4292073691 4293387749 4293454056 4293651178 4293651435 4293717228 4293979884 4294045677 4294570732 4292141289 4292600552 4293716454 4291286498 4287280089 4289840083 4291021779 4289707725 4291742922 4291282628 4291019198 4288456885 4282019495 4286746783 4288781718 4281950867 4281887396 4294967295 4294967295 4286751936 4283072423 4290759121 4293256161 4293125091 4293256677 4293388263 4293454055 4293322470 4293454056 4293585126 4291615205 4288660195 4293453281 4292927453 4289709529 4289709012 4284060879 4280710603 4284847045 4290034367 4290821304 4283596204 4279260319 4280573344 4282279573 4280177297 4285764275 4294967295 4294967295 4289052113 4281691034 4287604926 4293386716 4293124318 4293124834 4292862178 4292862435 4293190883 4293125091 4293125091 4293256161 4286755294 4290759898 4292861144 4293451733 4290167759 4281497798 4280512711 4279723969 4286224312 4289310130 4280049060 4279522465 4279390105 4281031571 4281162126 4289378244 4294967295 4294967295 4291549411 4281887898 4283333795 4288197578 4291023068 4292861403 4292401884 4292467934 4292927455 4292796126 4292730333 4292992732 4289774293 4287541457 4291218384 4286751945 4281628868 4280643522 4280775105 4279985078 4281429427 4287076779 4280507810 4278996123 4279520658 4284052628 4281028991 4290102485 4294967295 4294967295 4294178552 4282676898 4282347676 4282217638 4283011023 4288592853 4292335316 4292466904 4292401368 4292335575 4292269782 4292203989 4292137421 4289576397 4286358216 4283270854 4280447175 4280774849 4280247992 4280116148 4279852458 4280573860 4280375451 4278929555 4278600333 4281489285 4281686404 4293126640 4294967295 4294967295 4294967295 4286753487 4281296796 4281821335 4281560742 4283995339 4291809489 4292072145 4292006610 4292006610 4292072146 4291808973 4291151302 4291808457 4291611335 4283008454 4280183489 4280247477 4280116148 4280049580 4279588258 4279127451 4278862988 4278928783 4278664582 4278201452 4282411161 4294901502 4294967295 4294967295 4294967295 4293192948 4281825203 4282021809 4281691555 4282283434 4289575365 4291742665 4291480523 4291546058 4290823368 4290297797 4291479492 4290625731 4284123580 4279854008 4280115891 4280115374 4279983015 4279588258 4279324829 4279126675 4278797195 4278599047 4278598271 4278201969 4291285986 4294967295 4294967295 4294967295 4294967295 4294967295 4287870423 4281364660 4282153144 4281363627 4284581805 4291216578 4290953922 4290953921 4289443262 4289640126 4289836474 4282349495 4279393714 4280115889 4280115115 4279719843 4279522467 4279324828 4279061139 4278862989 4278599304 4278598787 4278203005 4283858866 4294901759 4294967295 4294967295 4294967295 4294967295 4294967295 4294638588 4283401661 4280838056 4281167023 4283530667 4290427062 4290361784 4290296249 4289902008 4290558389 4287208884 4279590578 4279852717 4279786151 4279654052 4279390881 4279258777 4279060882 4278796939 4278598789 4278599044 4278204032 4279717267 4294112760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293849847 4281823918 4280180644 4282611115 4289309355 4289769389 4289703855 4289703598 4289046956 4288652972 4280113566 4281492896 4280704931 4279061915 4279126676 4278994833 4278730890 4278598788 4278599303 4278204291 4278862475 4292798191 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293718518 4282151853 4278865561 4284185759 4289505186 4289045668 4289111459 4288322978 4281555858 4280767629 4287534234 4280110730 4278863504 4278861698 4278663546 4278598786 4278533252 4278203521 4279717267 4292798191 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294441467 4286160582 4279455893 4284446609 4288387735 4288650649 4283722890 4278202228 4280502908 4282079872 4278334063 4278794356 4278728048 4278662253 4278202738 4278204034 4284253108 4294047224 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292075500 4284385206 4281031829 4280372612 4278201450 4278267754 4278333805 4278202221 4278399341 4278201706 4278201193 4278268788 4282872230 4291352294 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901503 4293192691 4289183450 4285567158 4282740126 4281030544 4280898701 4282345625 4285106607 4288853711 4292995312 4294835966 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
			offset: 0@0)
				asFormOfDepth: Display depth;
				yourself]! !

Object subclass: #SNullWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Tracer'!

!SNullWrapper commentStamp: 'mp 7/13/2010 16:10:38.579' prior: 0!
A SNullWrapper is a null object that is required if you want to use the tracer without tracing (execute entry points only).

Instance Variables
!

!SNullWrapper class methodsFor: 'instance creation' stamp: 'mp 7/13/2010 16:06:23.225'!
on: aSymbol inClass: aClass with: aTracer

	^ self new! !

!SNullWrapper methodsFor: 'installation' stamp: 'mp 7/13/2010 16:07:31.93'!
install! !

!SNullWrapper methodsFor: 'installation' stamp: 'mp 7/13/2010 16:07:43.356'!
uninstall! !

Object subclass: #SProject
	instanceVariableNames: 'projectName categories classesCache concerns coverage harvestedBuckets views hasContracts'
	classVariableNames: 'CurrentProject ProjectRegistry'
	poolDictionaries: ''
	category: 'Path-Core-Projects'!

!SProject class methodsFor: 'class initialization' stamp: 'mp 7/8/2010 16:51:03.467'!
addPredefinedProjects
	self 
		addProject: self nullProject;
		addProject: self monticelloProject;
		addProject: self sunitProject;
		addProject: self systemBrowserProject;
		addProject: self sandboxProject;
		addProject: self observerExampleProject.! !

!SProject class methodsFor: 'projects' stamp: 'mp 6/11/2010 15:20'!
addProject: aProject

	self projectAt: aProject projectName put: aProject.! !

!SProject class methodsFor: 'system events' stamp: 'mp 3/8/2011 20:14:22.804'!
addSystemChangeNotifierForAddedClasses
	"self addSystemChangeNotifierForAddedClasses"
	SystemChangeNotifier uniqueInstance 
		notify: self 
		ofEvents: {'classAddedEvent:'. 'classModifiedEvent:'. 'classRecategorizedEvent:'. 'classRemovedEvent:'. 'classRenamedEvent:'. 'classReorganizedEvent:'. 'classModifiedEvent:'. 'classModifiedEvent:'} 
		using: #systemClassChanged:
	! !

!SProject class methodsFor: 'system events' stamp: 'mp 1/1/2012 15:48:01.58'!
addSystemChangeNotifierForSourceCodeChanges
	"self addSystemChangeNotifierForSourceCodeChanges"
	SystemChangeNotifier uniqueInstance 
		notify: self 
		ofEvents: SystemChangeNotifier uniqueInstance allSystemEvents
		using: #sourceCodeChanged:
	! !

!SProject class methodsFor: 'projects' stamp: 'mp 6/11/2010 15:04'!
allProjectNames

	^ ProjectRegistry keys! !

!SProject class methodsFor: 'projects' stamp: 'mp 6/11/2010 15:04'!
allProjects

	^ ProjectRegistry values! !

!SProject class methodsFor: 'projects' stamp: 'mp 7/7/2010 09:27:21.988'!
allProjectsWithoutNull

	^ ProjectRegistry values select: [:each | (each projectName == #null) not]! !

!SProject class methodsFor: 'projects' stamp: 'mp 6/11/2010 18:28'!
current

	^ CurrentProject! !

!SProject class methodsFor: 'class initialization' stamp: 'mp 1/1/2012 15:44:29.036'!
initialize
	"self initialize"
	super initialize.
	self
		reset;
		addPredefinedProjects;
		addSystemChangeNotifierForAddedClasses;
		addSystemChangeNotifierForSourceCodeChanges;
		setCurrent: #null.! !

!SProject class methodsFor: 'testing' stamp: 'mp 3/7/2012 09:42:03.341'!
isNullProjectSelected
	^ SProject current projectName = SProject nullProject projectName! !

!SProject class methodsFor: 'predefined projects' stamp: 'mp 6/11/2010 15:10'!
monticelloProject

	^ self 
		name: #monticello 
		categories: #(#'Monticello-Base' #'Monticello-Chunk Format' #'Monticello-Loading' #'Monticello-Merging' #'Monticello-Modeling' #'Monticello-Patching' #'Monticello-Repositories' #'Monticello-Storing' #'Monticello-UI' #'Monticello-Versioning' #'Tests-Monticello' #'Tests-Monticello-Mocks')! !

!SProject class methodsFor: 'instance creation' stamp: 'mp 6/11/2010 15:07'!
name: aSymbol categories: aCollection

	^ self new
		projectName: aSymbol;
		categories: aCollection;
		yourself! !

!SProject class methodsFor: 'predefined projects' stamp: 'mp 7/7/2010 09:11:08.894'!
nullProject

	^ self 
		name: #null
		categories: #()! !

!SProject class methodsFor: 'predefined projects' stamp: 'tfel 3/6/2012 15:23:24.097'!
observerExampleProject

	^ self 
		name: #observerExample
		categories: #(#'Path-Dev-Example-Observer')! !

!SProject class methodsFor: 'projects' stamp: 'mp 6/11/2010 15:14'!
projectAt: aSymbol

	^ self projectRegistry
		at: aSymbol ifAbsent: [nil]! !

!SProject class methodsFor: 'projects' stamp: 'mp 6/11/2010 15:14'!
projectAt: aSymbol put: aProject

	^ self projectRegistry 
		at: aSymbol 
		put: aProject! !

!SProject class methodsFor: 'projects' stamp: 'mp 6/11/2010 15:13'!
projectRegistry

	^ ProjectRegistry ifNil: [ProjectRegistry := Dictionary new]! !

!SProject class methodsFor: 'projects' stamp: 'mp 6/11/2010 15:24'!
projectRegistry: aProjectRegistry
	"Mostly required for testing purposes"
	ProjectRegistry := aProjectRegistry.! !

!SProject class methodsFor: 'projects' stamp: 'mp 7/7/2010 12:01:56.049'!
removeProjectAt: aSymbol

	CurrentProject == (self projectAt: aSymbol)
		ifTrue: [CurrentProject := self projectAt: #null].
	^ self projectRegistry
		removeKey: aSymbol! !

!SProject class methodsFor: 'class initialization' stamp: 'mp 6/11/2010 18:31'!
reset
	
	ProjectRegistry := nil.
	CurrentProject := nil.! !

!SProject class methodsFor: 'predefined projects' stamp: 'tfel 3/6/2012 15:23:40.278'!
sandboxProject

	^ self 
		name: #sandbox 
		categories: #(#'Path-Tests-Sandbox')! !

!SProject class methodsFor: 'projects' stamp: 'mp 6/11/2010 18:37'!
setCurrent: aSymbol

	CurrentProject := self projectAt: aSymbol.
	CurrentProject ifNotNil: [CurrentProject resetClassesCache].! !

!SProject class methodsFor: 'projects' stamp: 'mp 6/16/2010 12:57'!
setCurrentProject: aProject
	CurrentProject := aProject.
	CurrentProject ifNotNil: [CurrentProject resetClassesCache].! !

!SProject class methodsFor: 'projects' stamp: 'mp 7/7/2010 09:18:13.796'!
setNullProjectAsCurrent

	self setCurrent: #null.! !

!SProject class methodsFor: 'system events' stamp: 'mp 1/1/2012 15:58:39.811'!
sourceCodeChanged: anEvent
	self allProjects do: [:each | each changed: anEvent].! !

!SProject class methodsFor: 'predefined projects' stamp: 'mp 6/11/2010 15:11'!
sunitProject

	^ self 
		name: #sunit 
		categories: #(#'SUnit-Extensions' #'SUnit-Kernel' #'SUnit-Tests')! !

!SProject class methodsFor: 'predefined projects' stamp: 'mp 6/11/2010 15:12'!
systemBrowserProject

	^ self 
		name: #systemBrowser 
		categories: #(#'ToolBuilder-Kernel' #'ToolBuilder-Morphic' #'Tools-Base' #'Tools-Browser' #'ToolsTests-Browser')! !

!SProject class methodsFor: 'system events' stamp: 'mp 3/8/2011 20:28:34.845'!
systemClassChanged: anEvent
	self current resetClassesCache.! !

!SProject methodsFor: 'accessing' stamp: 'tfel 6/23/2011 13:29:21.272'!
addViewNamed: aString with: aMorph

	self views at: aString put: aMorph.! !

!SProject methodsFor: 'classes' stamp: 'mp 1/2/2012 13:56:13.098'!
allClasses

	^ classesCache ifNil: [classesCache := (Smalltalk allClasses select: [:each | 
										self categories includes: each category]) asArray].! !

!SProject methodsFor: 'tests' stamp: 'mp 6/23/2010 16:36'!
allMethods
	^ self allClasses inject: OrderedCollection new into: [:col :klass | 
		klass methodDict keys do: [:selector | col add: (MethodReference class: klass selector: selector)].
		klass class methodDict keys do: [:selector | col add: (MethodReference class: klass class selector: selector)].
		col]! !

!SProject methodsFor: 'tests' stamp: 'mp 3/24/2011 10:55:27.37'!
allTests
	| tests |
	tests := OrderedCollection new.
	self testClasses do: [:testClass | 
		testClass isAbstract 
			ifFalse: [testClass inheritedTestSelectors 
						do: [:selector | tests add: (MethodReference 
													class: testClass selector: selector)]]].
	^ tests! !

!SProject methodsFor: 'tests' stamp: 'mp 1/24/2011 17:07:40.738'!
allTestsAsEntryPoints
	^ self allTests collect: [:each | STestCaseEntryPoint onTestMethodReference: each]! !

!SProject methodsFor: 'tests' stamp: 'mp 6/23/2010 16:49'!
allTestsWithoutLongRunning
	^ self allTests reject: [:each | each actualClass inheritsFrom: LongTestCase]! !

!SProject methodsFor: 'tests' stamp: 'mp 4/1/2011 11:54:44.742'!
allUserStories
	| userStories |
	userStories := OrderedCollection new.
	Smalltalk 
		at: #ACUserStory 
		ifPresent: [:aClass | 	userStories := self testClasses 
								select: [:each | each inheritsFrom: ACUserStory]].
	^ userStories asOrderedCollection! !

!SProject methodsFor: 'accessing' stamp: 'mp 6/16/2010 21:52'!
categories
	"Answer the value of categories"

	^ categories ifNil: [categories := #()]! !

!SProject methodsFor: 'accessing' stamp: 'mp 6/11/2010 15:06'!
categories: anObject
	"Set the value of categories"

	categories := anObject! !

!SProject methodsFor: 'categories' stamp: 'mp 6/11/2010 16:43'!
categoriesOrderedByTestsFirst
	| testCategories allOtherCategories |
	testCategories := self categoriesWithTests asSortedCollection asOrderedCollection.
	allOtherCategories := self categories asSortedCollection asOrderedCollection
					 reject: [:each | testCategories includes: each].
	^ (testCategories, allOtherCategories) asArray! !

!SProject methodsFor: 'categories' stamp: 'mp 6/11/2010 16:43'!
categoriesWithTests

	^ (self testClasses inject: Set new into: [:sum :each | 
		sum 
			add: each category; 
			yourself]) asArray! !

!SProject methodsFor: 'accessing' stamp: 'mp 9/1/2010 11:20:18.676'!
classesCache
	"Answer the value of classesCache"

	^ classesCache! !

!SProject methodsFor: 'accessing' stamp: 'mp 9/1/2010 11:20:18.681'!
classesCache: anObject
	"Set the value of classesCache"

	classesCache := anObject! !

!SProject methodsFor: 'classes' stamp: 'mp 6/11/2010 15:53'!
classesOfCategory: aCategory

	^ self allClasses select: [:each | each category = aCategory]! !

!SProject methodsFor: 'accessing' stamp: 'mp 9/1/2010 11:21:43.434'!
concerns
	"Answer the value of concerns"

	^ concerns ifNil: [concerns := SConcernsRepository new]! !

!SProject methodsFor: 'accessing' stamp: 'mp 9/1/2010 11:20:18.688'!
concerns: anObject
	"Set the value of concerns"

	concerns := anObject! !

!SProject methodsFor: 'accessing' stamp: 'mp 3/21/2011 14:40:04.827'!
coverage
	"Answer the value of coverage"

	^ coverage ifNil: [coverage := Dictionary new]! !

!SProject methodsFor: 'accessing' stamp: 'mp 3/21/2011 14:39:49.332'!
coverage: anObject
	"Set the value of coverage"

	coverage := anObject! !

!SProject methodsFor: 'coverage' stamp: 'mp 5/12/2011 14:20:23.837'!
coveredTestsFor: aMethodReference
	| coveringTests |
	(self isClassInProject: (Smalltalk at: aMethodReference classSymbol))
		ifTrue: [
				coveringTests := Set new.
				self coverage keysAndValuesDo: [:test :coveredMethods |
					(coveredMethods includesKey: aMethodReference)
						ifTrue: [coveringTests add: test]].
				^ coveringTests asOrderedCollection]
		ifFalse: [^ {}].! !

!SProject methodsFor: 'buckets' stamp: 'mp 1/31/2012 13:56:52.435'!
harvestedBuckets
	"Answer the value of harvestedBuckets"

	^ harvestedBuckets ifNil: [harvestedBuckets := Dictionary new]! !

!SProject methodsFor: 'buckets' stamp: 'mp 1/31/2012 13:56:32.082'!
harvestedBuckets: anObject
	"Set the value of harvestedBuckets"

	harvestedBuckets := anObject! !

!SProject methodsFor: 'testing' stamp: 'mp 6/1/2011 13:42:28.081'!
hasConcernsDefined
	^ self concerns groups notEmpty! !

!SProject methodsFor: 'accessing' stamp: 'mp 3/14/2012 17:31:41.981'!
hasContracts
	"Answer the value of hasContracts"

	^ hasContracts ifNil: [hasContracts := false]! !

!SProject methodsFor: 'accessing' stamp: 'mp 3/14/2012 17:31:10.987'!
hasContracts: anObject
	"Set the value of hasContracts"

	hasContracts := anObject! !

!SProject methodsFor: 'coverage' stamp: 'mp 3/21/2011 15:13:35.189'!
isClassInProject: aClass
	^ self allClasses includes: aClass! !

!SProject methodsFor: 'metrics' stamp: 'mp 6/11/2010 16:28'!
loc
	"Lines of Code"
	^ self allClasses inject: 0 into: [:sum :each | sum + each linesOfCode]! !

!SProject methodsFor: 'method categories' stamp: 'mp 9/28/2010 14:39:15.116'!
methodCategories: aClass withQuick: aBoolean
	| categories |
	categories := #().
	aClass organization elementArray ifNotEmpty: [
		categories := (aClass organization categories select: [:each | 
							(aClass organization isEmptyCategoryNamed: each) not]).
	aBoolean 
		ifFalse: [categories := categories 
						select: [:each | (aClass organization listAtCategoryNamed: each)
							anySatisfy: [:symbol | (aClass >> symbol) isQuick not]]]].
	aClass isMeta
		ifTrue: [categories := categories collect: [:each | (each, ' (class)') asSymbol]].					
	^ categories! !

!SProject methodsFor: 'method categories' stamp: 'mp 9/28/2010 14:08:56.934'!
methodCategoriesOfClass: aClass
	^ self methodCategoriesOfClass: aClass withQuick: true! !

!SProject methodsFor: 'method categories' stamp: 'mp 9/28/2010 14:34:13.497'!
methodCategoriesOfClass: aClass withQuick: aBoolean
	^ (self methodCategories: aClass withQuick: aBoolean), 
		(self methodCategories: aClass class withQuick: aBoolean)! !

!SProject methodsFor: 'classes' stamp: 'mp 9/28/2010 19:20:29.26'!
methodsPerClass: aClass 
	^ self methodsPerClass: aClass withQuick: true! !

!SProject methodsFor: 'method categories' stamp: 'mp 9/28/2010 13:52:52.311'!
methodsPerClass: aClass andMethodCategory: aCategory
	^ self methodsPerClass: aClass andMethodCategory: aCategory withQuick: true! !

!SProject methodsFor: 'method categories' stamp: 'mp 9/28/2010 13:55:06.804'!
methodsPerClass: aClass andMethodCategory: aCategory withQuick: aBoolean
	| categoryName symbols |
	(aCategory includesSubString: ' (class)')
		ifTrue: [
			"without  (class)"
			categoryName := (aCategory copyFrom: 1 to: aCategory size - 8) asSymbol. 
			symbols := aClass class organization listAtCategoryNamed: categoryName.
			aBoolean 
				ifFalse: [^ symbols select: [:each | (aClass class >> each) isQuick not]]]
		ifFalse: [symbols := aClass organization listAtCategoryNamed: aCategory.
			aBoolean 
				ifFalse: [^ symbols select: [:each | (aClass >> each) isQuick not]]].
		^ symbols! !

!SProject methodsFor: 'classes' stamp: 'mp 9/28/2010 19:51:06.388'!
methodsPerClass: aClass withQuick: aBoolean
	aBoolean ifFalse: [^ (aClass methodDict keys 
							select: [:each | (aClass >> each) isQuick not]) sorted].
	^ aClass methodDict keys sorted! !

!SProject methodsFor: 'printing' stamp: 'mp 5/16/2011 15:38:12.178'!
metricsOverviewString

	^ self nop asString, ' Categories, ',
		self noc asString, ' Classes, and ',
		self nom asString, ' Methods (', self loc asString, ' LoC)'! !

!SProject methodsFor: 'metrics' stamp: 'mp 6/11/2010 16:27'!
noc
	"Number of Classes"
	^ self allClasses size! !

!SProject methodsFor: 'metrics' stamp: 'mp 6/11/2010 16:26'!
nom
	"Number of Methods"
	^ self categories inject: 0 into: [:sum :each | sum := sum + (self nomOfCategory: each)]! !

!SProject methodsFor: 'metrics' stamp: 'mp 9/28/2010 17:42:33.152'!
nomOfCategory: aCategory

	^ self nomOfCategory: aCategory withQuick: true! !

!SProject methodsFor: 'metrics' stamp: 'mp 9/28/2010 17:43:36.207'!
nomOfCategory: aCategory withQuick: aBoolean

	^ (self classesOfCategory: aCategory) 
		inject: 0 into: [:sum :each | sum := sum + (self nomOfClass: each withQuick: aBoolean)].! !

!SProject methodsFor: 'metrics' stamp: 'mp 9/28/2010 14:42:43.223'!
nomOfClass: aClass
	^ self nomOfClass: aClass withQuick: true! !

!SProject methodsFor: 'metrics' stamp: 'mp 9/28/2010 14:03:12.72'!
nomOfClass: aClass methodCategory: aCategory

	^ self nomOfClass: aClass methodCategory: aCategory withQuick: true! !

!SProject methodsFor: 'metrics' stamp: 'mp 9/28/2010 14:03:50.274'!
nomOfClass: aClass methodCategory: aCategory withQuick: aBoolean

	^ (self 
		methodsPerClass: aClass 
		andMethodCategory: aCategory 
		withQuick: aBoolean) size! !

!SProject methodsFor: 'metrics' stamp: 'mp 9/28/2010 14:47:07.991'!
nomOfClass: aClass withQuick: aBoolean
	aBoolean ifFalse: [
		^ (aClass methodDict keys select: [:each | (aClass >> each) isQuick not]) size +
	(aClass class methodDict keys select: [:each | (aClass class >> each) isQuick not]) size].
	^ aClass methodDict size + aClass class methodDict size! !

!SProject methodsFor: 'metrics' stamp: 'mp 9/28/2010 19:43:13.278'!
nomOfOneSideClass: aClass withQuick: aBoolean
	aBoolean ifFalse: [^ (aClass methodDict keys 
							select: [:each | (aClass >> each) isQuick not]) size].
	^ aClass methodDict size! !

!SProject methodsFor: 'metrics' stamp: 'mp 9/22/2011 15:19:25.839'!
nomWithoutLowComplexity
	"Number of Methods with a complexity > 1"
	^ (self allMethods select: [:each | each compiledMethod complexity > 1]) size! !

!SProject methodsFor: 'metrics' stamp: 'mp 6/11/2010 16:27'!
nop
	"Number of Packages Here: Categories"
	^ self categories size! !

!SProject methodsFor: 'printing' stamp: 'mp 1/31/2012 14:21:21.78'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' <', self projectName, '>'.! !

!SProject methodsFor: 'printing' stamp: 'mp 1/31/2012 14:21:58.285'!
printString

	^ self == SProject current
		ifTrue: [self projectName, ' <current>']
		ifFalse: [self projectName]! !

!SProject methodsFor: 'accessing' stamp: 'mp 6/11/2010 15:06'!
projectName
	"Answer the value of projectName"

	^ projectName! !

!SProject methodsFor: 'accessing' stamp: 'mp 6/11/2010 15:06'!
projectName: anObject
	"Set the value of projectName"

	projectName := anObject! !

!SProject methodsFor: 'classes' stamp: 'mp 1/2/2012 14:04:35.215'!
removeFromClassesCache: aClass
	classesCache := self allClasses reject: [:each | each = aClass].! !

!SProject methodsFor: 'accessing' stamp: 'tfel 7/4/2011 10:46:40.925'!
removeViewNamed: aString

	self views removeKey: aString ifAbsent: [].! !

!SProject methodsFor: 'classes' stamp: 'mp 6/11/2010 15:56'!
resetClassesCache

	classesCache := nil.! !

!SProject methodsFor: 'classes' stamp: 'mp 1/2/2012 13:54:33.425'!
testClasses
	^ self allClasses select: [:each | each inheritsFrom: TestCase]! !

!SProject methodsFor: 'classes' stamp: 'mp 6/11/2010 15:53'!
testClassesOfCategory: aCategory

	^ self testClasses select: [:each | each category = aCategory]! !

!SProject methodsFor: 'buckets' stamp: 'mp 1/31/2012 14:06:10.529'!
typesBucket
	"Answer the value of typesBucket"

	^ self harvestedBuckets 
		at: THTypeHarvester asString asSymbol
		ifAbsent: [nil]! !

!SProject methodsFor: 'buckets' stamp: 'tfel 2/14/2012 10:32:27.158'!
typesBucket: aTHBucket

	^ self harvestedBuckets 
		at: THTypeHarvester asString asSymbol
		put: aTHBucket! !

!SProject methodsFor: 'buckets' stamp: 'mp 2/9/2012 13:47:05.149'!
valueRangeBucket
	^ self harvestedBuckets 
		at: SValueRangeHarvester asString asSymbol
		ifAbsent: [nil]! !

!SProject methodsFor: 'accessing' stamp: 'tfel 6/21/2011 15:41:34.555'!
viewNamed: aString

	^ self views at: aString ifAbsent: []! !

!SProject methodsFor: 'accessing' stamp: 'tfel 6/21/2011 15:40:45.208'!
views

	^ views ifNil: [views := Dictionary new]! !

!SProject methodsFor: 'accessing' stamp: 'mp 3/14/2012 17:31:10.963'!
views: anObject
	"Set the value of views"

	views := anObject! !

Object subclass: #SSourceCodeEntityAdapter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Models'!

SSourceCodeEntityAdapter subclass: #SCategoryAdapter
	instanceVariableNames: 'category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Models'!

!SCategoryAdapter class methodsFor: 'instance creation' stamp: 'mp 1/21/2010 10:14'!
on: aCategory

	^ self new
		category: aCategory! !

!SCategoryAdapter methodsFor: 'accessing' stamp: 'mp 1/21/2010 10:13'!
category
	"Answer the value of category"

	^ category! !

!SCategoryAdapter methodsFor: 'accessing' stamp: 'mp 1/21/2010 10:13'!
category: anObject
	"Set the value of category"

	category := anObject! !

!SCategoryAdapter methodsFor: 'testing' stamp: 'mp 1/21/2010 10:14'!
isCategory

	^ true! !

!SCategoryAdapter methodsFor: 'printing' stamp: 'mp 1/21/2010 10:13'!
printString

	^ self category! !

!SSourceCodeEntityAdapter methodsFor: 'testing' stamp: 'mp 1/21/2010 10:10'!
isCategory

	^ false! !

!SSourceCodeEntityAdapter methodsFor: 'testing' stamp: 'mp 1/21/2010 10:12'!
isTestCategory

	^ false! !

!SSourceCodeEntityAdapter methodsFor: 'testing' stamp: 'mp 1/21/2010 10:10'!
isTestClass

	^ false! !

!SSourceCodeEntityAdapter methodsFor: 'testing' stamp: 'mp 1/21/2010 10:11'!
isTestMethod

	^ false! !

Object subclass: #STool
	instanceVariableNames: 'windowMorph windowSpec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Tools'!

STool subclass: #SCategoryChooser
	instanceVariableNames: 'selectedCategoriesList userOk project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Tools'!

!SCategoryChooser class methodsFor: 'accessing' stamp: 'mp 6/23/2010 11:38'!
allCategories

	| categories |
	categories := Set new.
	Smalltalk allClasses do: [:each | 
		each category ifNotNil: [	categories add: each category]].
	^ categories asSortedCollection asArray! !

!SCategoryChooser class methodsFor: 'instance creation' stamp: 'mp 6/16/2010 21:50'!
on: aProject
	| tool |
	tool := self open.
	tool
		project: aProject;
		setCategoryListFromNames.
	^ tool
! !

!SCategoryChooser class methodsFor: 'instance creation' stamp: 'mp 6/16/2010 21:49'!
open
	| tool |
	tool := super open.
	tool setCategoryListFromNames.
	^ tool! !

!SCategoryChooser methodsFor: 'accessing' stamp: 'mp 1/20/2010 15:34'!
allCategoryNames
	^ self selectedCategoriesList collect: [ :each | each key ]! !

!SCategoryChooser methodsFor: 'building' stamp: 'mp 1/21/2010 09:45'!
buildButtonPanelOn: aBuilder

	self windowSpec children add: (aBuilder pluggablePanelSpec new
		layout: #vertical;
		frame: (0.00 @ 0.75 corner: 1.00 @ 1.00);
		children: {
			self buildButtonsWith: aBuilder from: self selectButtons.
			self buildButtonsWith: aBuilder from: self userButtons.
			};
		yourself).! !

!SCategoryChooser methodsFor: 'building' stamp: 'mp 1/21/2010 09:46'!
buildCategoryListOn: aBuilder

	| listSpec |
	listSpec := aBuilder pluggableMultiSelectionListSpec new.
	listSpec
		model: self;
		name: #categoryList;
		list: #allCategoryNames;
		menu: #categoryMenu:;
		getSelectionList: #selectedCategoryAt:;
		setSelectionList: #selectedCategoryAt:put:;
		frame: (0 @ 0 corner: 1 @ 0.75).
	self windowSpec children add: listSpec.
	! !

!SCategoryChooser methodsFor: 'building' stamp: 'mp 1/20/2010 16:06'!
buildWith: aBuilder 
	
	self
		buildWindowOn: aBuilder;
		buildCategoryListOn: aBuilder;
		buildButtonPanelOn: aBuilder.

	^ super buildWith: aBuilder
! !

!SCategoryChooser methodsFor: 'actions' stamp: 'mp 1/20/2010 15:34'!
cancel

	self userOk: false.
	self windowMorph abandon.! !

!SCategoryChooser methodsFor: 'building' stamp: 'mp 1/20/2010 15:34'!
categoryMenu: aMenu

	^ aMenu
		title: 'Categories';
		add: 'Select all' action: #selectAll;
		add: 'Select inversion' action: #selectInverse;
		add: 'Select none' action: #selectNone;
		yourself.! !

!SCategoryChooser methodsFor: 'accessing' stamp: 'mp 1/20/2010 15:34'!
getSelectedCategoryNames
	^ (self selectedCategoriesList
		select: [:each | each value]
		thenCollect: [:each | each key]) asArray! !

!SCategoryChooser methodsFor: 'user interface' stamp: 'mp 1/20/2010 15:34'!
initialExtent

	^ 300@300! !

!SCategoryChooser methodsFor: 'initialize-release' stamp: 'mp 7/7/2010 16:55:05.741'!
initialize

	self userOk: false.
	self project: SProject new.! !

!SCategoryChooser methodsFor: 'accessing' stamp: 'mp 3/15/2010 16:58'!
label

	^ 'Select Categories'! !

!SCategoryChooser methodsFor: 'actions' stamp: 'mp 3/8/2011 18:11:29.622'!
ok

	self userOk: true.
	self storeSelectedCategories.
	self changed.
	self windowMorph abandon.! !

!SCategoryChooser methodsFor: 'accessing' stamp: 'mp 6/16/2010 21:47'!
project
	"Answer the value of project"

	^ project! !

!SCategoryChooser methodsFor: 'accessing' stamp: 'mp 6/16/2010 21:47'!
project: anObject
	"Set the value of project"

	project := anObject! !

!SCategoryChooser methodsFor: 'actions' stamp: 'mp 1/20/2010 15:34'!
selectAll

	self selectedCategoriesList do: [:each | each value: true].
	self changed: #allCategoryNames.! !

!SCategoryChooser methodsFor: 'building' stamp: 'mp 9/1/2010 12:22:24.768'!
selectButtons

	^ #(
		( 'All' #selectAll #alwaysEnabled)
		( 'Inverse' #selectInverse #alwaysEnabled)
		( 'None' #selectNone #alwaysEnabled)	
		)! !

!SCategoryChooser methodsFor: 'actions' stamp: 'mp 1/20/2010 15:34'!
selectInverse

	self selectedCategoriesList do: [:each | each value: each value not].
	self changed: #allCategoryNames.! !

!SCategoryChooser methodsFor: 'actions' stamp: 'mp 1/20/2010 15:34'!
selectNone

	self selectedCategoriesList do: [:each | each value: false].
	self changed: #allCategoryNames.! !

!SCategoryChooser methodsFor: 'accessing' stamp: 'mp 6/16/2010 21:34'!
selectedCategoriesList
	^ selectedCategoriesList ifNil: [selectedCategoriesList := #()]! !

!SCategoryChooser methodsFor: 'accessing' stamp: 'mp 1/20/2010 15:34'!
selectedCategoriesList: anObject
	selectedCategoriesList := anObject! !

!SCategoryChooser methodsFor: 'list commands' stamp: 'mp 1/20/2010 15:34'!
selectedCategoryAt: anIndex 
	^ (self selectedCategoriesList at: anIndex) value! !

!SCategoryChooser methodsFor: 'list commands' stamp: 'mp 1/20/2010 15:50'!
selectedCategoryAt: anIndex put: aBoolean 
	| result |
	result := (self selectedCategoriesList at: anIndex) value: aBoolean.
	self windowMorph changed.
	^ result! !

!SCategoryChooser methodsFor: 'initialize-release' stamp: 'mp 6/16/2010 21:50'!
setCategoryListFromNames

	self selectedCategoriesList: (self class allCategories 
		inject: OrderedCollection new 
		into: [:coll :each | coll 
						add: each -> (self project categories includes: each);
						yourself]).
	self changed: #allCategoryNames.! !

!SCategoryChooser methodsFor: 'actions' stamp: 'mp 6/16/2010 21:51'!
storeSelectedCategories
	self project categories: self getSelectedCategoryNames.! !

!SCategoryChooser methodsFor: 'building' stamp: 'mp 1/20/2010 15:34'!
userButtons

	^ #(
		( 'Ok' #ok #alwaysEnabled)
		( 'Cancel' #cancel #alwaysEnabled)
		).! !

!SCategoryChooser methodsFor: 'accessing' stamp: 'mp 1/20/2010 15:34'!
userOk
	^ userOk! !

!SCategoryChooser methodsFor: 'accessing' stamp: 'mp 1/20/2010 15:34'!
userOk: anObject
	userOk := anObject! !

STool subclass: #SConcernChooser
	instanceVariableNames: 'options project selectedConcernItem selectedTestItem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Tools'!

!SConcernChooser class methodsFor: 'instance creation' stamp: 'mp 2/3/2012 11:42:14.106'!
on: aTraceabilityOptions
	| tool |
	tool := self open.
	tool 
		options: aTraceabilityOptions;
		project: aTraceabilityOptions pathMap project;
		reloadUIData.
	^ tool! !

!SConcernChooser methodsFor: 'acceptIt Button' stamp: 'mp 4/1/2011 11:56:28.596'!
acceptItButtonEnabled
	self project ifNil: [^ false].
	^ self project allUserStories notEmpty! !

!SConcernChooser methodsFor: 'acceptIt Button' stamp: 'mp 4/1/2011 12:58:10.985'!
acceptItGroupName
	^ 'AcceptIt Stories'! !

!SConcernChooser methodsFor: 'concern button' stamp: 'mp 9/1/2010 18:37:25.589'!
addConcern
	| concern |
	concern := (UIManager default request: 'Please insert a concern name:').
	(self concernGroups at: self selectedGroup) add: concern.
	self concernColors at: concern put: (Color h: 360 atRandom s: 1.0 v: 1.0).
	self refreshDeselectedConcernTree.

	! !

!SConcernChooser methodsFor: 'group button' stamp: 'mp 9/2/2010 15:27:23.146'!
addConcernGroup
	| group |
	group := (UIManager default request: 'Please insert concern group name:').
	((self concernGroups keys includes: group) or: [group isEmpty])
		ifTrue: [^ self inform: 'The group name is not allowed.'].
	self concernGroups at: group put: OrderedCollection new.
	self changed: #rootsConcerns.
	! !

!SConcernChooser methodsFor: 'mapping button' stamp: 'mp 3/24/2011 11:05:58.615'!
addMapping
	| tests |
	tests := OrderedCollection new.
	self isTestClassSelected
		ifTrue: [	self selectedTestClass inheritedTestSelectors 
					do: [:each | tests add: (MethodReference 
											class: self selectedTestClass 
											selector: each)].
				tests := tests select: [:each | (self project concerns 
												mappingExisting: self selectedConcern 
												and: each) not]]
		ifFalse: [tests add: self selectedTest].
	tests do: [:each | (self concernMapping 
						at: self selectedConcern 
						ifAbsentPut: [OrderedCollection new]) add: each].

! !

!SConcernChooser methodsFor: 'building' stamp: 'mp 9/1/2010 12:20:53.209'!
buildButtonsOn: aBuilder

	self windowSpec children add: (aBuilder pluggablePanelSpec new
		layout: #vertical;
		frame: (0.00 @ 0.9 corner: 1.00 @ 1.00);
		children: {self buildButtonsWith: aBuilder from: self concernButtons};
		yourself).! !

!SConcernChooser methodsFor: 'building' stamp: 'mp 9/2/2010 13:04:31.219'!
buildConcernTreeOn: aBuilder
	| treeSpec |
	treeSpec := aBuilder pluggableTreeSpec new.
	treeSpec
		model: self;
		name: #concernTree;
		roots: #rootsConcerns;
		hasChildren: #hasChildrenConcerns:;
		getChildren: #getChildrenConcerns:;
		label: #labelTree:;
		setSelected: #newSelectedConcernItem:;
		icon: #iconForConcernItem:;		
		frame: (0 @ 0 corner: 0.5 @ 0.9).
	self windowSpec children add: treeSpec.! !

!SConcernChooser methodsFor: 'building' stamp: 'mp 9/2/2010 15:02:21.691'!
buildTestTreeOn: aBuilder
	| treeSpec |
	treeSpec := aBuilder pluggableTreeSpec new.
	treeSpec
		model: self;
		name: #testTree;
		roots: #rootsTestClasses;
		hasChildren: #hasChildrenTest:;
		getChildren: #getChildrenTest:;
		label: #labelTree:;
		setSelected: #newSelectedTestItem:;
		icon: #iconForConcernTestItem:;
		frame: (0.5 @ 0 corner: 1 @ 0.9).
	self windowSpec children add: treeSpec.! !

!SConcernChooser methodsFor: 'building' stamp: 'mp 9/13/2010 19:05:15.178'!
buildWith: aBuilder 
	self 
		buildWindowOn: aBuilder;
		buildConcernTreeOn: aBuilder;
		buildTestTreeOn: aBuilder;
		buildButtonsOn: aBuilder.
	^ super buildWith: aBuilder! !

!SConcernChooser methodsFor: 'color button' stamp: 'mp 9/1/2010 18:37:51.663'!
colorAction
	ColorPickerMorph new
		choseModalityFromPreference;
		sourceHand: self windowMorph activeHand;
		target: self;
		selector: #setIconColorOfSelectedConcern:;
		originalColor: (self concernColors at: self selectedConcern);
		putUpFor: self windowMorph near: self windowMorph fullBoundsInWorld.! !

!SConcernChooser methodsFor: 'color button' stamp: 'mp 9/2/2010 09:20:19.808'!
colorEnabled

	^ self isConcernSelected
! !

!SConcernChooser methodsFor: 'concern button' stamp: 'mp 9/2/2010 09:21:08.885'!
concernButtonAction
	self isConcernGroupSelected
		ifTrue: [self addConcern].
	self isConcernSelected
		ifTrue: [self removeConcern].! !

!SConcernChooser methodsFor: 'concern button' stamp: 'mp 9/2/2010 15:29:16.295'!
concernButtonEnabled
	^ self isConcernGroupSelected or: [self isConcernSelected]
! !

!SConcernChooser methodsFor: 'concern button' stamp: 'mp 9/2/2010 09:20:41.945'!
concernButtonLabel
	self isConcernSelected ifTrue: [^ 'Remove Concern'].
	^ 'Add Concern'! !

!SConcernChooser methodsFor: 'building' stamp: 'mp 4/1/2011 11:48:54.889'!
concernButtons
	^ #(
		( #groupButtonLabel #groupButtonAction #groupButtonEnabled)
		( #concernButtonLabel #concernButtonAction #concernButtonEnabled)
		( 'Choose Color' #colorAction #colorEnabled)
		( #mappingButtonLabel #mappingButtonAction #mappingButtonEnabled)
		('AcceptIt Mapping' #createAcceptItMapping #acceptItButtonEnabled)				
		)! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/2/2010 15:29:36.941'!
concernColors
	^ self project concerns colors ! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/2/2010 15:29:44.839'!
concernGroups
	^ self project concerns groups ! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/2/2010 15:29:56.591'!
concernMapping
	^ self project concerns mapping ! !

!SConcernChooser methodsFor: 'acceptIt Button' stamp: 'mp 4/1/2011 13:11:02.1'!
connectConcernsWithScenarios
	| userStories userStory |
	userStories := self project allUserStories.
	self concernMapping keys do: [:each | 
		userStory := userStories detect: [:story | story asString = each].
		userStory allTestSelectors
			do: [:scenario | (self concernMapping at: each) add: 
				(MethodReference class: userStory selector: scenario)]].! !

!SConcernChooser methodsFor: 'acceptIt Button' stamp: 'mp 4/1/2011 12:48:09.117'!
createAcceptItConcernGroup
	(self concernGroups keys includes: self acceptItGroupName)
		ifTrue: [self removeConcernGroup: self acceptItGroupName].
	self concernGroups at: self acceptItGroupName put: OrderedCollection new.! !

!SConcernChooser methodsFor: 'acceptIt Button' stamp: 'mp 4/1/2011 12:08:56.72'!
createAcceptItMapping

	self
		createAcceptItConcernGroup;
		createConcernsforEachUserStory;
		connectConcernsWithScenarios;
		reloadUIData.! !

!SConcernChooser methodsFor: 'acceptIt Button' stamp: 'mp 4/1/2011 13:06:10.834'!
createConcernsforEachUserStory
	| concern userStories |
	userStories := self project allUserStories.
	userStories withIndexDo: [:each :index | 
		concern := each asString.
		(self concernGroups at: self acceptItGroupName) add: concern.
		self concernColors at: concern 
			put: (Color h: (360 / userStories size) * (index -1) s: 1.0 v: 1.0).
		self concernMapping at: concern put: OrderedCollection new].
	self refreshDeselectedConcernTree.! !

!SConcernChooser methodsFor: 'concern tree' stamp: 'mp 9/2/2010 14:19:21.001'!
getChildrenConcerns: aCollection
	"size corresponds to depth of tree"
	"concern groups"
	aCollection size = 1 
		ifTrue: [^ (self concernGroups at: aCollection first) asSortedCollection 
					collect: [:each | {aCollection first. each}]].
	"concerns"
	aCollection size = 2 
		ifTrue: [	^ (self project concerns testClassesOfConcern: aCollection second)
					collect: [:each | {aCollection first. aCollection second. each}]].
	"test classes"
	aCollection size = 3
		ifTrue: [^ (self project concerns 
					testSelectorsOfClass: aCollection third 
					andConcern: aCollection second)
						collect: [:each | {aCollection first. aCollection second. 
										aCollection third. each}]].! !

!SConcernChooser methodsFor: 'test tree' stamp: 'mp 3/24/2011 11:05:53.89'!
getChildrenTest: aCollection
	"size corresponds to depth of tree"
	| testRef concerns |
	"test classes"
	aCollection size = 1 
		ifTrue: [ ^ aCollection first inheritedTestSelectors collect: [:each | {aCollection first. each}]].
	"test selectors"
	aCollection size = 2 
		ifTrue: [	testRef := MethodReference 
							class: aCollection first  selector: aCollection second. 
				concerns := self project concerns concernsOfTest: testRef.
				^ (self project concerns groupsOfConcerns: concerns)
					collect: [:each | {aCollection first. aCollection second. each}]].
	"concern groups"
	aCollection size = 3
		ifTrue: [	testRef := MethodReference 
							class: aCollection first  selector: aCollection second. 
				^ (self project concerns concernsOfGroup: aCollection third andTest: testRef)
					collect: [:each | {aCollection first. aCollection second. 
									aCollection third. each}]].! !

!SConcernChooser methodsFor: 'user interface' stamp: 'mp 9/2/2010 15:16:11.317'!
getIconForConcernFrom: aCollection at: aNumber
	| icon |
	(aCollection size = aNumber) ifFalse: [^ nil].
	(self concernColors includesKey: (aCollection at: aNumber))
		ifTrue: [
			icon := Form extent: 15@15 depth: 32.
			icon fillColor: (self concernColors at: (aCollection at: aNumber)).
			^ icon].
	^ nil! !

!SConcernChooser methodsFor: 'group button' stamp: 'mp 9/2/2010 09:24:02.229'!
groupButtonAction
	self isConcernGroupSelected
		ifTrue: [self removeConcernGroup]
		ifFalse: [self addConcernGroup].
	
	! !

!SConcernChooser methodsFor: 'group button' stamp: 'mp 9/2/2010 15:51:53.281'!
groupButtonEnabled

	^ (self selectedConcernItem isNil or: 
		[self isConcernGroupSelected]) or: 
			[self isConcernSelected]! !

!SConcernChooser methodsFor: 'group button' stamp: 'mp 9/2/2010 09:23:42.281'!
groupButtonLabel
	self isConcernGroupSelected
		ifTrue: [^ 'Remove Group']
		ifFalse: [^ 'Add Group'].
	! !

!SConcernChooser methodsFor: 'concern tree' stamp: 'mp 9/2/2010 14:19:10.794'!
hasChildrenConcerns: aCollection		
	"size corresponds to depth of tree"
	"concern groups"
	aCollection size = 1 
		ifTrue: [^ (self concernGroups at: aCollection first) notEmpty].
	"concerns"
	aCollection size = 2 
		ifTrue: [	(self concernMapping includesKey: aCollection second)
					ifTrue: [^ (self concernMapping at: aCollection second) notEmpty]].	
	"test classes"
	^ aCollection size = 3 ! !

!SConcernChooser methodsFor: 'test tree' stamp: 'mp 3/24/2011 11:05:50.509'!
hasChildrenTest: aCollection
	"size corresponds to depth of tree"
	| testRef |
	"test classes"
	aCollection size = 1 
		ifTrue: [^ aCollection first inheritedTestSelectors notEmpty].
	"test selectors"
	aCollection size = 2 
		ifTrue: [testRef := MethodReference 
							class: aCollection first  selector: aCollection second. 
			^ (self project concerns concernsOfTest: testRef) notEmpty].
	"concern groups"
	^ aCollection size = 3! !

!SConcernChooser methodsFor: 'concern tree' stamp: 'mp 9/2/2010 15:15:36.516'!
iconForConcernItem: aCollection
	^ self getIconForConcernFrom: aCollection at: 2! !

!SConcernChooser methodsFor: 'test tree' stamp: 'mp 9/2/2010 15:16:39.3'!
iconForConcernTestItem: aCollection
	^ self getIconForConcernFrom: aCollection at: 4! !

!SConcernChooser methodsFor: 'user interface' stamp: 'mp 9/1/2010 11:38:51.286'!
initialExtent

	^ 500@400! !

!SConcernChooser methodsFor: 'concern button' stamp: 'mp 9/2/2010 12:05:27.768'!
isConcernGroupSelected
	^ self selectedConcernItem notNil and: [self selectedConcernItem size = 1]! !

!SConcernChooser methodsFor: 'concern button' stamp: 'mp 9/2/2010 12:06:44.23'!
isConcernSelected
	^ self selectedConcernItem notNil and: [self selectedConcernItem size = 2]! !

!SConcernChooser methodsFor: 'mapping button' stamp: 'mp 3/24/2011 11:05:44.091'!
isSelectedMappingExisting
	self isConcernSelected ifFalse: [^ false].
	(self concernMapping includesKey: self selectedConcern) ifFalse: [^ false].
	self isTestClassSelected
		ifTrue: [	^ ((self concernMapping at: self selectedConcern) 
				select: [:each | each actualClass == self selectedTestClass]) size = 
					self selectedTestClass inheritedTestSelectors size].
	self isTestSelectorSelected
		ifTrue: [^ self project concerns 
					mappingExisting: self selectedConcern and: self selectedTest].
	^ false! !

!SConcernChooser methodsFor: 'mapping button' stamp: 'mp 9/2/2010 12:07:55.58'!
isTestClassSelected
	^ self selectedTestItem notNil and: [self selectedTestItem size = 1]! !

!SConcernChooser methodsFor: 'mapping button' stamp: 'mp 9/2/2010 12:08:04.046'!
isTestSelectorSelected
	^ self selectedTestItem notNil and: [self selectedTestItem size = 2]! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/22/2010 18:12:47.742'!
label

	^ 'Concern Mapping'! !

!SConcernChooser methodsFor: 'user interface' stamp: 'mp 9/2/2010 11:59:23.048'!
labelTree: aCollection

	^ aCollection last asString! !

!SConcernChooser methodsFor: 'mapping button' stamp: 'mp 9/2/2010 16:29:37.712'!
mappingButtonAction
	self isSelectedMappingExisting
		ifTrue: [self removeMapping]
		ifFalse: [self addMapping].
	self 
		selectedConcernItem: nil;
		selectedTestItem: nil;
		reloadUIData.! !

!SConcernChooser methodsFor: 'mapping button' stamp: 'mp 9/2/2010 09:25:38.111'!
mappingButtonEnabled

	^ self isConcernSelected and: [
		self isTestClassSelected or: [self isTestSelectorSelected]]! !

!SConcernChooser methodsFor: 'mapping button' stamp: 'mp 9/2/2010 16:13:07.302'!
mappingButtonLabel
	self isSelectedMappingExisting
		ifTrue: [^ 'Remove Mapping']
		ifFalse: [^ 'Add Mapping'].
! !

!SConcernChooser methodsFor: 'concern tree' stamp: 'mp 9/2/2010 12:02:58.282'!
newSelectedConcernItem: anObject
	self 
		selectedConcernItem: anObject;
		refreshButtons.! !

!SConcernChooser methodsFor: 'test tree' stamp: 'mp 9/2/2010 12:04:20.417'!
newSelectedTestItem: anObject
	self 
		selectedTestItem: anObject; 
		refreshButtons.! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 2/3/2012 11:42:28.85'!
options
	"Answer the value of options"

	^ options! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 2/3/2012 11:42:28.866'!
options: anObject
	"Set the value of options"

	options := anObject! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/1/2010 11:14:17.165'!
project
	"Answer the value of project"

	^ project! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/1/2010 11:14:17.169'!
project: anObject
	"Set the value of project"

	project := anObject! !

!SConcernChooser methodsFor: 'user interface' stamp: 'mp 4/1/2011 11:55:54.041'!
refreshButtons
	self
		changed: #groupButtonLabel;
		changed: #groupButtonEnabled;
		changed: #concernButtonLabel;
		changed: #concernButtonEnabled;
		changed: #colorEnabled;
		changed: #mappingButtonLabel;
		changed: #mappingButtonEnabled;
		changed: #acceptItButtonEnabled.! !

!SConcernChooser methodsFor: 'user interface' stamp: 'mp 9/2/2010 12:03:35.778'!
refreshDeselectedConcernTree
	self 
		selectedConcernItem: nil;
		refreshButtons;
		changed: #rootsConcerns.

	! !

!SConcernChooser methodsFor: 'user interface' stamp: 'mp 9/2/2010 15:42:58.909'!
refreshDeselectedTestTree
	self 
		selectedTestItem: nil;
		changed: #rootsTestClasses.

	! !

!SConcernChooser methodsFor: 'user interface' stamp: 'mp 9/1/2010 17:10:35.498'!
reloadUIData

	self 
		changed: #rootsTestClasses;
		changed: #rootsConcerns;
		refreshButtons.
	! !

!SConcernChooser methodsFor: 'concern button' stamp: 'mp 9/2/2010 15:43:13.315'!
removeConcern
	| concerns |
	(UIManager default confirm: 'Remove concern?')
		ifTrue: [	concerns := self concernGroups at: self selectedGroup.
				concerns remove: self selectedConcern.
				self concernColors removeKey: self selectedConcern ifAbsent: [].
				self concernMapping removeKey: self selectedConcern ifAbsent: [].		
				self 
					refreshDeselectedTestTree;
					refreshDeselectedConcernTree].! !

!SConcernChooser methodsFor: 'group button' stamp: 'mp 4/1/2011 12:11:22.934'!
removeConcernGroup
	self removeConcernGroup: self selectedGroup.! !

!SConcernChooser methodsFor: 'group button' stamp: 'mp 4/1/2011 12:11:03.29'!
removeConcernGroup: aGroup
	(UIManager default confirm: 'Remove group and all included concerns?')
		ifTrue: [ (self concernGroups at: aGroup) 
					do: [:each | 
						self concernColors removeKey: each ifAbsent: [].
						self concernMapping removeKey: each ifAbsent: []].
				self concernGroups removeKey: aGroup.
				self 
					refreshDeselectedTestTree;
					refreshDeselectedConcernTree].! !

!SConcernChooser methodsFor: 'mapping button' stamp: 'mp 9/2/2010 16:35:01.226'!
removeMapping
	self isTestClassSelected
		ifTrue: [((self concernMapping at: self selectedConcern) 
					select: [:each | each actualClass == self selectedTestClass])
					do: [:each | (self concernMapping at: self selectedConcern) remove: each]]
		ifFalse: [(self concernMapping at: self selectedConcern) remove: self selectedTest]
! !

!SConcernChooser methodsFor: 'concern tree' stamp: 'mp 9/2/2010 12:58:01.373'!
rootsConcerns
	self project ifNil: [^ #()].
	^ self concernGroups keys asSortedCollection collect: [:each | {each}]! !

!SConcernChooser methodsFor: 'test tree' stamp: 'mp 3/24/2011 11:05:28.912'!
rootsTestClasses
	self project ifNil: [^ #()].
	^ (self project testClasses asSortedCollection: [:a :b | a asString <= b asString])
		select: [:each | each inheritedTestSelectors notEmpty] 
		thenCollect: [:each | {each}]! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/2/2010 12:06:51.545'!
selectedConcern
	^ self selectedConcernItem second! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/2/2010 12:02:01.053'!
selectedConcernItem
	"Answer the value of selectedConcernItem"

	^ selectedConcernItem! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/2/2010 12:02:01.058'!
selectedConcernItem: anObject
	"Set the value of selectedConcernItem"

	selectedConcernItem := anObject! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/2/2010 12:06:55.964'!
selectedGroup
	^ self selectedConcernItem first! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/2/2010 12:08:14.08'!
selectedTest
	^ MethodReference 
		class: self selectedTestItem first 
		selector: self selectedTestItem second
	
	
	 ! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/2/2010 12:08:16.905'!
selectedTestClass
	^ self selectedTestItem first! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/2/2010 12:02:01.062'!
selectedTestItem
	"Answer the value of selectedTestItem"

	^ selectedTestItem! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/2/2010 12:02:01.066'!
selectedTestItem: anObject
	"Set the value of selectedTestItem"

	selectedTestItem := anObject! !

!SConcernChooser methodsFor: 'color button' stamp: 'mp 9/2/2010 15:09:23.677'!
setIconColorOfSelectedConcern: aColor
	self selectedConcernItem ifNil: [^ self].
	self concernColors at: self selectedConcern put: aColor.
	self 
		refreshDeselectedConcernTree;
		changed: #rootsTestClasses.! !

!SConcernChooser methodsFor: 'user interface' stamp: 'mp 2/3/2012 11:44:09.868'!
windowIsClosed
	self options concernsHaveChanged.! !

STool subclass: #SPathFinder
	instanceVariableNames: 'callgraphTracer callgraphModel testChooserModel coverageTracer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Tools'!

SPathFinder subclass: #SPathDebugger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Tools'!

!SPathDebugger methodsFor: 'building' stamp: 'mp 3/25/2011 12:40:13.291'!
callgraphModelClass
	^ SDebuggerCallgraphModel! !

!SPathDebugger methodsFor: 'building-pluggable-morphs' stamp: 'mp 3/25/2011 12:21:29.891'!
indentingListItemClass
	^ SDebuggerCodeExplorerIndentingListItemMorph! !

!SPathDebugger methodsFor: 'building-pluggable-morphs' stamp: 'mp 10/12/2011 12:10:57.757'!
toolName
	^ 'PathFinder'! !

!SPathFinder class methodsFor: 'private' stamp: 'mp 6/23/2010 11:23'!
convertMethodReferenceToString: aMethodReference
	^ aMethodReference classSymbol asString, 
		(aMethodReference classIsMeta ifTrue: [ ' class' ] ifFalse: ['']), 
		'>>', 
		aMethodReference methodSymbol asString! !

!SPathFinder class methodsFor: 'class initialization' stamp: 'mp 3/7/2011 21:49:20.381'!
initialize
	"self initialize"
	TheWorldMenu registerOpenCommand: {'PathFinder'. {self. #open}}.! !

!SPathFinder class methodsFor: 'instance creation' stamp: 'mp 3/7/2012 09:45:12.269'!
open
	SProject isNullProjectSelected
		ifTrue: [self inform: 'Please choose a project first and start PathFinder again.'.
				^ SProjectChooser open].
	^ super open.! !

!SPathFinder class methodsFor: 'instance creation' stamp: 'mp 3/24/2011 09:58:07.381'!
openOn: aTestMethodReference

	| pathFinder |
	pathFinder := self open.
	pathFinder testChooserModel setCurrentTest: aTestMethodReference.
	pathFinder changed: #label.
	^ pathFinder! !

!SPathFinder class methodsFor: 'instance creation' stamp: 'mp 10/31/2010 11:39:40.205'!
openOn: aTestMethodReference and: aMethodReference

	| pathFinder |
	pathFinder := self openOn: aTestMethodReference.
	pathFinder callgraphModel 
		searchNode: (self convertMethodReferenceToString: aMethodReference);
		changed: #getSearchQuery.
	^ pathFinder! !

!SPathFinder class methodsFor: 'instance creation' stamp: 'mp 3/25/2011 11:47:55.942'!
openOn: aTestMethodReference and: aMethodReference coverageTracer: aTracer
	| pathFinder |
	pathFinder := self openOn: aTestMethodReference coverageTracer: aTracer.
	pathFinder callgraphModel 
		searchNode: (self convertMethodReferenceToString: aMethodReference);
		changed: #getSearchQuery.
	^ pathFinder! !

!SPathFinder class methodsFor: 'instance creation' stamp: 'mp 3/25/2011 12:29:45.063'!
openOn: aTestMethodReference coverageTracer: aTracer
	| pathFinder |
	pathFinder := self open.
	pathFinder coverageTracer: aTracer.
	pathFinder testChooserModel setCurrentTest: aTestMethodReference.
	pathFinder changed: #label.
	^ pathFinder! !

!SPathFinder class methodsFor: 'instance creation' stamp: 'mp 10/31/2010 11:39:45.221'!
openOnCode: aSourceCodeString

	| pathFinder |
	pathFinder := self open.
	pathFinder testChooserModel setCurrentCode: aSourceCodeString.
	^ pathFinder! !

!SPathFinder class methodsFor: 'instance creation' stamp: 'mp 10/31/2010 11:39:49.691'!
openOnCode: aSourceCodeString and: aMethodReference

	| pathFinder |
	pathFinder := self openOnCode: aSourceCodeString.
	pathFinder callgraphModel 
		searchNode: (self convertMethodReferenceToString: aMethodReference);
		changed: #getSearchQuery.
	^ pathFinder! !

!SPathFinder class methodsFor: 'private' stamp: 'abc 5/7/2010 18:49'!
openWithPerformanceMesaureOn: aTestMethodReference
	| testExpander swFindNode |
	swFindNode := Stopwatch new.
	testExpander := self new.
	ToolBuilder open: testExpander.
	testExpander testChooserModel setCurrentTest: aTestMethodReference.
	swFindNode activate.
	(testExpander callgraphModel tracer getNode: (testExpander callgraphModel tracer currentId / 2) asInteger) setAsCurrentSelection.
	swFindNode suspend.
	testExpander windowMorph abandon.
	^ swFindNode duration asMilliSeconds! !

!SPathFinder class methodsFor: 'private' stamp: 'mp 4/26/2010 17:14'!
openWithPerformanceMesaureOn: aTestMethodReference and: aMethodReference
	| testExpander swGui swShallowAnalysis swFindNode fullTime |
	Transcript clear.
	swGui := Stopwatch new.
	swShallowAnalysis := Stopwatch new.
	swFindNode := Stopwatch new.
	"Start: Build GUI"
	swGui activate.
	testExpander := self new.
	ToolBuilder open: testExpander.
	swGui suspend.
	"End: Build GUI"
	"Start: Shallow Analyzis"
	swShallowAnalysis activate.
	testExpander testChooserModel setCurrentTest: aTestMethodReference.
	swShallowAnalysis suspend.
	"End: Shallow Analyzis"
	"Start: Find Node in Tree"
	swFindNode activate.
	testExpander callgraphModel 
		searchNode: (self convertMethodReferenceToString: aMethodReference);
		changed: #getSearchQuery.
	swFindNode suspend.
	"End: Find Node in Tree"
	"Summary"
	fullTime := swGui duration + swShallowAnalysis duration + swFindNode duration.
	Transcript show: 'GUI: ', swGui duration asString; space; show: ((swGui duration / fullTime) * 100) asInteger asString; show: '%'; cr.	
	Transcript show: 'Shallow Analysis: ', swShallowAnalysis duration asString; space; show: ((swShallowAnalysis duration / fullTime) * 100) asInteger asString; show: '%'; cr.
	Transcript show: 'Find Node: ', swFindNode duration asString; space; show: ((swFindNode duration / fullTime) * 100) asInteger asString; show: '%'; cr.
	Transcript show: 'All: ', (fullTime) asString; cr.
	^ testExpander! !

!SPathFinder methodsFor: 'building-pluggable-morphs' stamp: 'mp 3/25/2011 12:20:29.516'!
buildCallGraphTreeOn: aBuilder frame: aRectangle 
	| treeSpec |
	treeSpec := SPluggableTreeSpec new.
	treeSpec
		model: self callgraphModel;
		name: #callGraphTree;
		roots: #rootCallNodes;
		hasChildren: #hasChildren:;
		getChildren: #getChildren:;
		setSelected: #newSelectedItem:;
		getSelectedPath: #getSelectedPath;
		menu: #callGraphMenu:;
		highlightItem: #highlightItem:;
		indentingListItemMorph: self indentingListItemClass;
		icon: #getIcon:;
		frame: aRectangle.
	self windowSpec children add: treeSpec! !

!SPathFinder methodsFor: 'building' stamp: 'mp 4/17/2010 20:45'!
buildCustomMorphs

	self 
		"buildNavigationBarMorphWithFrame: (0.007 @ 0.00 corner: 0.85 @ 0.05);"
		buildTestResultFeedbackMorphWithFrame: (0.008 @ 0.0 corner: 0.047 @ 0.061);
		buildDropDownMorphOn: self testChooserModel
			with: {'Class View' -> #selectClassesView. 
				   'Object View' -> #selectObjectView.
				   'Identity View' -> #selectIdentityView.}
			frame: (0.05 @ 0.0 corner:  0.254 @ 0.061);
		buildDropDownMorphOn: self testChooserModel
			with: {'Without Profiling' -> #normalRun. 
				   'Relative % Profiling' -> #profileRunWithPercentage. 
				   'Absolute ms Profiling' -> #profileRunWithMs.
				   'Call Counts' -> #normalRunWithCounts.}
			frame: (0.256 @ 0.0 corner:  0.46 @ 0.061).! !

!SPathFinder methodsFor: 'building-custom-morphs' stamp: 'mp 7/7/2010 16:45:28.525'!
buildDropDownMorphOn: aModel with: aCollection frame: aRectangle
	| morph |
	morph := SDropDownMorph on: aModel with: aCollection.
	self setFrame: aRectangle in: morph.
	self windowMorph addMorph: morph.! !

!SPathFinder methodsFor: 'building-pluggable-morphs' stamp: 'mp 1/20/2010 17:03'!
buildHistoryButtonsOn: aBuilder frame: aRectangle 
	| buttonSpec |
	buttonSpec := self 
		buildButtonsWith: aBuilder
		from: self historyButtons
		model: self callgraphModel.
	buttonSpec frame: aRectangle.
	self windowSpec children add: buttonSpec! !

!SPathFinder methodsFor: 'building-custom-morphs' stamp: 'mp 7/7/2010 16:49:09.621'!
buildNavigationBarMorphWithFrame: aRectangle
	| navigationBar |
	navigationBar := SPathFindNaviBarMorph new.
	self setFrame: aRectangle in: navigationBar.
	navigationBar borderWidth: 2; borderColor: #inset.
	self windowMorph addMorph: navigationBar.
	self callgraphModel addDependent: navigationBar.! !

!SPathFinder methodsFor: 'building-pluggable-morphs' stamp: 'mp 3/7/2012 17:12:14.101'!
buildPathViewButtonOn: aBuilder frame: aRectangle
	| buttonSpec |
	buttonSpec := self 
		buildButtonsWith: aBuilder
		from: #(('PathView' #openPathViewOnTrace #isGraphAvailable))
		model: self callgraphModel.
	buttonSpec frame: aRectangle.
	self windowSpec children add: buttonSpec! !

!SPathFinder methodsFor: 'building' stamp: 'mp 3/7/2012 17:07:09.372'!
buildPluggableMorphsOn: aBuilder
	self
		buildWindowOn: aBuilder;
		buildHistoryButtonsOn: aBuilder frame: (0.85 @ -0.01 corner: 1.0 @ 0.062);
		buildPathViewButtonOn: aBuilder frame: (0.75 @ -0.01 corner: 0.85 @ 0.062);
		buildSearchFieldOn: aBuilder frame: (0.456 @ -0.01 corner: 0.75 @ 0.062);
		buildCallGraphTreeOn: aBuilder frame: (0.0 @ 0.062 corner: 1.0 @ 1.0).
	super buildWith: aBuilder.! !

!SPathFinder methodsFor: 'building-pluggable-morphs' stamp: 'mp 3/4/2010 13:59'!
buildSearchFieldOn: aBuilder frame: aRectangle 
	| inputSpec |
	inputSpec := aBuilder pluggableInputFieldSpec new
		model: self callgraphModel;
		name: #searchInputField;
		getText: #getSearchQuery;
		setText: #searchNode:;
		frame: aRectangle.
	self windowSpec children add: inputSpec! !

!SPathFinder methodsFor: 'building-custom-morphs' stamp: 'mp 3/24/2011 10:03:37.592'!
buildTestResultFeedbackMorphWithFrame: aRectangle
	| testResult |
	testResult := STestResultFeedbackMorph on: self selector: #rerunTest.
	self setFrame: aRectangle in: testResult.
	self windowMorph addMorph: testResult.
	self testChooserModel addDependent: testResult.! !

!SPathFinder methodsFor: 'building' stamp: 'mp 1/20/2010 17:03'!
buildWith: aBuilder 
	
	self 
		createModels;
		buildPluggableMorphsOn: aBuilder;
		buildCustomMorphs;
		resizeWindow.
	^ self windowMorph! !

!SPathFinder methodsFor: 'accessing' stamp: 'mp 1/20/2010 17:03'!
callgraphModel
	^ callgraphModel! !

!SPathFinder methodsFor: 'accessing' stamp: 'mp 1/20/2010 17:03'!
callgraphModel: anObject 
	callgraphModel := anObject! !

!SPathFinder methodsFor: 'building' stamp: 'mp 3/25/2011 12:39:50.678'!
callgraphModelClass
	^ SCallgraphModel! !

!SPathFinder methodsFor: 'accessing' stamp: 'mp 1/20/2010 17:03'!
callgraphTracer
	^ callgraphTracer! !

!SPathFinder methodsFor: 'accessing' stamp: 'mp 1/20/2010 17:03'!
callgraphTracer: anObject
	callgraphTracer := anObject! !

!SPathFinder methodsFor: 'actions' stamp: 'mp 3/24/2011 10:28:01.534'!
chooseNewTest
	self testChooserModel	setCurrentTest: 
		(UIManager default 
				chooseFrom: SProject current allTests
				values: SProject current allTests
				lines: #() 
				title: 'Choose Test Case') ! !

!SPathFinder methodsFor: 'actions' stamp: 'mp 3/24/2011 10:34:57.774'!
chooseTestAction
	^ UIManager default 
				chooseFrom: {'Rerun current test'. 'Choose new test'}
				values: {#rerun. #newTest}
				lines: #() 
				title: 'Choose test action'

	! !

!SPathFinder methodsFor: 'actions' stamp: 'mp 4/15/2010 15:46'!
clearAnalysis

	self testChooserModel setCurrentTest: nil.! !

!SPathFinder methodsFor: 'accessing' stamp: 'mp 3/25/2011 11:30:42.879'!
coverageTracer
	"Answer the value of coverageTracer"

	^ coverageTracer! !

!SPathFinder methodsFor: 'accessing' stamp: 'mp 3/25/2011 11:30:42.884'!
coverageTracer: anObject
	"Set the value of coverageTracer"

	coverageTracer := anObject! !

!SPathFinder methodsFor: 'building' stamp: 'mp 3/27/2012 16:13:04.901'!
createModels
	self callgraphTracer: (SCallgraphTracer on: SProject current).
	self callgraphModel: (self callgraphModelClass 
							on: self callgraphTracer
							pathFinder: self).
	self callgraphTracer callgraphModel: self callgraphModel.
	self testChooserModel: (STestChooserModel on: self callgraphTracer).! !

!SPathFinder methodsFor: 'building-pluggable-morphs' stamp: 'mp 1/20/2010 17:03'!
historyButtons

	^ #(
		( '<<' #historyBack #historyBackButtonEnabled)
		( '>>' #historyPrevious #historyPreviousButtonEnabled)
		).! !

!SPathFinder methodsFor: 'building-pluggable-morphs' stamp: 'mp 3/25/2011 12:20:40.322'!
indentingListItemClass
	^ SCodeExplorerIndentingListItemMorph! !

!SPathFinder methodsFor: 'user interface' stamp: 'mp 11/8/2010 17:14:38.535'!
initialExtent

	^ 750@450! !

!SPathFinder methodsFor: 'building-pluggable-morphs' stamp: 'mp 3/24/2011 17:43:50.509'!
label
	| subhead |
	subhead := self testChooserModel test 
		ifNil: ['']
		ifNotNil: [
			self testChooserModel test isString
				ifTrue: ['Code Snippet']
				ifFalse: [self testChooserModel test stringVersionDefault]].
	^ self toolName, ': ', subhead! !

!SPathFinder methodsFor: 'actions' stamp: 'mp 3/24/2011 10:31:39.029'!
rerunTest
	| choice |
	self testChooserModel isTestAvailable
		ifTrue: [	choice := self chooseTestAction.
				choice caseOf: {
					[#rerun] -> [self testChooserModel analyzeTest].
					[#newTest] -> [self chooseNewTest]}]
		ifFalse: [self chooseNewTest].
	self changed: #label.

	! !

!SPathFinder methodsFor: 'building' stamp: 'mp 1/20/2010 17:03'!
resizeWindow

	self windowMorph extent: self initialExtent.
! !

!SPathFinder methodsFor: 'accessing' stamp: 'mp 1/20/2010 17:03'!
testChooserModel
	^ testChooserModel! !

!SPathFinder methodsFor: 'accessing' stamp: 'mp 1/20/2010 17:03'!
testChooserModel: anObject 
	testChooserModel := anObject! !

!SPathFinder methodsFor: 'building-pluggable-morphs' stamp: 'mp 3/24/2011 17:44:03.439'!
toolName
	^ 'PathFinder'! !

STool subclass: #SPathView
	instanceVariableNames: 'startClass classDiagramMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Tools'!

!SPathView class methodsFor: 'class initialization' stamp: 'ag 12/27/2011 13:55:49.452'!
initialize
	"self initialize"
	
	TheWorldMenu registerOpenCommand: { 'PathView'. { self. #open } }.! !

!SPathView class methodsFor: 'instance creation' stamp: 'ag 12/27/2011 13:55:35.02'!
new
	
	self error: 'Use #open.'! !

!SPathView class methodsFor: 'instance creation' stamp: 'ag 2/19/2012 12:58:27.838'!
open

	^ self openOn: nil! !

!SPathView class methodsFor: 'instance creation' stamp: 'tfel 6/7/2011 14:08:15.132'!
openOn: aClass
	
	^ self basicNew
		initialize;
		startWithClass: aClass;
		yourself! !

!SPathView class methodsFor: 'instance creation' stamp: 'ag 12/27/2011 13:02:52.673'!
openSaved: aClassDiagramOrString
	
	| morph |
	morph := aClassDiagramOrString isString
		ifTrue: [ SProject current viewNamed: aClassDiagramOrString ]
		ifFalse: [ aClassDiagramOrString ].
	^ ToolBuilder open: (self basicNew
		classDiagramMorph: morph;
		initialize;
		yourself)! !

!SPathView methodsFor: 'building' stamp: 'ag 9/2/2011 16:39:09.985'!
buildButtonsWith: aBuilder
	
	self
		buildButtonsPanelWith: aBuilder
		from: self menuButtons
		model: self classDiagramMorph
		frame: (0.0 @ 0.0 corner: 1 @ 0.05);
		
		buildButtonsPanelWith: aBuilder
		from: self toolbarButtons
		model: self classDiagramMorph
		frame: (0.0 @ 0.05 corner: 1 @ 0.10).! !

!SPathView methodsFor: 'building' stamp: 'mp 1/22/2011 14:51:09.636'!
buildPluggableMorphsOn: aBuilder
	self
		buildWindowOn: aBuilder.
"		buildHistoryButtonsOn: aBuilder frame: (0.85 @ 0.0 corner: 1.0 @ 0.062);
		buildSearchFieldOn: aBuilder frame: (0.456 @ 0.0 corner: 0.85 @ 0.062);
		buildCallGraphTreeOn: aBuilder frame: (0.0 @ 0.062 corner: 1.0 @ 1.0)."
	super buildWith: aBuilder.! !

!SPathView methodsFor: 'building' stamp: 'tfel 2/14/2012 13:35:01.872'!
buildWindowWith: aBuilder
	
	| pathViewSpec |
	self buildWindowOn: aBuilder.
	self windowSpec
		model: self classDiagramMorph;
		label: #windowLabel;
		closeAction: nil.
	pathViewSpec :=  SPathViewDiagramSpec new
											model: self;
											children: OrderedCollection new;
											frame: (0@0.10 extent: 1@0.90);
											viewAreaMorph: self classDiagramMorph.
	self windowSpec children addAll: { pathViewSpec }.
	self buildButtonsWith: aBuilder.
	super buildWith: aBuilder.! !

!SPathView methodsFor: 'building' stamp: 'ag 12/4/2011 14:00:27.564'!
buildWith: aBuilder 
	
	self
		buildWindowWith: aBuilder;
		resizeWindow.
	^ self windowMorph! !

!SPathView methodsFor: 'building' stamp: 'ag 12/29/2011 12:22:50.595'!
classDiagramMorph
	
	^ classDiagramMorph ifNil: [
		classDiagramMorph := SClassDiagram new.
		self initialDiagramMorph ifNotNilDo: [ :classMorph |
			classDiagramMorph addMorph: classMorph.
			classMorph optionallyOpenConnectors ].
		classDiagramMorph ]! !

!SPathView methodsFor: 'building' stamp: 'tfel 6/23/2011 12:06:09.366'!
classDiagramMorph: aClassDiagramMorph
	
	classDiagramMorph := aClassDiagramMorph.! !

!SPathView methodsFor: 'building' stamp: 'ag 12/27/2011 14:03:17.149'!
initialDiagramMorph
	
	^ startClass
		ifNotNil: [ | classMorph |
			classMorph := SClassMorph on: startClass.
			classMorph position: ((self initialExtent x / 2) - (classMorph width / 2)) @ 
						((self initialExtent y / 2) - (classMorph height / 2)).
			classMorph ]! !

!SPathView methodsFor: 'initialize-release' stamp: 'ag 12/31/2011 09:39:00.604'!
initialExtent

	^ 800@600! !

!SPathView methodsFor: 'accessing' stamp: 'mp 1/26/2011 11:20:37.433'!
label

	^ 'PathView'! !

!SPathView methodsFor: 'building' stamp: 'ag 12/29/2011 00:02:01.341'!
menuButtons
	"These buttons represent the menu. They contain meta-actions like saving or opening another view."
	
	^ #(
		('Revert' #revert #hasChanges)
		('Open another view' #open #alwaysEnabled)
		('Save to project' #save #isDirty)
		('Save as PNG' #savePNG #hasSubmorphs)
		('Delete view' #remove #isSaved)
		('Preferences' #openPreferences #alwaysEnabled)
		)! !

!SPathView methodsFor: 'building' stamp: 'mp 1/22/2011 16:35:58.117'!
resizeWindow

	self windowMorph extent: self initialExtent.! !

!SPathView methodsFor: 'initialize-release' stamp: 'ag 12/27/2011 13:58:38.446'!
startWithClass: aClass
	
	startClass := aClass.
	ToolBuilder open: self.! !

!SPathView methodsFor: 'building' stamp: 'ag 2/14/2012 18:11:22.902'!
toolbarButtons
	"The model for these button-actions is classDiagramMorph (an SClassDiagram).
	These buttons represent a toolbar; they contain actions for altering the contents of the class-diagram."
	
	^ #(
		('Extend diagram area' #extendArea #alwaysEnabled)
		('Add Note' #addNote #alwaysEnabled)
		('Toggle labels' #toggleLabels #alwaysEnabled)
		('Zoom in' #zoomIn #alwaysEnabled)
		('Zoom out' #zoomOut #canZoomOut)
		('Minimap --' #minimapSmaller #canScaleMinimapSmaller)
		('Minimap ++' #minimapBigger #canScaleMinimapBigger)
		('Smoothing --' #smoothDown #canSmoothDown)
		('Smoothing ++' #smoothUp #canSmoothUp)
		('Layout' #layoutGraph #alwaysEnabled)
		
"The auto-layout buttons are disabled; when deleting this, also delete all implementation-methods in SClassDiagram and SClassMorph."
"		('Trigger Auto Layout' #startLayouting #isLayoutNotRunning)
		('Lock Auto Layout' #lockLayouting #isLayoutUnlocked)
		('Stop Auto Layout' #stopLayouting #isLayoutRunning)
"
		)! !

STool subclass: #SProjectChooser
	instanceVariableNames: 'selectedProject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Tools'!

!SProjectChooser class methodsFor: 'as yet unclassified' stamp: 'mp 3/7/2011 21:50:41.281'!
initialize
	"self initialize"
	TheWorldMenu registerOpenCommand: {'PathProjects'. {self. #open}}.! !

!SProjectChooser methodsFor: 'project commands' stamp: 'mp 3/8/2011 18:01:41.905'!
addProject
	| projectName |
	projectName := UIManager default request: 'Insert new project name' initialAnswer: ''.
	(projectName notNil and: [projectName notEmpty])
		ifTrue: [
			projectName := projectName asSymbol.
			(SProject projectAt: projectName) 
				ifNotNil: [^ self inform: 'Project name already exists.'].
			selectedProject := SProject 
									projectAt: projectName 
									put: (SProject name: projectName categories: #())].
	self 
		changed: #allRegisteredProjects;
		changed: #selectedProject;
		changed: #selectedCategoriesOfProject.! !

!SProjectChooser methodsFor: 'project commands' stamp: 'mp 7/7/2010 16:55:20.267'!
allRegisteredProjects

	^ SProject allProjectsWithoutNull asSortedCollection: [:a :b | 
		a projectName < b projectName]! !

!SProjectChooser methodsFor: 'building' stamp: 'mp 6/15/2010 22:33'!
buildProjectListOn: aBuilder frame: aRectangle
	| listSpec |
	listSpec := aBuilder pluggableListSpec new.
	listSpec
		model: self;
		name: #projectList;
		list: #allRegisteredProjects;
		getSelected: #selectedProject;
		setSelected: #selectedProject:;
		frame: aRectangle.
	self windowSpec children add: listSpec.! !

!SProjectChooser methodsFor: 'building' stamp: 'mp 6/16/2010 14:23'!
buildSelectedCategoriesListOn: aBuilder frame: aRectangle
	| listSpec |
	listSpec := aBuilder pluggableListSpec new.
	listSpec
		model: self;
		name: #selectedCategoriesList;
		list: #selectedCategoriesOfProject;
		frame: aRectangle.
	self windowSpec children add: listSpec.
! !

!SProjectChooser methodsFor: 'building' stamp: 'mp 2/3/2012 11:28:57.791'!
buildWith: aBuilder 
	
	self
		buildWindowOn: aBuilder;
		buildButtonsPanelWith: aBuilder 
			from: self projectControlButtons 
			model: self 
			frame: (0.0 @ 0.0 corner: 1.0 @ 0.1325);
		buildProjectListOn: aBuilder frame: (0.0 @ 0.1325 corner: 0.5 @ 1.0);
		buildSelectedCategoriesListOn: aBuilder frame: (0.5 @ 0.1325 corner: 1.0 @ 1.0).

	^ super buildWith: aBuilder! !

!SProjectChooser methodsFor: 'project commands' stamp: 'mp 1/2/2012 14:17:43.869'!
chooseCategories

	| chooser |
	chooser := SCategoryChooser on: selectedProject.
	chooser addDependent: self.
	selectedProject resetClassesCache.! !

!SProjectChooser methodsFor: 'user interface' stamp: 'mp 2/3/2012 11:30:25.696'!
initialExtent

	^ 600@215! !

!SProjectChooser methodsFor: 'initialize-release' stamp: 'mp 7/7/2010 16:55:09.006'!
initialize

	selectedProject := SProject current.! !

!SProjectChooser methodsFor: 'user interface' stamp: 'mp 6/16/2010 09:46'!
isProjectSelected

	^ selectedProject notNil ! !

!SProjectChooser methodsFor: 'accessing' stamp: 'mp 3/7/2011 21:43:07.163'!
label

	^ 'PathProjects'! !

!SProjectChooser methodsFor: 'building' stamp: 'mp 3/8/2011 20:29:02.126'!
projectControlButtons

	^ #(
		( 'Set Current' #selectCurrentProject #alwaysEnabled)
		( 'Add Project' #addProject #alwaysEnabled)
		( 'Choose Categories...' #chooseCategories #isProjectSelected)
		( 'Remove Project' #removeSelectedProject #isProjectSelected)
		( 'Reset Cache' #resetCacheOfSelectedProject #isProjectSelected)
		).! !

!SProjectChooser methodsFor: 'project commands' stamp: 'mp 7/7/2010 16:55:29.145'!
removeSelectedProject

	SProject removeProjectAt: selectedProject projectName.
	selectedProject := SProject current.
	self 
		changed: #allRegisteredProjects;
		changed: #selectedProject;
		changed: #selectedCategoriesOfProject.! !

!SProjectChooser methodsFor: 'project commands' stamp: 'mp 6/16/2010 11:09'!
resetCacheOfSelectedProject

	selectedProject resetClassesCache.! !

!SProjectChooser methodsFor: 'project commands' stamp: 'mp 3/8/2011 19:42:40.308'!
selectCurrentProject
	selectedProject 
		ifNil: [SProject setNullProjectAsCurrent]
		ifNotNil: [SProject setCurrentProject: selectedProject].
	selectedProject resetClassesCache.
	self changed: #allRegisteredProjects.! !

!SProjectChooser methodsFor: 'project commands' stamp: 'mp 1/2/2012 14:17:07.161'!
selectedCategoriesOfProject

	^ selectedProject
		ifNil: [#()]
		ifNotNil: [selectedProject categories]! !

!SProjectChooser methodsFor: 'project commands' stamp: 'mp 6/16/2010 09:47'!
selectedProject

	^ selectedProject! !

!SProjectChooser methodsFor: 'project commands' stamp: 'mp 6/16/2010 14:25'!
selectedProject: aProject

	selectedProject := aProject.
	self 
		changed: #isProjectSelected;
		changed: #selectedCategoriesOfProject.! !

!SProjectChooser methodsFor: 'updating' stamp: 'mp 3/8/2011 18:11:56.975'!
update: aCategoryChooser

	self changed: #selectedCategoriesOfProject.! !

!STool class methodsFor: 'instance creation' stamp: 'tfel 2/14/2012 13:31:27.413'!
open
	| tool |
	tool := self new.
	ToolBuilder open: tool.
	^ tool! !

!STool class methodsFor: 'layouting' stamp: 'ag 12/27/2011 14:29:37.094'!
setFrame: aRectangle in: aMorph
	
	^ self
		setLayoutFrame: (LayoutFrame fractions: aRectangle)
		of: aMorph! !

!STool class methodsFor: 'layouting' stamp: 'ag 12/27/2011 14:29:54.625'!
setFrame: aRectangle offset: anotherRectangle in: aMorph
	
	^ self
		setLayoutFrame: (LayoutFrame fractions: anotherRectangle offsets: aRectangle)
		of: aMorph! !

!STool class methodsFor: 'layouting' stamp: 'ag 12/27/2011 14:29:05.315'!
setLayoutFrame: aLayoutFrame of: aMorph
	
	^ aMorph
		layoutFrame: aLayoutFrame;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		yourself! !

!STool class methodsFor: 'layouting' stamp: 'ag 12/27/2011 14:30:18.794'!
setOffsetFrame: aRectangle in: aMorph
	
	^ self
		setLayoutFrame: (LayoutFrame offsets: aRectangle)
		of: aMorph! !

!STool methodsFor: 'user interface' stamp: 'mp 1/20/2010 15:33'!
alwaysDisabled

	^ false! !

!STool methodsFor: 'user interface' stamp: 'mp 1/20/2010 15:33'!
alwaysEnabled

	^ true! !

!STool methodsFor: 'building' stamp: 'mp 3/8/2011 17:46:44.008'!
buildButtonsPanelWith: aBuilder from: anArray model: aModel frame: aRect
	
	self windowSpec children add: (aBuilder pluggablePanelSpec new
		layout: #horizontal;
		frame: aRect;
		children: {
			self buildButtonsWith: aBuilder from: anArray model: aModel.
			};
		yourself).! !

!STool methodsFor: 'building' stamp: 'mp 1/20/2010 15:33'!
buildButtonsWith: aBuilder from: anArray

	^ self buildButtonsWith: aBuilder from: anArray model: self! !

!STool methodsFor: 'building' stamp: 'mp 1/20/2010 16:04'!
buildButtonsWith: aBuilder from: anArray model: aModel

	^ aBuilder pluggablePanelSpec new
		model: aModel;
		layout: #horizontal;
		children: (anArray collect: [ :each |
			aBuilder pluggableButtonSpec new
				model: aModel; 
				label: each first;
				action: each second;
				enabled: each third;
				yourself ]);
		yourself.! !

!STool methodsFor: 'building' stamp: 'mp 2/3/2012 11:38:49.459'!
buildWindowOn: aBuilder

	self windowSpec: aBuilder pluggableWindowSpec new.
	self windowSpec
		model: self;
		label: #label;
		children: OrderedCollection new;
		closeAction: #windowIsClosed! !

!STool methodsFor: 'building' stamp: 'mp 3/4/2010 15:20'!
buildWith: aBuilder

	self windowMorph: (aBuilder build: self windowSpec).
	^ self windowMorph
	! !

!STool methodsFor: 'user interface' stamp: 'mp 1/19/2012 14:37:27.202'!
hideAllToolsDuring: aBlock
	| windows |
	windows := (SystemWindow allSubInstances select: [:each | each visible]).
	windows do: [:each | each hide].
	World restoreDisplay.
	^ aBlock 
		ensure: [
			windows do: [:each | each show].
			World restoreDisplay.].! !

!STool methodsFor: 'user interface' stamp: 'mp 1/19/2012 14:37:23.008'!
hideToolDuring: aBlock
	self windowMorph hide.
	World restoreDisplay.
	^ aBlock 
		ensure: [self windowMorph show.
			World restoreDisplay].! !

!STool methodsFor: 'accessing' stamp: 'mp 6/15/2010 21:52'!
label

	^ 'tool title'! !

!STool methodsFor: 'building' stamp: 'mp 1/22/2011 14:56:58.095'!
setFrame: aRectangle in: aMorph

	| frame |
	frame := LayoutFrame new
				leftFraction: aRectangle left; 
				rightFraction: aRectangle right; 
				topFraction: aRectangle top; 
				bottomFraction: aRectangle bottom.
	aMorph layoutFrame: frame.
	aMorph hResizing: #spaceFill; vResizing: #spaceFill.! !

!STool methodsFor: 'user interface' stamp: 'mp 2/3/2012 11:39:03.953'!
windowIsClosed
	"Can be overwritten by subclasses"! !

!STool methodsFor: 'accessing' stamp: 'mp 1/20/2010 15:33'!
windowMorph
	^ windowMorph! !

!STool methodsFor: 'accessing' stamp: 'mp 1/20/2010 15:33'!
windowMorph: anObject
	windowMorph := anObject! !

!STool methodsFor: 'accessing' stamp: 'mp 1/20/2010 15:33'!
windowSpec
	^ windowSpec! !

!STool methodsFor: 'accessing' stamp: 'mp 1/20/2010 15:33'!
windowSpec: anObject
	windowSpec := anObject! !

Object subclass: #STracer
	instanceVariableNames: 'entryPoints wrappers active project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Tracer'!

!STracer class methodsFor: 'instance creation' stamp: 'mp 1/24/2011 17:11:13.983'!
on: aProject
	^ self on: aProject entryPoints: aProject allTestsAsEntryPoints! !

!STracer class methodsFor: 'instance creation' stamp: 'mp 7/12/2010 13:49:56.027'!
on: aProject entryPoints: aCollection
	^ self new
		project: aProject;
		entryPoints: aCollection;
		yourself! !

!STracer methodsFor: 'accessing' stamp: 'mp 3/23/2011 16:38:36.756'!
activate
	self active: true.! !

!STracer methodsFor: 'accessing' stamp: 'mp 7/12/2010 13:00:52.702'!
active
	"Answer the value of active"

	^ active ifNil: [active := false]! !

!STracer methodsFor: 'accessing' stamp: 'mp 7/12/2010 12:59:23.159'!
active: anObject
	"Set the value of active"

	active := anObject! !

!STracer methodsFor: 'running' stamp: 'mp 7/12/2010 13:20:53.66'!
beginExecutionOf: anEntryPoint

	"Can be overwritten in subclasses"! !

!STracer methodsFor: 'wrapper instrumentation' stamp: 'mp 7/12/2010 12:52:07.13'!
createWrapperOn: aClass and: aSelector
	| wrapper |
	wrapper := self getWrapperOn: aSelector inClass: aClass.
	wrapper 
		ifNotNil: [self wrappers add: wrapper.
				 wrapper install].! !

!STracer methodsFor: 'wrapper instrumentation' stamp: 'mp 11/19/2010 20:11:43.228'!
createWrappers
	self selectedClasses do: [:klass | 
			klass selectors do: [:selector | 
				self createWrapperOn: klass and: selector].		
			klass class selectors do: [:selector | 
				self createWrapperOn: klass class and: selector]].! !

!STracer methodsFor: 'accessing' stamp: 'mp 3/23/2011 16:38:42.169'!
deactivate
	self active: false.! !

!STracer methodsFor: 'helper' stamp: 'mp 1/24/2012 15:23:00.504'!
disableTimeoutOfEntryPoints
	self entryPoints do: [:each | each disableTimeout].! !

!STracer methodsFor: 'running' stamp: 'mp 7/12/2010 13:21:16.932'!
endExecutionOf: anEntryPoint withResult: anObject

	"Can be overwritten in subclasses"! !

!STracer methodsFor: 'accessing' stamp: 'mp 7/12/2010 12:38:23.746'!
entryPoints
	"Answer the value of entryPoints"

	^ entryPoints! !

!STracer methodsFor: 'accessing' stamp: 'mp 7/12/2010 12:38:23.75'!
entryPoints: anObject
	"Set the value of entryPoints"

	entryPoints := anObject! !

!STracer methodsFor: 'wrapper instrumentation' stamp: 'mp 7/12/2010 13:33:44.599'!
getWrapperClass
	"Wrapper should be a subclass of SWrapper 
	otherwise overwrite #getWrapperOn:inClass:"
	^ SWrapper! !

!STracer methodsFor: 'wrapper instrumentation' stamp: 'mp 7/13/2010 16:07:00.628'!
getWrapperOn: aSelector inClass: aClass

	^ self getWrapperClass on: aSelector inClass: aClass with: self! !

!STracer methodsFor: 'helper' stamp: 'mp 1/24/2012 14:50:39.053'!
hideAllToolsDuring: aBlock
	| windows |
	windows := (SystemWindow allSubInstances select: [:each | each visible]).
	windows do: [:each | each hide].
	World restoreDisplay.
	^ aBlock 
		ensure: [
			windows do: [:each | each show].
			World restoreDisplay.].! !

!STracer methodsFor: 'testing' stamp: 'mp 7/12/2010 12:59:46.127'!
isActive

	^ self active! !

!STracer methodsFor: 'public api' stamp: 'mp 3/25/2011 11:55:58.04'!
pathFinderTool
	^ SPathFinder! !

!STracer methodsFor: 'tracing' stamp: 'mp 7/12/2010 12:45:26.775'!
postProcessing

	"Can be overwritten in subclasses"! !

!STracer methodsFor: 'tracing' stamp: 'mp 7/12/2010 12:44:53.329'!
preProcessing

	"Can be overwritten in subclasses"! !

!STracer methodsFor: 'accessing' stamp: 'mp 7/12/2010 13:49:11.915'!
project

	^ project! !

!STracer methodsFor: 'accessing' stamp: 'mp 7/12/2010 13:49:23.782'!
project: anObject
	"Set the value of project"

	project := anObject! !

!STracer methodsFor: 'wrapper instrumentation' stamp: 'mp 7/13/2010 14:36:10.856'!
removeWrappers

	self wrappers do: [:each | each uninstall].
	self wrappers: nil.
	Smalltalk garbageCollect.! !

!STracer methodsFor: 'public api' stamp: 'mp 9/22/2011 15:16:12.578'!
run
	| begin |
	[self preProcessing.
	begin := DateAndTime now.
	self
		createWrappers;
		runEntryPoints] 
	ensure: [self removeWrappers].
	Transcript show: DateAndTime now - begin; cr.
	self postProcessing.! !

!STracer methodsFor: 'running' stamp: 'mp 11/19/2010 18:00:44.938'!
runEntryPoint: anEntryPoint
	| result |
	self beginExecutionOf: anEntryPoint.
	self startTracing.
	result := anEntryPoint execute.
	self stopTracing.
	self endExecutionOf: anEntryPoint withResult: result.! !

!STracer methodsFor: 'running' stamp: 'mp 4/1/2011 13:36:48.468'!
runEntryPoints
	| size |
	size := self entryPoints size.
	self entryPoints 
		do: [:each | self runEntryPoint: each	] 
		displayingProgress: [:each | 
			'Processing ', each asString, ' out of ', size asString, ' Entry Points.'].! !

!STracer methodsFor: 'accessing' stamp: 'mp 7/12/2010 12:48:03.01'!
selectedClasses

	^ self project allClasses! !

!STracer methodsFor: 'helper' stamp: 'mp 1/24/2012 14:48:27.776'!
setOnlyPassingTestsAsEntryPoints
	| size passingTests |
	size := self entryPoints size.
	passingTests := OrderedCollection new.
	self entryPoints 
		do: [:each | each execute hasPassed
					ifTrue: [passingTests add: each]] 
		displayingProgress: [:each | 
			'Processing ', each asString, ' out of ', size asString, ' Entry Points.'].
	self entryPoints: passingTests.! !

!STracer methodsFor: 'tracing' stamp: 'mp 7/12/2010 13:41:19.462'!
startTracing
	"Can be overwritten in subclasses"
	self active: true.! !

!STracer methodsFor: 'tracing' stamp: 'mp 7/12/2010 13:41:22.317'!
stopTracing
	"Can be overwritten in subclasses"
	self active: false.! !

!STracer methodsFor: 'accessing' stamp: 'mp 7/12/2010 12:42:26.035'!
wrappers
	"Answer the value of wrappers"

	^ wrappers ifNil: [wrappers := OrderedCollection new]! !

!STracer methodsFor: 'accessing' stamp: 'mp 7/12/2010 12:38:23.758'!
wrappers: anObject
	"Set the value of wrappers"

	wrappers := anObject! !

Object subclass: #STreeModel
	instanceVariableNames: 'selectedItem highlightedItems'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Models'!

!STreeModel methodsFor: 'public api' stamp: 'mp 12/11/2009 13:56'!
clearHighlightedItems

	self highlightedItems: nil.
	self changed: #highlightItem:.! !

!STreeModel methodsFor: 'spec commands' stamp: 'mp 12/11/2009 14:07'!
getChildren: aNode

	self subclassResponsibility.! !

!STreeModel methodsFor: 'spec commands' stamp: 'mp 12/11/2009 13:57'!
getIcon: aNode

	self subclassResponsibility.! !

!STreeModel methodsFor: 'private' stamp: 'mp 12/11/2009 13:58'!
getIconWithColor: aColor

	^ (Form extent: 10@10 depth: 32)
				fillColor: aColor! !

!STreeModel methodsFor: 'spec commands' stamp: 'mp 12/11/2009 14:07'!
hasChildren: aNode

	self subclassResponsibility.! !

!STreeModel methodsFor: 'accessing' stamp: 'mp 1/13/2010 19:06'!
hasSelectedItem

	^ self selectedItem notNil! !

!STreeModel methodsFor: 'spec commands' stamp: 'mp 12/11/2009 13:59'!
highlightItem: aNode

	^ self highlightedItems includes: aNode! !

!STreeModel methodsFor: 'accessing' stamp: 'mp 12/11/2009 13:52'!
highlightedItems
	^ highlightedItems ifNil: [highlightedItems := Set new]! !

!STreeModel methodsFor: 'accessing' stamp: 'mp 12/11/2009 13:52'!
highlightedItems: anObject
	highlightedItems := anObject! !

!STreeModel methodsFor: 'spec commands' stamp: 'mp 1/21/2010 11:15'!
newSelectedItem: aNode

	self selectedItem: aNode.! !

!STreeModel methodsFor: 'accessing' stamp: 'mp 12/11/2009 13:52'!
selectedItem
	^ selectedItem! !

!STreeModel methodsFor: 'accessing' stamp: 'mp 12/11/2009 13:52'!
selectedItem: anObject
	selectedItem := anObject! !

TestRunner subclass: #SPathMapTestRunner
	instanceVariableNames: 'windowMorph pathMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Tools'!

!SPathMapTestRunner class methodsFor: 'initialization' stamp: 'mp 7/8/2010 18:34:13.166'!
initialize
	"self initialize"
	self registerInWorldMenu.! !

!SPathMapTestRunner class methodsFor: 'instance-creation' stamp: 'mp 3/7/2012 09:44:14.092'!
open
	SProject isNullProjectSelected
		ifTrue: [self inform: 'Please choose a project first and start PathMap again.'.
				^ SProjectChooser open].
	^ super open.! !

!SPathMapTestRunner class methodsFor: 'initialization' stamp: 'mp 3/7/2011 21:49:49.479'!
registerInWorldMenu
	self environment at: #TheWorldMenu ifPresent: [ :class |
		class registerOpenCommand: (Array 
			with: 'PathMap' 
			with: (Array
				with: self
				with: #open)) ].! !

!SPathMapTestRunner methodsFor: 'building-customs' stamp: 'mp 9/21/2010 13:51:38.749'!
addColorLegendOn: aModel to: aSymbol inFrame: aRectangle
	| flap colorLegend |
	flap := self getFlap: aSymbol.
	colorLegend := SColorLegendMorph on: aModel.
	aModel 
		colorLegend: colorLegend;
		refreshColorLegend.
	self setFrame: aRectangle in: colorLegend.
	flap addMorph: colorLegend.
	colorLegend hide.

! !

!SPathMapTestRunner methodsFor: 'building-customs' stamp: 'mp 2/3/2012 12:11:44.482'!
addDropDownSelectionListTo: aSym on: aModel with: aColl inFrame: aRect
	| flap dropDownList |
	flap := self getFlap: aSym.
	dropDownList := SDropDownMorph on: aModel with: aColl.
	flap addMorph: dropDownList.
	self setFrame: aRect in: dropDownList.
	dropDownList 
		cornerStyle: #rounded;
		hResizing: #rigid;
		hide.
	^ dropDownList! !

!SPathMapTestRunner methodsFor: 'building-customs' stamp: 'mp 2/3/2012 12:16:43.421'!
addDropDownSelectionListTo: aSym on: aModel with: aColl inFrame: aRect entriesChanged: aMessage
	| dropDownList |
	dropDownList := self 
						addDropDownSelectionListTo: aSym 
						on: aModel 
						with: aColl 
						inFrame: aRect.
	aModel addDependent: dropDownList.
	dropDownList entriesChangedSelector: aMessage.
	^ dropDownList! !

!SPathMapTestRunner methodsFor: 'building-customs' stamp: 'mp 9/9/2011 10:07:41.227'!
addTitle: aString toFlap: aSymbol inFrame: aRectangle
	| title flap |
	flap := self getFlap: aSymbol.
	title := SLabelMorph label: aString.
	title labelMorphs do: [:each | 
		each
			fontName: Preferences standardDefaultTextFont familyName 
			size: 100].
	self setFrame: aRectangle in: title.
	flap addMorph: title.
	title 
		hResizing: #rigid;
		width: 150; "ToDo: Change this hard value!!"
		hide.

! !

!SPathMapTestRunner methodsFor: 'accessing-ui' stamp: 'mp 1/20/2010 15:29'!
alwaysEnabled

	^ true! !

!SPathMapTestRunner methodsFor: 'building' stamp: 'mp 3/15/2010 17:02'!
buildButtonsWith: aBuilder
	^ aBuilder pluggablePanelSpec new
		model: self;
		layout: #vertical;
		children: (self buttons collect: [ :each |
			aBuilder pluggableButtonSpec new
				model: self; 
				label: each first;
				action: each second;
				enabled: each third;
				yourself ]);
		yourself.! !

!SPathMapTestRunner methodsFor: 'building' stamp: 'mp 1/20/2012 09:45:23.194'!
buildCustomMorphs

	self 
		buildPathMapMorphFrame: (0.224 @ 0.045 corner: 0.996 @ 0.944);
		buildTestQualityFlapCustomMorphs;
		buildProfilingFlapCustomMorphs;
		buildFaultLocalizationFlapCustomMorphs;
		buildInductiveAnalysisCustomMorphs;
		buildTraceabilityFlapCustomMorphs;
		buildOptionsFlapCustomMorphs.
! !

!SPathMapTestRunner methodsFor: 'building-customs' stamp: 'mp 10/31/2010 10:02:10.841'!
buildFaultLocalizationFlapCustomMorphs
	| id options |
	id := #faultLocalization.
	options := self pathMap options at: id.
	self 
		addTitle: 'Fault Localization' 
			toFlap: id 
			inFrame: (0.0 @ 0.0 corner: 1.0 @ 0.0825);
		addColorLegendOn: options
			to: id 
			inFrame: (0.0 @ 0.19 corner: 1.0 @ 0.725);
		addDropDownSelectionListTo: id
			on: options
			with: {{'Ochiai'. #setFormula:. {#ochiai}}.
				   {'Tarantula'. #setFormula:. {#tarantula}}.
				   {'Jaccard'. #setFormula:. {#jaccard}}}
			inFrame: (0.0 @ 0.09 corner: 1.0 @ 0.18).! !

!SPathMapTestRunner methodsFor: 'building-flaps' stamp: 'mp 3/24/2011 16:20:18.894'!
buildFaultLocalizationFlapWith: aBuilder
	| id |
	id := #faultLocalization.
	^ aBuilder pluggableFlapSpec new
		name: id;
		icon: SImageRepository ladybugIconLarge;
		model: self;
		children: {(aBuilder pluggableCheckBoxSpec new
					model: (self pathMap options at: id); 
					frame: (0.0 @ 0.73 corner: 1.0 @ 0.821);
					label: 'Single Fault';
					action: #switchSinglePointOfFault;
					state: #singlePointOfFault;
					yourself).
				(aBuilder pluggableButtonSpec new
					model: (self pathMap options at: id); 
					frame: (0.0 @ 0.821 corner: 1.0 @ 0.912);
					label: 'Highscore';
					action: #showHighscore;
					yourself ).
				(aBuilder pluggableButtonSpec new
					model: (self pathMap options at: id); 
					frame: (0.0 @ 0.912 corner: 1.0 @ 1.0);
					label: 'Developer Ranking';
					action: #authorRanking;
					yourself ).
				};
		yourself! !

!SPathMapTestRunner methodsFor: 'building-customs' stamp: 'mp 2/3/2012 13:33:27.147'!
buildInductiveAnalysisCustomMorphs
	| id options |
	id := #inductive.
	options := self pathMap options at: id.
	self 
		addTitle: 'Inductive Analysis' 
			toFlap: #inductive 
			inFrame: (0.0 @ 0.0 corner: 1.0 @ 0.09);
		addColorLegendOn: options
			to: id
			inFrame: (0.0 @ 0.2 corner: 1.0 @ 0.79);
		addDropDownSelectionListTo: id
			on: options
			with: SHarvester createAListOfAllHarvester
			inFrame: (0.0 @ 0.1 corner: 1.0 @ 0.1975).! !

!SPathMapTestRunner methodsFor: 'building-flaps' stamp: 'mp 3/14/2012 13:57:07.707'!
buildInductiveAnalysisFlapWith: aBuilder
	| id |
	id := #inductive.
	^ aBuilder pluggableFlapSpec new
		name: id;
		icon: SImageRepository inductiveIconLarge;
		model: self;
		children: {(aBuilder pluggableButtonSpec new
					model: (self pathMap options at: id); 
					frame: (0.0 @ 0.8 corner: 1.0 @ 0.8975);
					label: 'Add Contracts';
					action: #addContracts;
					enabled: #isAddingContractsPossible;
					yourself).
				(aBuilder pluggableButtonSpec new
					model: (self pathMap options at: id); 
					frame: (0.0 @ 0.8975 corner: 1.0 @ 1.0);
					label: 'Remove Contracts';
					action: #removeContracts;
					enabled: #isRemovingContractsPossible;
					yourself ).};
		yourself! !

!SPathMapTestRunner methodsFor: 'building-customs' stamp: 'mp 9/23/2010 16:14:41.766'!
buildOptionsFlapCustomMorphs
	self 
		addTitle: 'Global Options' 
		toFlap: #globalOptions 
		inFrame: (0.0 @ 0.0 corner: 1.0 @ 0.19).! !

!SPathMapTestRunner methodsFor: 'building-flaps' stamp: 'mp 1/20/2012 09:53:58.735'!
buildOptionsFlapWith: aBuilder
	| id |
	id := #globalOptions.
	^ aBuilder pluggableFlapSpec new
		name: id;
		icon: SImageRepository worldIconLarge;
		model: self;
		children: {(aBuilder pluggableCheckBoxSpec new
					model: (self pathMap options at: id); 
					frame: (0.0 @ 0.2 corner: 1.0 @ 0.4);
					label: 'Show Meth. Categories';
					action: #switchShowMethodCategories;
					state: #showMethodCategories;
					yourself).
				(aBuilder pluggableCheckBoxSpec new
					model: (self pathMap options at: id); 
					frame: (0.0 @ 0.4 corner: 1.0 @ 0.6);
					label: 'Show Quick Methods';
					action: #switchShowQuickAndAccessorMethods;
					state: #showQuickAndAccessorMethods;
					yourself ).
				(aBuilder pluggableCheckBoxSpec new
					model: (self pathMap options at: id); 
					frame: (0.0 @ 0.6 corner: 1.0 @ 0.8);
					label: 'Ignore Setup Code';
					action: #switchIgnoreTracingOfSetUpAndTearDownMethods;
					state: #ignoreTracingOfSetUpAndTearDownMethods;
					yourself ).
				(aBuilder pluggableCheckBoxSpec new
					model: (self pathMap options at: id); 
					frame: (0.0 @ 0.8 corner: 1.0 @ 1.0);
					label: 'Visualize Inter-Steps';
					action: #switchVisualizeIntermediateSteps;
					state: #visualizeIntermediateSteps;
					yourself )};
		yourself! !

!SPathMapTestRunner methodsFor: 'building-customs' stamp: 'mp 1/2/2012 14:55:37.585'!
buildPathMapMorphFrame: aRectangle
	| root |
	root := self pathMap rootMorph.
	self setFrame: aRectangle in: root.
	self windowMorph addMorph: root.! !

!SPathMapTestRunner methodsFor: 'building' stamp: 'mp 3/8/2012 17:35:41.347'!
buildPluggableMorphsOn: aBuilder
	| window |
	window := aBuilder pluggableWindowSpec new
		model: self; 
		label: self label; 
		extent: self extent;
		children: (OrderedCollection new 		
			add: ((self buildClassesWith: aBuilder)
				frame: (0.0 @ 0.00 corner: 0.22 @ 0.775 );
				yourself);
			add: ((self buildStatusWith: aBuilder)
				frame: (0.22 @ 0.00 corner: 1.00 @ 0.04);
				yourself);
			add: ((self buildProjectStatisticWith: aBuilder)
				frame: (0.22 @ 0.946 corner: 1.00 @ 1.00);
				yourself);
			add: ((self buildButtonsWith: aBuilder)
				frame: (0.00 @ 0.775 corner: 0.22 @ 1.00);
				yourself);
			add: ((self buildTestQualityFlapWith: aBuilder)
				frame: (1.0 @ -0.0075 corner: 1.3 @ 0.5425);
				yourself);
			add: ((self buildProfilingFlapWith: aBuilder)
				frame: (1.0 @ 0.054 corner: 1.3 @ 0.554);
				yourself);
			add: ((self buildFaultLocalizationFlapWith: aBuilder)
				frame: (1.0 @ 0.115 corner: 1.3 @ 0.665);
				yourself);
			add: ((self buildInductiveAnalysisFlapWith: aBuilder)	
				frame: (1.0 @ 0.176 corner: 1.3 @ 0.676);
				yourself);											
			add: ((self buildTraceabilityFlapWith: aBuilder)
				frame: (1.0 @ 0.237 corner: 1.3 @ 0.837);
				yourself);
			add: ((self buildOptionsFlapWith: aBuilder)
				frame: (1.0 @ 0.298 corner: 1.3 @ 0.548);
				yourself);												
			yourself);
		yourself.
	self windowMorph: (aBuilder build: window).
	^ self windowMorph! !

!SPathMapTestRunner methodsFor: 'building-customs' stamp: 'mp 9/23/2010 10:36:37.463'!
buildProfilingFlapCustomMorphs
	| id options |
	id := #profiling.
	options := self pathMap options at: id.	
	self 
		addTitle: '  Profiling  ' toFlap: #profiling inFrame: (0.0 @ 0.0 corner: 1.0 @ 0.09);
		addColorLegendOn: options
			to: id 
			inFrame: (0.0 @ 0.305 corner: 1.0 @ 0.895);
		addDropDownSelectionListTo: id
			on: options
			with: {{'Method Calls'. #setKindOfProfiling:. {#numberOfMethodCalls}}.
				   {'Instances Count'. #setKindOfProfiling:. {#numberOfInstances}}.
				   {'Run-time'. #setKindOfProfiling:. {#runtime}}.
				   {'Run-time per Call'. #setKindOfProfiling:. {#runtimePerCall}}}
			inFrame: (0.0 @ 0.1 corner: 1.0 @ 0.1975).! !

!SPathMapTestRunner methodsFor: 'building-flaps' stamp: 'mp 1/20/2012 09:50:17.794'!
buildProfilingFlapWith: aBuilder
	| id |
	id := #profiling.
	^ aBuilder pluggableFlapSpec new
		name: #profiling;
		icon: SImageRepository stopwatchIconLarge;
		model: self;
		children: {(aBuilder pluggableCheckBoxSpec new
					model: (self pathMap options at: id); 
					frame: (0.0 @ 0.2 corner: 1.0 @ 0.2975);
					label: 'Profile Leafs';
					action: #switchLeafProfilingRuntime;
					state: #leafProfiling;
					enabled: #isRuntimeProfilingSelected;
					yourself).
				(aBuilder pluggableButtonSpec new
					model: (self pathMap options at: id); 
					frame: (0.0 @ 0.8975 corner: 1.0 @ 1.0);
					label: 'Highscore';
					action: #showHighscore;
					yourself ).};
		yourself! !

!SPathMapTestRunner methodsFor: 'building' stamp: 'mp 7/8/2010 18:13:25.231'!
buildProjectStatisticWith: aBuilder

	^ aBuilder pluggableInputFieldSpec new
		model: self pathMap;
		getText: #projectStatisticText;
		yourself.! !

!SPathMapTestRunner methodsFor: 'building-customs' stamp: 'mp 9/9/2011 17:11:15.757'!
buildTestQualityFlapCustomMorphs
	| id options |
	id := #testQuality.
	options := self pathMap options at: id.
	self 
		addTitle: 'Test Quality' toFlap: id inFrame: (0.0 @ 0.0 corner: 1.0 @ 0.08);
		addColorLegendOn: options
			to: id 
			inFrame: (0.0 @ 0.375 corner: 1.0 @ 0.90);
		addDropDownSelectionListTo: id
			on: options
			with: {'No Static Metric' -> #staticMetricNone. 
				   'Authors' -> #staticMetricAuthors.
				   'Last Changes' -> #staticMetricLastChanges.
				   'Lines of Code' -> #staticMetricLinesOfCode.
				   'Complexity' -> #staticMetricComplexity.
				   'Variables Access' -> #staticMetricAccessedVariables.}
			inFrame: (0.0 @ 0.28 corner: 1.0 @ 0.37)	;
		addDropDownSelectionListTo: id
			on: options
			with: {'Methods' -> #methodCoverage. 
				   'Test Intensity' -> #intensityCoverage.
				   'Statements' -> #statementCoverage.}
			inFrame: (0.0 @ 0.09 corner: 1.0 @ 0.18)	

! !

!SPathMapTestRunner methodsFor: 'building-flaps' stamp: 'mp 1/20/2012 09:54:17.244'!
buildTestQualityFlapWith: aBuilder
	| id |
	id := #testQuality.
	^ aBuilder pluggableFlapSpec new
		name: id;
		icon: SImageRepository qualityIconLarge;
		model: self;
		children: {
				(aBuilder pluggableButtonSpec new
					model: (self pathMap options at: id); 
					frame: (0.0 @ 0.185 corner: 1.0 @ 0.27);
					label: 'Sort Methods by Metric';
					action: #sortMethodsToStaticMetric;
					enabled: #sortMethodsIsEnabled;
					yourself ).
				(aBuilder pluggableCheckBoxSpec new
					model: (self pathMap options at: id); 
					frame: (0.0 @ 0.905 corner: 1.0 @ 1.0);
					label: 'Show Test Results';
					action: #switchShowTestResults;
					state: #showTestResults;
					yourself )};
		yourself! !

!SPathMapTestRunner methodsFor: 'building-customs' stamp: 'mp 2/3/2012 12:15:21.557'!
buildTraceabilityFlapCustomMorphs
	| id options |
	id := #traceability.
	options := self pathMap options at: id.
	self 
		addTitle: 'Traceability' toFlap: #traceability inFrame: (0.0 @ 0.0 corner: 1.0 @ 0.075);
		addDropDownSelectionListTo: id
			on: options
			with: (self pathMap project concerns groups keys 
					collect: [:each | {each. #setConcernGroup:. {each}}])
			inFrame: (0.0 @ 0.083 corner: 1.0 @ 0.166)
			entriesChanged: #newConcernGroups;
		addColorLegendOn: options
			to: id 
			inFrame: (0.0 @ 0.659 corner: 1.0 @ 0.825).! !

!SPathMapTestRunner methodsFor: 'building-flaps' stamp: 'mp 2/3/2012 11:20:04.155'!
buildTraceabilityFlapWith: aBuilder
	| id options |
	id := #traceability.
	options := self pathMap options at: id.
	^ aBuilder pluggableFlapSpec new
		name: #traceability;
		icon: SImageRepository traceabilityIconLarge;
		model: self;
		children: {(SPluggableMultiSelectionListSpec new
					model: options;
					name: #concernList;
					list: #allConcerns;
					itemColor: #concernColorAt:;
					getSelectionList: #selectedConcernAt:;
					setSelectionList: #selectedConcernAt:put:;
					frame: (0.0 @ 0.1725 corner: 1.0 @ 0.5575);
					yourself ).
				(aBuilder pluggableButtonSpec new
					model: options;
					frame: (0.0 @ 0.5675 corner: 1.0 @ 0.65);
					label: 'Concerns...';
					action: #chooseConcerns;
					yourself).
				(aBuilder pluggableCheckBoxSpec new
					model: options; 
					frame: (0.0 @ 0.83 corner: 1.0 @ 0.913);
					label: 'Specific Only';
					action: #switchSpecificConcernMethodsOnly;
					state: #specificConcernMethodsOnly;
					yourself ).
				(aBuilder pluggableCheckBoxSpec new
					model: options; 
					frame: (0.0 @ 0.913 corner: 1.0 @ 1.0);
					label: 'Multiple Colors';
					action: #switchMultipleColorsPerMethod;
					state: #multipleColorsPerMethod;
					yourself ).};
		yourself! !

!SPathMapTestRunner methodsFor: 'building' stamp: 'mp 9/13/2010 19:09:46.801'!
buildWith: aBuilder
	self 
		buildPluggableMorphsOn: aBuilder;
		buildCustomMorphs.
	^ self windowMorph! !

!SPathMapTestRunner methodsFor: 'accessing-ui' stamp: 'mp 3/14/2012 17:38:44.95'!
buttons
	"label action enabled"
	^ #(( 'Run Selected' #runAll #hasRunnable )
		( 'Run with Contracts' #runAllWithContracts #hasContracts )
		( 'Run Failures' #runFailures #hasFailures )
		( 'Run Errors' #runErrors #hasErrors ) )
! !

!SPathMapTestRunner methodsFor: 'accessing-ui' stamp: 'mp 3/16/2010 14:09'!
extent

	^ 650 @ 580! !

!SPathMapTestRunner methodsFor: 'utilities' stamp: 'mp 7/7/2010 16:54:06.742'!
findCategories

	| foundedCategories |
	foundedCategories := super findCategories.
	^ foundedCategories select: [:each | SProject current categories includes: each]! !

!SPathMapTestRunner methodsFor: 'utilities' stamp: 'mp 3/2/2010 17:13'!
findClassesForCategories: aCollection

	| items |
	aCollection isEmpty 
		ifTrue: [ ^ #() ].
	items := aCollection gather: [ :category |
		((Smalltalk organization listAtCategoryNamed: category)
			collect: [ :each | Smalltalk at: each ])
			select: [ :each | each includesBehavior: self baseClass ] ].
	^ items asSet.! !

!SPathMapTestRunner methodsFor: 'accessing-ui' stamp: 'mp 9/16/2010 11:50:05.225'!
getFlap: aSymbol
	^ self windowMorph paneMorphs 
		detect: [:each | each externalName asSymbol == aSymbol]! !

!SPathMapTestRunner methodsFor: 'testing' stamp: 'mp 3/14/2012 17:40:02.626'!
hasContracts
	^ self hasRunnable and: [self pathMap project hasContracts]! !

!SPathMapTestRunner methodsFor: 'initialization' stamp: 'mp 1/1/2012 15:29:46.654'!
initialize
	super initialize.
	"self suitesAt: 1 put: true. ""Select all tests"
	self pathMap: (SPMPathMap on: self).
	self addDependent: self pathMap.
	self update. "Changed doesn't work'"! !

!SPathMapTestRunner methodsFor: 'accessing-ui' stamp: 'mp 7/9/2010 09:53:13.247'!
label
	^ 'PathMap'! !

!SPathMapTestRunner methodsFor: 'user interface' stamp: 'mp 1/2/2012 14:58:06.184'!
modelWakeUp
	self pathMap isDirty
		ifTrue: [self pathMap rebuildPathMapWithSortByMetric].! !

!SPathMapTestRunner methodsFor: 'accessing' stamp: 'mp 7/8/2010 18:12:23.231'!
pathMap
	"Answer the value of pathMap"

	^ pathMap! !

!SPathMapTestRunner methodsFor: 'accessing' stamp: 'mp 7/8/2010 18:12:23.235'!
pathMap: anObject
	"Set the value of pathMap"

	pathMap := anObject! !

!SPathMapTestRunner methodsFor: 'actions' stamp: 'mp 3/17/2012 21:23:06.025'!
runAll
	| flap |
	self flag: #mpe. "Refactor the fragile code without morphic methods!!"
	flap := self windowMorph paneMorphs 
		detect: [:each | (each isKindOf: SPluggableFlapMorph) and: [each isExpanded]] 
		ifNone: [nil].
	(flap isNil or: [flap externalName asSymbol == #globalOptions])
		ifTrue: [self pathMap runAllTests]
		ifFalse: [self pathMap runAllTestsWith: flap externalName asSymbol].! !

!SPathMapTestRunner methodsFor: 'actions' stamp: 'mp 3/15/2012 14:38:32.325'!
runAllWithContracts
	| violations |
	violations := Dictionary new.
	[[self runAll] runWithContracts: self pathMap project projectName]
		on: DCContractViolation
		do: [:exception | (violations 
							at: exception methodReference
							ifAbsentPut: [Bag new]) add: exception.		
						exception resume].
	self pathMap 
		violations: violations;
		addViolations.! !

!SPathMapTestRunner methodsFor: 'actions' stamp: 'mp 7/9/2010 10:03:09.201'!
runErrors
	self halt.
	super runErrors.! !

!SPathMapTestRunner methodsFor: 'actions' stamp: 'mp 7/9/2010 10:02:47.879'!
runFailures
	self halt.
	super runFailures.! !

!SPathMapTestRunner methodsFor: 'accessing' stamp: 'mp 7/7/2010 16:54:13.111'!
selectedClasses

	^ Smalltalk allClasses select: [:aClass | 
		(SProject current categories includes: aClass category) 
		and: [(aClass inheritsFrom: TestCase) not]]! !

!SPathMapTestRunner methodsFor: 'building' stamp: 'mp 9/15/2010 17:31:24.77'!
setFrame: aRectangle in: aMorph

	| frame |
	frame := LayoutFrame new
				leftFraction: aRectangle left; 
				rightFraction: aRectangle right; 
				topFraction: aRectangle top; 
				bottomFraction: aRectangle bottom.
	aMorph layoutFrame: frame.
	aMorph hResizing: #spaceFill; vResizing: #spaceFill.! !

!SPathMapTestRunner methodsFor: 'updating' stamp: 'mp 5/27/2010 13:22'!
updateCategories
	categories := self findCategories.
	categoriesSelected := categories.
	self changed: #categoryList; changed: #categorySelected.! !

!SPathMapTestRunner methodsFor: 'accessing' stamp: 'mp 1/20/2010 15:29'!
windowMorph
	^ windowMorph! !

!SPathMapTestRunner methodsFor: 'accessing' stamp: 'mp 1/20/2010 15:29'!
windowMorph: anObject
	windowMorph := anObject! !

MwMethodWrapper subclass: #SWrapper
	instanceVariableNames: 'tracer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Tracer'!

!SWrapper class methodsFor: 'instance creation' stamp: 'mp 3/30/2011 17:16:53.857'!
canWrap: aSymbol inClass: aClass
	| selectors |
	(super canWrap: aSymbol inClass: aClass) ifFalse: [^ false].
	(aClass == SClassA) ifTrue: [^ false]. "Required for SBeforeWrapperTest"
	selectors := #( #addToCoveredMethods: #coveredMethods #coveredMethods:).
	(aClass == SPMTRCoverageTracer and: [selectors includes: aSymbol]) ifTrue: [^ false].
	((aClass == STracer) and: [aSymbol == #active]) ifTrue: [^ false].
	((aClass == SPMTRProfilingTracer) or: [aClass inheritsFrom: SPMTRProfilingTracer]) 
		ifTrue: [^ false].
	(aClass inheritsFrom: ACUserStory) ifTrue: [^ false].
	^ true! !

!SWrapper class methodsFor: 'class initialization' stamp: 'mp 7/12/2010 12:38:44.486'!
initialize
	"doIt: [self initialize]"

	super initialize.! !

!SWrapper class methodsFor: 'instance creation' stamp: 'mp 11/19/2010 16:28:44.67'!
on: aSymbol inClass: aClass with: aTracer
	| wrapper |
	wrapper := (self on: aSymbol inClass: aClass).
	wrapper ifNotNil: [wrapper tracer: aTracer].
	^ wrapper! !

!SWrapper methodsFor: 'converting' stamp: 'mp 7/12/2010 15:45:00.131'!
asMethodReference

	^ MethodReference class: self wrappedClass selector: self clientSelector! !

!SWrapper methodsFor: 'accessing' stamp: 'mp 7/12/2010 12:38:18.786'!
tracer
	"Answer the value of tracer"

	^ tracer! !

!SWrapper methodsFor: 'accessing' stamp: 'mp 7/12/2010 12:38:18.79'!
tracer: anObject
	"Set the value of tracer"

	tracer := anObject! !
SBrowser initialize!
SProject initialize!
SPathFinder initialize!
SPathView initialize!
SProjectChooser initialize!
SPathMapTestRunner initialize!
SWrapper initialize!
